#!/bin/sh

set +v # -- **************************************************************************
set +v # -- Licensed Material - Property of IBM
set +v # -- 5724-M24
set +v # -- Copyright IBM Corp. 2009.  All rights reserved.
set +v # -- US Government Users Restricted Rights - Use, duplication or
set +v # -- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
set +v # -- **************************************************************************
set +v # -- Update the portlets, migrate the preferences for instances portlet
set +v # -- **************************************************************************

scriptName=migrateSettings.sh

if [ "${4}" = "" ]; then 
	echo  ERROR: Missing 1 or more required parameter. Script is invoked as follows:
    echo  Usage: migrateSettings.sh \<WAS_HOME\> \<portal_config_url\> \<portal_admin\> \<portal_pw\> 
	echo  where for example
	echo  \<WAS_HOME\> 	/opt/IBM/WebSphere/Appserver
	echo  \<portal_config_url\> http://localhost:10040/wps/config
	echo  \<portal_admin\> wpsadmin
	echo  \<portal_pw\> yourpassword
	exit
fi

if [ "${1}" != "" ]; then WAS_HOME=$1; fi
echo `date +"%x - %X: "` $scriptName use WAS_HOME=$WAS_HOME 

if [ "${2}" != "" ]; then PORTAL_CONFIG_URL=$2; fi
echo `date +"%x - %X: "` $scriptName use PORTAL_CONFIG_URL=$PORTAL_CONFIG_URL 

if [ "${3}" != "" ]; then ADMIN_USER=$3;  fi
echo `date +"%x - %X: "` $scriptName use ADMIN_USER=$ADMIN_USER 

if [ "${4}" != "" ]; then ADMIN_PASSWORD=$4; fi
echo `date +"%x - %X: "` $scriptName use ADMIN_PASSWORD=$ADMIN_PASSWORD 

CURRENT_DIR=`pwd`
JAVA=$WAS_HOME/java/bin/java
IN_FILE=$CURRENT_DIR/ExportDefaultPage.xml
OUT_FILE=$CURRENT_DIR/Exported_Defaultpage.xml
WPS_HOME=$CURRENT_DIR/../../..
CLASSPATH_MON=$WPS_HOME/base/wp.xml.client/bin/wp.xml.client.jar:$WPS_HOME/base/wp.base/shared/app/wp.base.jar:$WAS_HOME/lib/j2ee.jar

# export default pages
$JAVA -cp $CLASSPATH_MON com.ibm.wps.xmlaccess.XmlAccess -in $IN_FILE -out $OUT_FILE -user $ADMIN_USER -pwd $ADMIN_PASSWORD -url $PORTAL_CONFIG_URL
