/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.SelectionModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.SelectionModel"] = true;
dojo.provide("com.ibm.data.SelectionModel");

dojo.declare("com.ibm.data.SelectionModel",
	null,
	{
		// treeModel: An instance of a DataTreeModel which backs this SelectionModel
		treeModel: null,
		
		// selectionPath: Array of items in the DataTreeModel which represent the current selection path.
		//		Starts at the currently selected node and goes up the tree to the root.
		selectionPath: [],
		
		constructor: function(args) {
			dojo.mixin(this, args);
			this.modelConnection = dojo.connect(this.treeModel, "onTreeChange", this, "onModelTreeChange");
		},
		
		atLevel: function(level, fromRoot) {
			return this.selectionPath[fromRoot ? this.selectionPath.length - 1 - level : level];
		},
		getPath: function() {
			return this.selectionPath.slice();
		},
		
		onModelTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
			if(oldParentItem != newParentItem 
					&& dojo.some(this.selectionPath, function(item){
						return item == childItem;
					}, this)) {
				this._calculateNewPath(this.selectionPath[0]);
				this.onSelectionPathChange(false);
			}
		},
		
		_calculateNewPath: function(lastSelected) {
			// the model is built from the top-down, so the model should already have
			// loaded all the ancestors of the lastSelected item so that model.getParent()
			// returns loaded items
			var cur = lastSelected;
			this.selectionPath.splice(0, this.selectionPath.length);
			while(cur) {
				this.selectionPath.push(cur);
				cur = this.treeModel.getParent(cur);
			}
		},
		
		onSelectionPathChange: function(/*Boolean*/ selectionChanged) {
			// summary: Event called when the selection path is updated.  This can occur when the
			//		selection model changes because the tree was restructured, changing the path
			//		from the currently selected node to the root by reparenting some nodes, or
			//		by actually changing the currently selected node in the tree.
			// selectionChanged: Boolean true if the currently selected node changed, false if the
			//		path changed but the currently selected node is the same.
		},
		
		changeSelection: function(/*item*/ newSelection) {
			// This line is commented out to allow Mashups to 
			// process the selected node after moving it using
			// the more actions menu
			//if(this.selectionPath[0] == newSelection) return;
			this._calculateNewPath(newSelection);
			this.onSelectionPathChange(true);
		}
	}
);

}
