/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.CMPocHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.CMPocHandler"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.CMPocHandler");

dojo.require("com.ibm.data.resolver.OpenSearchPocHandler");
dojo.require("com.ibm.data.resolver.ResolverQueryRules");
dojo.require("com.ibm.data.resolver.tree.TreeModeledHandler");
dojo.require("com.ibm.data.resolver.tree.PocGlobalTreeModel");
dojo.require("com.ibm.data.resolver.tree.PocLMTreeModel");

dojo.declare("com.ibm.data.resolver.CMPocHandler",
	[com.ibm.data.resolver.OpenSearchPocHandler, com.ibm.data.resolver.tree.TreeModeledHandler],
	{		
		category: "content",
		
		_globalTreeModel: null,
		
		namespaces: dojo.mixin({}, 
			com.ibm.data.resolver.OpenSearchPocHandler.prototype.namespaces,
			com.ibm.data.resolver.ResolverQueryRules.namespaces),
		
		constructor: function() {
			this.customAttributes.treeModel.get = function(item, multiValued) {
				if(!this._globalTreeModel) {
					this._globalTreeModel = new com.ibm.data.resolver.tree.PocGlobalTreeModel({
						refItem: item,
						handler: this,
						resolver: this.resolver,
						scheme: this.definition.scheme
					});
				}
				return multiValued ? [this._globalTreeModel] : this._globalTreeModel;
			};
		},
		
		_createTemplates: function() {
			var nsDecl = [];
			for(var prefix in this.namespaces) {
				nsDecl.push('xmlns:', prefix, '="', this.namespaces[prefix], '" ');
			}
			dojo.mixin(this, {
				pageTemplate: {
					templateString:
						'<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:content-page>'
										+'<model:supported-markup>html</model:supported-markup>'
										+'<model:title>'
										+'<base:nls-string xml:lang="${locale}">${title}</base:nls-string>'
										+'</model:title>'
									+'</model:content-page>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						locale: dojo.local,
						parentId: ""
					}
				},
					
				internalURLTemplate: {
					templateString:
						 '<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:content-page>'
										+'<model:supported-markup>html</model:supported-markup>'
										+'<model:title>'
										+'<base:nls-string xml:lang="${locale}">${title}</base:nls-string>'
										+'</model:title>'
									+'</model:content-page>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						locale: dojo.local,
						parentId: ""
					}
				},
				
				externalURLTemplate: {
					templateString:
						'<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:content-page>'
										+'<model:supported-markup>html</model:supported-markup>'
										+'<model:title>'
										+'<base:nls-string xml:lang="${locale}">${title}</base:nls-string>'
										+'</model:title>'
									+'</model:content-page>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						locale: dojo.local,
						parentId: ""
					}
				}
			});
		},
		
		getSaveQuery: function(/*item*/ item) {
			var q = this.inherited(arguments);
			if(this.resolver.isCreated(item)) {
				// merge updates
				// empty representation.. performance-smart
				q.rep = "empty";
			}
			else {
				q.uri = this.getValue(item, "parentId");
			}
			return q;
		},
		
		modifyNewItemArgs: function(args, parentInfo) {
			this.inherited(arguments);
			if(args.isPrivate != null) {
				if(dojo.isString(args.isPrivate)) {
					args.isPrivate = args.isPrivate.toLowerCase();
					switch(args.isPrivate) {
						case "true":
						case "yes":
							args.isPrivate = "true";
						default:
							args.isPrivate = "false";
					}
				}
				else {
					if(args.isPrivate == true) args.isPrivate = "true";
					else args.isPrivate = "false";
				}
			}
			return args;
		},
		fillInProperties: function(newItem, template, keywordArgs, parentInfo) {
			if(keywordArgs.isPrivate != null) {
				this.engine.select("./atom:content/*", newItem.data, true).attr("creationcontext:private", keywordArgs.isPrivate);
			}
			delete keywordArgs.isPrivate;
			if(keywordArgs.metadata) {
				for(var key in keywordArgs.metadata) {
					keywordArgs["metadata[" + key + "]$"] = keywordArgs.metadata[key];
				}
				delete keywordArgs.metadata;
			}
			if(keywordArgs.friendlyName) {
				keywordArgs["metadata[com.ibm.portal.friendly.name]$"] = keywordArgs.friendlyName;
				delete keywordArgs.friendlyName;
			}
			return this.inherited(arguments);
		},
		getTemplate: function(args, parentInfo) {
			switch(args.type) {
				case "internalURL": 
					return this.internalURLTemplate;
				case "externalURL": 
					return this.externalURLTemplate;
				case "page": 
				default: 
					return this.pageTemplate;
			}
		},
		instantiateTemplate: function(template, args, parentInfo) {
			var xmlDoc = this.inherited(arguments);
			if(!args.parentId) {
				// we don't want the thr:in-reply-to element in the DOM data to send, so remove it
				this.engine.select("./thr:in-reply-to", xmlDoc).destroy();
			}
			return xmlDoc;
		},
		_makeModifiable: function(item) {
			// summary: Modifies the element of this item to become modifiable
			//		for writing back to the server.  Subclasses can override this
			//		to do things like prune an item to only include necessary information
			//		for updates and nothing more.  This is called by backup once after
			//		backing up the original element first.  After this returns,
			//		this item's element may have been modified.  Any queries against
			//		this item should now include logic to check the backup copy as well
			//		if a query doesn't return anything as it could have been deleted by
			//		this function.  Care should be taken to ensure that the query result
			//		specifically detects if nothing was found or if the actual value was
			//		null or an empty string.
			this.engine.select("atom:content/*/* | thr:in-reply-to | atom:link", item.data).destroy();
			
			this.inherited(arguments);
		}
	}
);

(function(){
	
	var r = com.ibm.data.resolver;
	var atomBase = r.ResolverQueryRules.atom;
	
	var r = com.ibm.data.resolver, 
		cmPoc = r.CMPocHandler, 
		prot = cmPoc.prototype, 
		def = prot.definition,
		atomBase = r.ResolverQueryRules.atom;
	
	def = dojo.mixin({}, def, {
		scheme: "cm"
	});
	
	def.features = dojo.mixin({}, def.features, {
		"TreeModeled": true
	});
	
	prot.definition = def;
	
	dojo.extend(cmPoc, {		
		queryRules: dojo.mixin({}, r.OpenSearchPocHandler.prototype.queryRules, 
					atomBase.threadExt,
					atomBase.treeExt, 
					atomBase.uniqueNameExt, 
					atomBase.L10nExt, 
					atomBase.acExt,  
					atomBase.modelExt,
					atomBase.operationsExt, 
					atomBase.contentExt,
					atomBase.metaExt, {
			//layout: {selector: "./atom:link[@ext:rel='layout']", field: "@ext:uri", type: "Item", readOnly: true},
			//layoutId: {selector: "./atom:link[@ext:rel='layout']", field: "@ext:uri", readOnly: true},
			shareable: {selector: "./atom:content/*[model:shareable]/model:shareable", field: "$textContent"},
			bookmarkable: {selector: "./atom:content/*[model:bookmarkable]/model:bookmarkable", field: "$textContent"},
			internalRef: {selector: "./atom:link[@ext:rel='internal-url']", type: "Item", field: "@ext:uri"},
			internalRefId: {selector: "./atom:link[@ext:rel='internal-url']", field: "@ext:uri"},
			internalURL: {selector: "./atom:link[@ext:rel='internal-url']", field: "@href"},
			externalURL: {selector: "./atom:link[@ext:rel='external-url']", field: "@href"}
		}),
		customAttributes: dojo.mixin({}, r.OpenSearchPocHandler.prototype.customAttributes, {
			navigationNode: {
				get: function(item, multiValued) {
					var nmId = "nm" + this.getIdentity(item).substr(2);
					var navItem = this.resolver.byId(nmId);
					if(!this.resolver.isItemLoaded(navItem)) {
						var seedArgs = {
							id: nmId,
							title: this.getLabel(item)
						};
						var parentId = this.etValue(item, "parentId");
						if(parentId) {
							seedArgs.parentId = parentId;
						}
						
						dojo.forEach(["theme", "nextId", "nextURI", "parentId", "parentURI", "uniqueName"], function(attr){
							var val = this.getValue(item, attr);
							if(val) {
								seedArgs[attr] = val;
							}
						}, this);
						navItem = this.resolver.seedStore(seedArgs);
					}
					return multiValued ? [navItem] : navItem;
				},
				set: function(item, value, multiValued) {
					// can't write to this attribute
					return false;
				}
			},
			layoutModel: {
				get: function(item, multiValued) {
					if(!item._cachedMeta.layoutModel) {
						item._cachedMeta.layoutModel = new com.ibm.data.resolver.tree.PocLMTreeModel({
							pageId: this.getIdentity(item).substr(7),
							handler: this,
							resolver: this.resolver
						});
					}
					return multiValued ? [item._cachedMeta.layoutModel] : item._cachedMeta.layoutModel;
				},
				set: function(item, value, multiValued) {
					// can't write to this attribute
					return false;
				}
			}
		})
	});
	
	var modelSpecificSetter = function(nodeName, data, rule, value){
		this.select("./atom:content/*", data, true).createFromJson({
			name: nodeName,
			children: [value]
		});
		return true;
	};
	
	prot.queryRules.shareable = dojo.partial(modelSpecificSetter, "model:shareable");
	prot.queryRules.bookmarkable = dojo.partial(modelSpecificSetter, "model:bookmarkable");
	
	com.ibm.strategy.Strategy.applyStrategy(cmPoc, new com.ibm.data.resolver.tree.AtomModelTreeStrategy());
	
	com.ibm.data.Resolver.register(def.scheme, cmPoc);
})();


}
