/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.PMPocHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.PMPocHandler"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.PMPocHandler");

dojo.require("com.ibm.data.resolver.OpenSearchPocHandler");
dojo.require("com.ibm.data.resolver.ResolverQueryRules");

dojo.declare("com.ibm.data.resolver.PMPocHandler",
	com.ibm.data.resolver.OpenSearchPocHandler,
	{
		category: "content",
		
		namespaces: dojo.mixin({}, 
			com.ibm.data.resolver.OpenSearchPocHandler.prototype.namespaces,
			com.ibm.data.resolver.ResolverQueryRules.namespaces),

		_createTemplates: function() {
			var nsDecl = [];
			for(var prefix in this.namespaces) {
				nsDecl.push('xmlns:', prefix, '="', this.namespaces[prefix], '" ');
			}
			dojo.mixin(this, {
				entityTemplate: {
					templateString: 
						 '<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:portlet-entity/>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						parentId: ""
					}
				},
							
				definitionTemplate: {
					templateString: 
						 '<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:summary>${summary}</atom:summary>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:portlet-definition/>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						summary: "",
						parentId: ""
					}
				},
				
				portletTemplate: {
					templateString:
						 '<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:portlet/>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						parentId: ""
					}
				}
			});
		},
		
		getTemplate: function(args, parentInfo) {
			switch(args.type) {
				case "portlet": 
					return this.portletTemplate;
				case "portlet-definition": 
					return this.definitionTemplate;
				case "portlet-entity": 
				default: 
					return this.entityTemplate;
			}
		},
		getSaveQuery: function(/*item*/ item) {
			var q = this.inherited(arguments);
			if(this.resolver.isCreated(item)) {
				// merge updates
				// empty representation.. performance-smart
				q.rep = "empty";
			}
			else {
				q.uri = this.getValue(item, "parentId");
			}
			
			switch(this.getValue(item, "modelNodeType", "")) {
				// portlet-entity and portlet-definition items should save in "replace" mode instead of "merge" mode
				// so that preferences are replaced correctly
				case "portlet-definition":
				case "portlet-entity":
					q.mode = "replace";
				default:
			}
			
			return q;
		},
		
		_makeModifiable: function(item) {
			// summary: Modifies the element of this item to become modifiable
			//		for writing back to the server.  Subclasses can override this
			//		to do things like prune an item to only include necessary information
			//		for updates and nothing more.  This is called by backup once after
			//		backing up the original element first.  After this returns,
			//		this item's element may have been modified.  Any queries against
			//		this item should now include logic to check the backup copy as well
			//		if a query doesn't return anything as it could have been deleted by
			//		this function.  Care should be taken to ensure that the query result
			//		specifically detects if nothing was found or if the actual value was
			//		null or an empty string.			
			this.inherited(arguments);
		}
	}
);

(function(){
	var r = com.ibm.data.resolver, 
		pmPoc = r.PMPocHandler, 
		prot = pmPoc.prototype, 
		def = prot.definition,
		atomBase = r.ResolverQueryRules.atom;
	
	def = dojo.mixin({}, def, {
		scheme: "pm"
	});
	
	prot.definition = def;
	
	// relationship model:
	//		portlet-window -> [private portlet-entity ->] shared portlet-entity -> 
	// 		portlet-definition -> portlet -> web-application
	// 
	// private portlet-entity is not there by default but can be created as a child
	// of the shared portlet-entity
	
	dojo.extend(pmPoc, {		
		queryRules: dojo.mixin({}, r.OpenSearchPocHandler.prototype.queryRules, 
				atomBase.threadExt,
				atomBase.uniqueNameExt, 
				atomBase.L10nExt,  
				atomBase.modelExt, {
			initParameters: {selector: "./atom:content/model:portlet/model:initparameters", field: "$textContent", readOnly: true},
			supportedModes: {selector: "./atom:content/model:portlet/model:supports/model:portlet-mode", field: "$textContent", readOnly: true},
			supportedMarkups: {selector: "./atom:content/model:portlet/model:supports/model:mime-type", field: "$textContent", readOnly: true},
			contextRoot: {selector: "./atom:content/model:web-application/model:context-root", field: "$textContent", readOnly: true},
			
			// the most common attribute for this store, provides read/write operations for portlet preferences on items
			// that support it
			preferenceValue$: {selector: "./atom:content/*[model:portletpreferences]/model:portletpreferences[@name='${0}']/base:value", field: "@value", key: "${0}", deferSet: true, setter: 
				function(data, rule, value, multiValued) {
					var valueDef = {
						name: "base:value",
						attributes: {
							"xsi:type": "base:String"
						}
					};
					
					var modelNode = this.select("./atom:content/*", data, true);
					var type = modelNode.prop("localName")[0];
					// only create preferences on portlet-entity and portlet-definition items
					if(type != "portlet-entity" && type != "portlet-definition") return false;
					
					var prefNode = modelNode.select("model:portletpreferences[@name='" + rule.key + "']", true);
					if(prefNode.length == 0) {
						modelNode.createFromJson({
							name: "model:portletpreferences",
							attributes: {
								"name": rule.key,
								"read-only": "false"
							}
						});
						prefNode = modelNode.select("model:portletpreferences[@name='" + rule.key + "']", true);
					}
					else {
						if(prefNode.attr("read-only")[0] == "true") {
							throw new Error(this.resolver.fmt("errorReadOnlyPrefs", [rule.key]));
						}
					}
					
					prefNode.select("*").destroy();	// clear existing values
					if(!multiValued) {
						value = [value];
					}
					
					dojo.forEach(value, function(singleValue){
						valueDef.attributes.value = singleValue;
						prefNode.createFromJson(valueDef);
					}, this);
					
					return true;
				}
			},
			preferenceReadOnly$: {selector: "./atom:content/*[model:portletpreferences]/model:portletpreferences[name=${0}]", field: "@read-only", key: "${0}", readOnly: true}
			
			// provide a read-only construct for easily accessing all the portlet preferences on the current item
			//,preferences: {selector: "./atom:content/*[model:portletpreferences]/model:portletpreferences", field: "PortletPreferenceConstruct", type: "Node", readOnly: true}
		}),
		
		customAttributes: dojo.mixin({}, prot.customAttributes, {
			portletWindowChain: {
				get: function(item, multiValued) {
					if(this.getValue(item, "modelNodeType", "portlet-window") != "portlet-window") return;
					return new com.ibm.data.resolver.PMWindowChain({
						store: this.resolver,
						windowId: this.getIdentity(item)
					});
				},
				set: function(item, value, multiValued) {
					// can't write to this attribute as it is a composite object derived from others
					return false;
				}
			}
		})
	});
	
	com.ibm.data.Resolver.register(def.scheme, pmPoc);	
})();

dojo.declare("com.ibm.data.resolver.PMWindowChain",
	com.ibm.data.ItemsLoader,
	{
		windowId: "",
		constructor: function() {
			this.query = {
				uri: this.windowId,
				levels: "-all"
			};
		},
		filter: function(items) {
			if(!items.pw) {	// only if not filtered yet
				var store = this.store;
				items = dojo.mixin(items, {
					getWindow: function() {
						return this.pw;
					},
					getPrivateEntity: function() {
						return this.ppe;
					},
					getSharedEntity: function() {
						return this.spe;
					},
					getDefinition: function() {
						return this.pd;
					},
					getPortlet: function() {
						return this.p;
					},
					getApplication: function() {
						return this.wa;
					},
					createPrivateEntity: function() {
						// summary: TODO
					},
					getPreferences: function(/*String?*/ layer) {
						// summary: Gets the preferences object for a PMPOD, which is rooted at a Window object.
						//		Allows getting preferences on various layers via the optional layer argument.
						// layer: String indicating which layer to set the preference value on.  Supports the following layers:
						//	 		"Config" - Refers to administrator preferences from Config mode
						// 			"Shared" - Refers to default shared preferences from Edit Defaults mode 
						// 			"Private" - Refers to personalized preferences from Edit, View, or Help modes.
						//		The default layer, if one isn't provided, is set to "Private" if a private entity exists.  Otherwise
						//		it's set to "Shared".
						var ppe = this.getPrivateEntity();
						if(!layer) {
							if(!ppe) layer = "Shared";
							else layer = "Private";
						}
						var item = null;
						switch(layer) {
							case "Private":
								item = ppe;
								break;
							case "Shared":
								item = this.getSharedEntity();
								break;
							case "Config":
								item = this.getDefinition();
								break;
							default: 
								item = ppe ? ppe : this.getSharedEntity();
						}
						return new com.ibm.data.resolver.PMPreferences({
							item: item,
							root: item.data,
							layer: layer,
							dataStore: store
						});
					}
				});
				var copy = items.slice();
				items.pw = copy.shift();
				items.spe = copy.shift();
				if(store.getValue(items[0], "modelNodeType") == "portlet-entity") {
					items.ppe = this._items.spe;
					items.spe = copy.shift();
				}
				items.pd = copy.shift();
				items.p = copy.shift();
				items.wa = copy.shift();
			}
			return items;
		}
	}
);

dojo.declare("com.ibm.data.resolver.PMPreferences",
	com.ibm.xml.SimpleXmlAccessor,
	{
		namespaces: com.ibm.data.resolver.ResolverQueryRules.namespaces,
		dataStore: null,
		
		constructor: function(args) {
			dojo.mixin(this, args);
		},
		getMap: function() {
			if(!this._map) {
				this._map = {};
				var prefs = this.select("./model:portletpreferences", this.root);
				if(prefs && prefs.length > 0) {
					dojo.forEach(prefs, function(prefNode){
						var name = this.attr(prefNode, "name"); 
						this._map[name] = {
							"readonly": this.attr(prefNode, "read-only"),
							"values": dojo.map(this.select("./base:value", prefNode), function(valueNode){
								return this.attr(valueNode, "value");
							}, this)
						};
					}, this);
				}
			}
			return this._map;
		},
		getNames: function() {
			var map = this.getMap();
			var names = [];
			for(var name in map) {
				names.push(name);
			}
			return names;
		},
		_getPrefNode: function(/*String*/ key) {
			if(!key) {
				throw new Error(this.dataStore.fmt("errorNullPrefsKey"));
			}
			var prefNode = this.select("./model:portletpreferences[name='" + key + "']", this.root);
			if(prefNode && prefNode.length > 0) return prefNode[0];
			return null;
		},
		isReadOnly: function(/*String*/ key) {
			var prefNode = this._getPrefNode(key);
			return prefNode && prefNode.length > 0 ? this.attr(prefNode, "read-only") == "true" : false;
		},
		reset: function(/*String*/ key) {
			var prefNode = this._getPrefNode(key);
			if(prefNode) {
				prefNode.parentNode.removeChild(prefNode);
				prefNode = null;
			}
		},
		store: function(args) {
			// summary: Store changes made to these preferences back to the server
			// args: Object specifying callbacks to be called on server response, supporting these properties:
			//		onComplete: Function called with zero arguments indicating success
			//		onError: Function called with one error object argument
			//		scope: Object scope to call the callbacks in, defaulting to the global scope
			this.dataStore.saveItems([this.item], args);
		},
		getValue: function(/*String*/ key, /*String*/ defaultValue) {
			return this.dataStore.getValue(this.item, "preferenceValue[" + key + "]$", defaultValue);
		},
		getValues: function(/*String*/ key, /*String[]*/ defaultValues) {
			return this.dataStore.getValues(this.item, "preferenceValue[" + key + "]$", defaultValues);
		},
		setValue: function(/*String*/ key, /*String*/ value) {
			this.setValues(key, [value]);
		},
		setValues: function(/*String*/ key, /*String[]*/ values) {
			if(values === undefined) values = [];
			this.dataStore.setValues(this.item, "preferenceValue[" + key + "]$", values);
			if(this._map) {
				// update the map
				if(this._map[key]) {
					this._map[key].values = values.slice();
				}
				else {
					this._map[key] = {
						"readonly": false,
						"values": values.slice()
					}
				}
			}
		}
	}
);


}
