/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.strategy.AspectsStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.strategy.AspectsStrategy"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.strategy.AspectsStrategy");

dojo.require("com.ibm.data.resolver.strategy.PocHandlerStrategy");

dojo.declare("com.ibm.data.resolver.strategy.AspectsStrategy",
	com.ibm.data.resolver.strategy.PocHandlerStrategy,
	{
		// summary: Advises a POC handler to modify all fetch queries
		//		targeted at the server-side handler registered at the
		//		same scheme with additional aspect parameters for
		//		requesting aspects for the fetched resources in addition
		// 		to whatever default aspects are returned from the request.
		//		It specifically uses the "aspect" query parameter.
		//		The constructor for this module takes a single argument
		//		array of strings, indicating all the aspects to be requested.
		
		extensions: ["modifyFetchQuery"],
		
		constructor: function(/*Array*/ aspects) {
			this._aspects = aspects || [];
		},
		
		modifyFetchQuery: function(query) {
			if(!query.aspect) query.aspect = [];
			query.aspect = query.aspect.concat(this._aspects);
			return this.proceed(arguments);
		}
	}
);

}
