/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.data.PortletModelStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.data.PortletModelStore"] = true;
dojo.provide( "com.ibm.portal.data.PortletModelStore" );

dojo.require( "com.ibm.portal.data._PortalModelStore" );

dojo.declare( "com.ibm.portal.data.PortletModelStore",
			com.ibm.portal.data._PortalModelStore, 
			{
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.portal.data.PortletModelItem",
				
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.portal.data.PortletModelStore
					// args: Map
					this._features['dojo.data.api.Write'] = true;	// adding Write support for this implementation
					this._features['dojo.data.api.Notification'] = true; // adding Notification support for this implementation
					
					// URL basic format - /wps/[my]contenthandler[/vpmapping]?(uri=model-uri)+(&mode=verb)?(&name=value)*
				},
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					switch(prop) {
						case "PortletPreferenceConstruct": return new com.ibm.portal.data.PortletPreferenceConstruct(node);
						default: return this.inherited(arguments);
					}
				},
				
				/********************************/
				/**                            **/
				/**    Extensions used by      **/
				/**    functions implementing  **/
				/**    dojo.data.api.Write     **/
				/**                            **/
				/**                            **/
				/********************************/
				_getTemplate: function(args, parentInfo) {
					switch(args.type) {
						case "portlet-entity": 
							return this.entityTemplate;
						case "portlet": 
							return this.portletTemplate;
						case "portlet-definition": 
							return this.definitionTemplate;
						default: 
							return this.entityTemplate;
					}
				},
				_getCreateUri: function(args, parentInfo) {
					return args.parent;
				}
			}
);

(function(){
	var namespaces = com.ibm.portal.data.PortletModelStore.prototype.namespaces;
	var nsDecl = new Array();
	
	for(var prefix in namespaces) {
		nsDecl.push('xmlns:', prefix, '="', namespaces[prefix], '" ');
	}
	
	// relationship model:
	//		portlet-window -> [private portlet-entity ->] shared portlet-entity -> 
	// 		portlet-definition -> portlet -> web-application
	// 
	// private portlet-entity is not there by default but can be created as a child
	// of the shared portlet-entity
	
	dojo.extend(com.ibm.portal.data.PortletModelStore, {
		entityTemplate: 	['<?xml version="1.0" encoding="UTF-8"?>',
					'<atom:feed ',
						nsDecl.join(''),
						'>',
						'<atom:author>',
							'<atom:name>IBM WebSphere Portal/6.1</atom:name>',
						'</atom:author>',
						'<atom:title>IBM WebSphere Portal Model Feed</atom:title>',
						'<atom:link href="." rel="self" type="application/atom+xml"/>',
						'<atom:entry>',
							'<atom:title></atom:title>',
							'<atom:id></atom:id>',
							'<atom:content type="application/xml">',
								'<model:portlet-entity/>',
							'</atom:content>',
							'<thr:in-reply-to portal:uri="${parent}" href="${parent}" ref="${parent}" type="application/atom+xml"/>',
						'</atom:entry>',
					'</atom:feed>'].join('')
	});
	
	dojo.extend(com.ibm.portal.data.PortletModelStore, {
		definitionTemplate: 	['<?xml version="1.0" encoding="UTF-8"?>',
					'<atom:feed ',
						nsDecl.join(''),
						'>',
						'<atom:author>',
							'<atom:name>IBM WebSphere Portal/6.1</atom:name>',
						'</atom:author>',
						'<atom:title>IBM WebSphere Portal Model Feed</atom:title>',
						'<atom:link href="." rel="self" type="application/atom+xml"/>',
						'<atom:entry>',
							'<atom:title>${title}</atom:title>',
							'<atom:summary>${summary}</atom:summary>',
							'<atom:id></atom:id>',
							'<atom:content type="application/xml">',
								'<model:portlet-definition/>',
							'</atom:content>',
							'<thr:in-reply-to portal:uri="${parent}" href="${parent}" ref="${parent}" type="application/atom+xml"/>',
						'</atom:entry>',
					'</atom:feed>'].join('')
	});
	
	dojo.extend(com.ibm.portal.data.PortletModelStore, {
		portletTemplate: 	['<?xml version="1.0" encoding="UTF-8"?>',
					'<atom:feed ',
						nsDecl.join(''),
						'>',
						'<atom:author>',
							'<atom:name>IBM WebSphere Portal/6.1</atom:name>',
						'</atom:author>',
						'<atom:title>IBM WebSphere Portal Model Feed</atom:title>',
						'<atom:link href="." rel="self" type="application/atom+xml"/>',
						'<atom:entry>',
							'<atom:title>${title}</atom:title>',
							'<atom:id></atom:id>',
							'<atom:content type="application/xml">',
								'<model:portlet/>',
							'</atom:content>',
							'<thr:in-reply-to portal:uri="${parent}" href="${parent}" ref="${parent}" type="application/atom+xml"/>',
						'</atom:entry>',
					'</atom:feed>'].join('')
	});

})();


dojo.declare( "com.ibm.portal.data.PortletModelItem",
			com.ibm.portal.data._PortalModelItem,
			{
				// summary: Helper class used to extend attrMappings for additional attributes provided by
				// 		portlet model items
				attrMappings: dojo.mixin({}, com.ibm.portal.data._PortalModelItem.prototype.attrMappings, {
					initParameters: {xpath: "./atom:content/model:portlet/model:initparameters", targetName: "textContent", type: "node"},
					supportedModes: {xpath: "./atom:content/model:portlet/model:supports/model:portlet-mode", targetName: "textContent", type: "node"},
					supportedMarkups: {xpath: "./atom:content/model:portlet/model:supports/model:mime-type", targetName: "textContent", type: "node"},
					contextRoot: {xpath: "./atom:content/model:web-application/model:context-root", targetName: "textContent", type: "node"},
					modelType: {xpath: "./atom:content/*", targetName: dojo.isIE ? "baseName" : "localName", type: "node"},
					
					// the most common attribute for this store, provides read/write operations for portlet preferences on items
					// that support it
					preferenceValue$: {xpath: "./atom:content/*[model:portletpreferences]/model:portletpreferences[name=${0}]", targetName: "PortletPreferenceConstruct", type: "node", key: "${0}", setter: 
						function(item, rule, value) {
							var result = this._getNodeByXpath(item.element, "./atom:content/*");
							if(!result.found) return false;
							var modelNode = result.value;
							var type = this._getNodeProp(modelNode, dojo.isIE ? "baseName" : "localName");
							// only create preferences on portlet-entity and portlet-definition items
							if(type != "portlet-entity" && type != "portlet-definition") return false;
							var prefsNode = this._createNSElement(item.element.ownerDocument, "model:portletpreferences",
								{
									"name": rule.key,
									"read-only": false
								});
							modelNode.appendChild(prefsNode);
							if(rule.multiValued) {
								dojo.forEach(value, function(singleValue){
									prefsNode.appendChild(this._createNSElement(item.element.ownerDocument, "base:value",
										{
											"xsi:type": "base:String",
											"value": singleValue
										}
									));
								}, this);
							}
							else {
								prefsNode.appendChild(this._createNSElement(item.element.ownerDocument, "base:value",
									{
										"xsi:type": "base:String",
										"value": value
									}
								));
							}
							return true;
						}
					},
					preferenceReadOnly$: {xpath: "./atom:content/*[model:portletpreferences]/model:portletpreferences[name=${0}]", targetName: "read-only", type: "attr", key: "${0}"},
					
					// provide a read-only construct for easily accessing all the portlet preferences on the current item
					preferences: {xpath: "./atom:content/*[model:portletpreferences]/model:portletpreferences", targetName: "PortletPreferenceConstruct", type: "node"}
				}),
				_makeModifiable: function() {
					// summary: Modifies the element of this item to become modifiable
					//		for writing back to the server.  Subclasses can override this
					//		to do things like prune an item to only include necessary information
					//		for updates and nothing more.  This is called by backup once after
					//		backing up the original element first.  After this returns,
					//		this item's element may have been modified.  Any queries against
					//		this item should now include logic to check the backup copy as well
					//		if a query doesn't return anything as it could have been deleted by
					//		this function.  Care should be taken to ensure that the query result
					//		specifically detects if nothing was found or if the actual value was
					//		null or empty.
					var node = this._getNodeByXpath(this.element, "./atom:content/*").value;
					if(node) {
						while(node.childNodes.length > 0) {
							node.removeChild(node.childNodes[0]);
						}
					}
					
					var toRemove = ["./atom:link"];
					dojo.forEach(toRemove, function(expr){
						var nodes = this._getNodesByXpath(this.element, expr).value;
						dojo.forEach(nodes, function(node){
							node.parentNode.removeChild(node);
						}, this);
					}, this);
					
					this.inherited(arguments);
				}
			}
);

dojo.declare( "com.ibm.portal.data.PortletPreferenceConstruct",
			com.ibm.data._XmlConstruct,
			{
				namespaces: dojo.mixin({}, com.ibm.portal.data.PortletModelStore.prototype.namespaces),
				
		        constructor: function(node) {
		        	this.root = node;
		        },
		        getName: function() {
		        	return this._getAttribute(this.root, "name");
		        },
		        isReadOnly: function() {
		        	return this._getAttribute(this.root, "read-only") == "true";
		        },
		        getValue: function() {
		        	return this._getAttrByXpath(this.root, "./base:value", "value").value;
		        },
		        getValues: function() {
		        	return this._getAttrsByXpath(this.root, "./base:value", "value").value;
		        },
		        toString: function() {
		        	return "<" + this.__getClassName() + " name='" + this.getName() + "'>"
		        }
			}
);

}
