/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.dnd.PortletSourceGhost"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.dnd.PortletSourceGhost"] = true;
dojo.provide("com.ibm.portal.dnd.PortletSourceGhost");

dojo.require("com.ibm.dnd.CustomManagerSource");
dojo.require("com.ibm.portal.dnd.PortletAvatar");

dojo.declare("com.ibm.portal.dnd.PortletSourceGhost", com.ibm.dnd.CustomManagerSource, {
	managerOverrides: {
		OFFSET_X: 1,
		OFFSET_Y: 1,
		makeAvatar: function(){
			return new com.ibm.portal.dnd.PortletAvatar(this);
		}
	},
	copyState: function(){
		return false;
	},
	onOverEvent: function(){
		// create ghost in empty container
		com.ibm.portal.dnd.PortletSourceGhost.superclass.onOverEvent.call(this);

		if(com.ibm.portal.dnd.PORTLET_MEDIATOR.isDragging && dojo.dnd.manager().target){
			var currentContainer = dojo.dnd.manager().target.node;	
			var portlets = dojo.query('.'+com.ibm.portal.dnd.PORTLET_MEDIATOR.portletContainerClass, currentContainer);	
			// check to see if layout container is empty
			if(portlets.length == 0){			
				com.ibm.portal.dnd.PORTLET_MEDIATOR.emptyContainer = currentContainer;
				if(dojo.query("."+com.ibm.portal.dnd.PORTLET_MEDIATOR.ghostClass).length == 0 ){
					// creating ghosts in empty layout container
					com.ibm.portal.dnd.PORTLET_MEDIATOR.emptyContainer.appendChild(com.ibm.portal.dnd.PORTLET_MEDIATOR.createEmptyContainerGhostMarkup(com.ibm.portal.dnd.PORTLET_MEDIATOR.ghostHeight, currentContainer.offsetWidth));
				}
			}else{
			// clear the empty layout container object
				com.ibm.portal.dnd.PORTLET_MEDIATOR.emptyContainer = null;			
			}
		}
	},
	onOutEvent: function(){
		// remove ghost from empty container
		com.ibm.portal.dnd.PortletSourceGhost.superclass.onOutEvent.call(this);
		if(dojo.query("."+com.ibm.portal.dnd.PORTLET_MEDIATOR.ghostClass).length > 0){
			com.ibm.portal.dnd.PORTLET_MEDIATOR.removeGhost();
		}
	},
	_addItemClass: function(node, type){
		// summary: adds a class with prefix "dojoDndItem" and create ghost
		// node: Node: a node
		// type: String: a variable suffix for a class name
		if(com.ibm.portal.dnd.PORTLET_MEDIATOR.isDragging){
			com.ibm.portal.dnd.PORTLET_MEDIATOR.currentTarget = node;
			com.ibm.portal.dnd.PORTLET_MEDIATOR.createGhost(node, type);
		}
	},
	_removeItemClass: function(node, type){
		// summary: removes a class with prefix "dojoDndItem" and remove ghost
		// node: Node: a node
		// type: String: a variable suffix for a class name
		if(com.ibm.portal.dnd.PORTLET_MEDIATOR.isDragging){
			com.ibm.portal.dnd.PORTLET_MEDIATOR.removeGhost();
		}
	}
});

}
