/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.services.PortletFragmentService"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.services.PortletFragmentService"] = true;
dojo.provide( "com.ibm.portal.services.PortletFragmentService" );

dojo.require( "dojox.data.dom" );

dojo.require( "com.ibm.portal.services.PortalRestServiceRequest" );
dojo.require( "com.ibm.portal.utilities" );
dojo.require( "com.ibm.portal.debug" );
dojo.require( "com.ibm.portal.EventBroker" );

dojo.declare( "com.ibm.portal.services.PortletFragmentURL",
			  null,
			  {
			  	constructor: function ( /*String*/uri ) {
				  	if ( uri.indexOf( "?uri=" ) == 0 ) {
						this.url = ibmPortalConfig["portalURI"] + uri;
						this.url = this.url.replace(/&amp;/g,"&" );
						this.url = this.url.replace( /lm:/, "pm:" );
					}
					else if ( uri.indexOf( "lm:" ) == 0 ) {
						this.url = ibmPortalConfig["portalURI"] + "?uri=fragment:" + uri;
						this.url = this.url.replace( /lm:/, "pm:" );
					}
					else {
						this.url = uri;
					}
				  }
			  }
);

dojo.declare( "com.ibm.portal.services.PortletInfo",
			  null,
			  {
				constructor: function( /*String*/wId, /*String*/pId, /*String*/pMarkup, /*Array*/pModes, /*Array*/wStates, /*Array*/depPortlets, /*Array*/otherPortlets, /*XMLDocument*/stateDOM, /*Array*/ stateVaryExpr, /*PortletMode*/ portletMode, /* WindowState */ windowState ) {
					ibm.portal.debug.entry( "PortletInfo.constructor", [ wId, pId, pMarkup, pModes, wStates, depPortlets, stateDOM ]);
					
					this.windowId = wId;
					this.portletId = pId;
					this.uri = "fragment:pm:oid:" + wId + "@oid:" + pId;
					this.markup = pMarkup;
					this.portletModes = pModes;
					this.windowStates = wStates;
					this.dependentPortlets = depPortlets;
					this.otherPortlets = otherPortlets;
					this.stateVaryExpressions = stateVaryExpr;
					this.updatedState = stateDOM;
					this.currentMode = portletMode;
					this.currentWindowState = windowState;
					
					ibm.portal.debug.exit( "PortletInfo.constructor" );
			    }
			  }
);

dojo.declare( "com.ibm.portal.services.PortletFragmentService",
			  null,
			  {
			  	namespaces: {
		            "xsl" : "http://www.w3.org/1999/XSL/Transform",
		            "thr" : "http://purl.org/syndication/thread/1.0",
		            "atom" : "http://www.w3.org/2005/Atom",
		            "xhtml" : "http://www.w3.org/1999/xhtml",
		            "model" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements",
		            "base" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0/ibm-portal-composite-base",
		            "portal" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model",
		            "xsi" : "http://www.w3.org/2001/XMLSchema-instance",
				"state" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.1/portal-state",
				"state-vary" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.1/portal-state-vary"
		        },
				_flagPortletUrl: function ( /*String*/ url, /*String*/ portletId ) {
					ibm.portal.debug.entry( "PortletFragmentService._flagPortletUrl", [ url ] );
					
					// Check to see if the uri parameter is already included in url
					var uriIncluded = url.indexOf("uri=fragment:pm:oid:");

					//Create the url and add the necessary parameters.
					var urlObj = new com.ibm.portal.utilities.HttpUrl( url );
					urlObj.addParameter( "ibm.web2.keepRenderMode", "false" );
					
					// If uriIncluded is -1, then add the uri as a parameter
					if(uriIncluded < 0 ){
						//Convert the portlet id to a fragment id.
						portletId = portletId.replace( /lm:/g, "fragment:pm:" );
						urlObj.addParameter( "uri", portletId );
					}
					
					ibm.portal.debug.exit( "PortletFragmentService._flagPortletUrl", [ urlObj.toString() ]);
					return urlObj.toString();
				},
				getPortletInfo: function ( /*String*/portletId, /*String*/ portletUrl, /*Function?*/ callbackFn, /*PortalRestServiceForm?*/form, /*Boolean?*/stateless ) {
					// summary: Retrieves the PortletInfo for the given portlet url.
					// description: Sends a request for the given portlet information, including markup for the current navigational state. If the request does not
					//		complete successfully, a null object will be returned or passed into the callback function. 
					// portletUrl: a portlet URL, should come directly from the Portlet Fragment Feed or be created using the
					//		NavigationalState.newPortletRenderURL() function.
					// callbackFn: OPTIONAL - a callback function to be called when the portlet info is retrieved. the first parameter is the portlet info object
					//		or NULL if an error occurred and the second parameter is the XMLHttpRequest object used to make the request.
					// formNode: OPTIONAL - the form to submit as part of the request OR the query string produced by a "serialized" form
					// formFilter: OPTIONAL - the form filter for elements to encode (see dojo documentation)
					// stateless: OPTIONAL - indicates that this request should not affect the state of the portlet. Setting this to
					//		true cancels the topic publishing for this request only. 
					ibm.portal.debug.entry( "PortletFragmentService.getPortletInfo", [portletId, portletUrl, callbackFn, form, stateless ] );
					
					//Two cases where we don't want this request to continue:
					//1. The url is a hash mark (frequenty used for simply firing onclick events).
					//2. The url is a javascript: url. Usually this would have been discovered by now, but in the off chance
					//		that it isn't, we just want to eval it and return. 
					if ( portletUrl == "#" || portletUrl == window.location.href + "#" ) {
						ibm.portal.debug.text( "Illegal portlet url provided: " + portletUrl );
						ibm.portal.debug.text( "Aborting request." );
						return false;
					}
					
					if ( com.ibm.portal.utilities.isJavascriptUrl( portletUrl )) {
						return eval( portletUrl );
					}
					
					// if the URL is relative (e.g. "?fragment:pm:oid:..."), we need to resolve it
					var tempUrl = portletUrl;
					if(tempUrl.indexOf(top.location.href) == 0) {
						// here we're checking to see if the URL is actually the same as our current
						// url... we then trim that down and see what it really points to, like if it's
						// a relative URL in disguise 
						tempUrl = tempUrl.substring(top.location.href.length);
						while(tempUrl.length > 0 && tempUrl.charAt(0) == "/") {
							tempUrl = tempUrl.substring(1);
						}
					}
					if (tempUrl.indexOf('?') == 0) {
						var state = com.ibm.portal.navigation.controller.NAVIGATION_CONTROLLER.getState();
						portletUrl = state.resolveRelativePortletURL(tempUrl);
					}

					if ( com.ibm.portal.utilities.isExternalUrl( portletUrl ) ) {
						self.location.href = portletUrl;	
					}
					else{
						var url = { url: this._flagPortletUrl( portletUrl, portletId ) }
						var serviceReq = new com.ibm.portal.services.PortalRestServiceRequest( url, form );
						if ( !stateless ) {
							com.ibm.portal.EVENT_BROKER.startFragment.fire( { id: portletId } );
						}
						var me = this;
						serviceReq.read(
							function ( /*String*/type, /*XMLDocument*/xmlData, /*XMLHttpRequest*/xhr ) {
								var pInfo = null;
								if ( type == "load" ) {
									pInfo = me.createPortletInfo( xmlData );
								}
								
								if ( xmlData instanceof Error ) {
									pInfo = xmlData;
								}
								
								if ( !stateless ) {
									me._fireEvents( pInfo, portletId, xhr );
								}
								
								if ( callbackFn ) {
									callbackFn( pInfo, xhr );
								}
							}	
						);
					}

					ibm.portal.debug.exit( "PortletFragmentService.getPortletInfo" );	
				},
				readWindowID: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readWindowID", [xmlData] );
					
					var windowIdXPath = "/atom:feed/atom:entry/atom:id";
					var nodes = com.ibm.portal.xpath.evaluateXPath( windowIdXPath, xmlData, this.namespaces );
					var windowId = dojox.data.dom.textContent( nodes[0] );
					
					ibm.portal.debug.exit( "PortletFragmentService.readWindowID", [windowId.substring(4)]);		
					return windowId.substring(4);	
				},
				readPortletID: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readPortletID", [xmlData] );
					
					var portletIdXPath = "/atom:feed/atom:id";
					var nodes = com.ibm.portal.xpath.evaluateXPath( portletIdXPath, xmlData, this.namespaces );
					var portletId = dojox.data.dom.textContent( nodes[0] );
					
					ibm.portal.debug.exit( "PortletFragmentService.readPortletID", [portletId.substring(4)]);
					return portletId.substring(4);
				},
				readMarkup: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readMarkup", [xmlData] );
					var contentsXPath = "/atom:feed/atom:entry/atom:content";
					var nodes = com.ibm.portal.xpath.evaluateXPath(contentsXPath, xmlData, this.namespaces);
					var markup = "";
					
					if (nodes != null && nodes.length > 0) {
			            markup = dojox.data.dom.textContent( nodes[0] );
			        }
					
					ibm.portal.debug.exit( "PortletFragmentService.readMarkup", [markup]);
					return markup;
				},
				readPortletModes: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readPortletModes", [xmlData] );
					var modesXPath = "/atom:feed/atom:entry/atom:link[@portal:rel='portlet-mode']";
					var nodes = com.ibm.portal.xpath.evaluateXPath(modesXPath, xmlData, this.namespaces);
					var modes = new Array();
					
					if (nodes != null && nodes.length > 0) {
			        	var nodeCount = nodes.length;
			            for (var i = 0; i < nodeCount; i++) {
							modes.push( { "link": nodes[i].getAttribute("href"), "mode": nodes[i].getAttribute("title") } );
			            }
			        }
					ibm.portal.debug.exit( "PortletFragmentService.readPortletModes", [modes]);
					return modes;
				},
				readWindowStates: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readWindowStates", [xmlData] );
					var wStatesXPath = "/atom:feed/atom:entry/atom:link[@portal:rel='window-state']";
					var nodes = com.ibm.portal.xpath.evaluateXPath(wStatesXPath, xmlData, this.namespaces);
					var wStates = new Array();
					
					if (nodes != null && nodes.length > 0) {
			        	var nodeCount = nodes.length;
			            for (var i = 0; i < nodeCount; i++) {
							wStates.push( { "link": nodes[i].getAttribute("href"), "mode": nodes[i].getAttribute("title") } );
			            }
			        }
					ibm.portal.debug.exit( "PortletFragmentService.readWindowStates", [wStates]);
					return wStates;
				},
				readDependentPortlets: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readDependentPortlets", [xmlData] );
					var depPortletsXPath = "/atom:feed/atom:link[@portal:rel='dependent']";
					var nodes = com.ibm.portal.xpath.evaluateXPath(depPortletsXPath, xmlData, this.namespaces );
					var depPortlets = new Array();
					
					if (nodes != null && nodes.length > 0) {
			        	var nodeCount = nodes.length;
			            for (var i = 0; i < nodeCount; i++) {
							depPortlets.push( { "link": nodes[i].getAttribute("href"), "portlet": nodes[i].getAttribute("title"), "uri": nodes[i].getAttribute("portal:uri") ? nodes[i].getAttribute("portal:uri") :  nodes[i].getAttribute("uri") } );
			            }
			        }
					
					ibm.portal.debug.exit( "PortletFragmentService.readDependentPortlets", [depPortlets]);
					return depPortlets;
				},
				readOtherPortlets: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readOtherPortlets", [xmlData] );
					var otherPortletsXPath = "/atom:feed/atom:link[@portal:rel='other']";
					var nodes = com.ibm.portal.xpath.evaluateXPath(otherPortletsXPath, xmlData, this.namespaces );
					var otherPortlets = new Array();
					if (nodes != null && nodes.length > 0) {
			        	var nodeCount = nodes.length;
			            for (var i = 0; i < nodeCount; i++) {
							otherPortlets.push( { "link": nodes[i].getAttribute("href"), "portlet": nodes[i].getAttribute("title"), "uri": nodes[i].getAttribute("portal:uri") } );
			            }
			        }
					ibm.portal.debug.exit( "PortletFragmentService.readOtherPortlets", [otherPortlets]);
					return otherPortlets;
				},
				readStateVaryExpressions: function (/*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readStateVaryExpressions", [xmlData] );
					var stateVaryXPath = "/atom:feed/atom:entry/state-vary:state-vary/state-vary:expr";
					var nodes = com.ibm.portal.xpath.evaluateXPath(stateVaryXPath, xmlData, this.namespaces );
					var varyExpr = new Array();
					if (nodes != null && nodes.length > 0) {
						var nodeCount = nodes.length;
						for (var i = 0; i < nodeCount; i++) {
							var txtNode = nodes[i].firstChild;
							if (txtNode != null) {
								varyExpr.push( txtNode.nodeValue );
							}
						}
					}
					ibm.portal.debug.exit( "PortletFragmentService.readStateVaryExpressions", [varyExpr]);
					return varyExpr;
				},
				readPortletState: function ( /*XMLDocument*/xmlData ) {
					return this._readPortletState(xmlData);
				},
				_readPortletState: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "PortletFragmentService.readPortletState", [xmlData] );
					var stateXPath = "/atom:feed/atom:entry/state:root";
					var nodes = com.ibm.portal.xpath.evaluateXPath(stateXPath, xmlData, this.namespaces);
					var result = null;
					if ( nodes != null && nodes.length > 0 ) {
						var doc = dojox.data.dom.createDocument();
						com.ibm.portal.utilities.addExternalNode(doc, nodes[0]);
						result = doc;
					} else {
						stateXPath = "/atom:feed/state:root";
						nodes = com.ibm.portal.xpath.evaluateXPath(stateXPath,xmlData,this.namespaces);
						if ( nodes != null && nodes.length > 0 ) {
							var doc = dojox.data.dom.createDocument();
							com.ibm.portal.utilities.addExternalNode(doc, nodes[0]);
							result = doc;
						}
					}
					ibm.portal.debug.exit( "PortletFragmentService.readPortletState", [ result ] );
					return result;
				},
				_fireEvents: function ( /*PortletInfo*/pInfo, /*String*/portletId, /*XMLHttpRequest*/xhr ) {
					this._fireGlobalPortletStateChange( pInfo, portletId, xhr );
					//this._fireIndividualPortletStateChange( pInfo );
				},
				_fireGlobalPortletStateChange: function ( /*PortletInfo*/pInfo, /*String*/portletId, /*XMLHttpRequest*/xhr ) {
					//dojo.event.topic.publish( "/portal/PortletFragmentService/portletInfoRetrieved", { portletInfo: pInfo } );
					com.ibm.portal.EVENT_BROKER.endFragment.fire( { portletInfo: pInfo, id: portletId, xhr: xhr } );		
				},
				_fireIndividualPortletStateChange: function ( /*PortletInfo*/pInfo ) {
					//ibm.portal.debug.text( "Firing individual portlet event: /portal/navigation/portlet/" + pInfo.portletId + "@" + pInfo.windowId  );
					//dojo.event.topic.publish( "/portal/PortletFragmentService/portletInfoRetrieved/oid:" + pInfo.windowId + "@oid:" + pInfo.portletId , { portletInfo: pInfo } );	
				},
				createPortletInfo: function( /*XMLDocument*/xmlData ) {
					var windowId = this.readWindowID( xmlData );
					var portletId = this.readPortletID( xmlData ); 
					var markup = this.readMarkup( xmlData );
					var modes = this.readPortletModes( xmlData );
					var wStates = this.readWindowStates( xmlData );
					var depPortlets = this.readDependentPortlets( xmlData );
					var otherPortlets = this.readOtherPortlets( xmlData );
					var newState = this.readPortletState( xmlData );
					var stateVaryExpr = this.readStateVaryExpressions( xmlData );
					// determine the current portlet mode and window state
					var currentState = newState;
					if (currentState == null) {
						currentState = this._readPortletState(xmlData);
					}
					var stateMgr = new com.ibm.portal.state.StateManager();
					var portletAcc = stateMgr.newPortletAccessor( windowId, currentState );
					var mode = portletAcc.getPortletMode();
					var winState = portletAcc.getWindowState();
					return new com.ibm.portal.services.PortletInfo( windowId, portletId, markup, modes, wStates, depPortlets, otherPortlets, newState, stateVaryExpr, mode, winState );
				} 
			  }
);

dojo.declare( "com.ibm.portal.services.IndependentPortletFragmentService",
			  com.ibm.portal.services.PortletFragmentService,
			  {
			  	// summary: Ignores any dependent portlets.
			  	
			  	readDependentPortlets: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "DependentPortletFragmentService.readDependentPortlets", [xmlData] );
					var depPortlets = new Array();
				
					ibm.portal.debug.exit( "DependentPortletFragmentService.readDependentPortlets", [depPortlets]);
					return depPortlets;
				},	
				readOtherPortlets: function ( /*XMLDocument*/xmlData ) {
					ibm.portal.debug.entry( "DependentPortletFragmentService.readOtherPortlets", [xmlData] );
					var otherPortlets = new Array();
				
					ibm.portal.debug.exit( "DependentPortletFragmentService.readOtherPortlets", [otherPortlets]);
					return otherPortlets;
				},
				readPortletState: function ( /*XMLDocument*/xmlData ) {
					return null;
				}
			}
);

}
