/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.strategy.ShareNotificationStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.strategy.ShareNotificationStrategy"] = true;
dojo.provide("com.ibm.strategy.ShareNotificationStrategy");

dojo.require("com.ibm.strategy.Strategy");

dojo.declare("com.ibm.strategy.ShareNotificationStrategy",
	com.ibm.strategy.Strategy,
	{
		// extensions: Array
		//		Array of strings indicating which functions in this strategy should be used
		//		to wrap functions of the same name in the object this strategy is applied to.
		//		Extensions cannot be named "strategyInit", "around", or "proceed", as these
		//		reserved words for strategy management.
		extensions: ["saveACL"],
		
		constructor: function(callback) {
			if(callback) this.callback = callback;
			ibmPortalConfig.isShareStrategySet = true;
		},
		
		saveACL: function() {
			var me = this,
				instance = this.getStrategyContext().instance,
				oldCommit = instance.acModel.commit,
				oldSetCallback = null,
				count = 0;
				
			var utilsAdvice = com.ibm.strategy.Strategy.applyStrategy(
				instance.acModelUtil, new com.ibm.strategy.ACModelUtilsWrapper(function(inc){count += inc;}));	
				
			instance.acModel.commit = function() {
				var dfd = oldCommit.apply(this, arguments);
				oldSetCallback = dfd.setOperationCallback;
				dfd.setOperationCallback = function(func) {
					var wrappedFunc = function(newNode) {
						com.ibm.strategy.Strategy.removeStrategy(utilsAdvice);
						utilsAdvice = null;
						if(--count <= 0) me.callback(newNode);
						return func(newNode);
					}
					var ret = oldSetCallback.call(this, wrappedFunc);
					dfd.setOperationCallback = oldSetCallback;
					return ret;
				}
				instance.acModel.commit = oldCommit;
				return dfd;
			}
			return this.proceed(arguments);
		},
		
		callback: function(newNode) {
			// summary: Function which is called at the end of the Deferred processing which
			// 		fires its operation callback when the share operation completes either
			// 		successfully or unsuccessfully. 
		}
	}
);

dojo.provide("com.ibm.strategy.ACModelUtilsWrapper");

dojo.declare("com.ibm.strategy.ACModelUtilsWrapper",
	com.ibm.strategy.Strategy,
	{
		// extensions: Array
		//		Array of strings indicating which functions in this strategy should be used
		//		to wrap functions of the same name in the object this strategy is applied to.
		//		Extensions cannot be named "strategyInit", "around", or "proceed", as these
		//		reserved words for strategy management.
		extensions: ["insertMemberWithRoleType", "removeMembersWithRoleType"],
		
		constructor: function(incFunc) {
			if(incFunc) this.incFunc = incFunc;
		},
		
		insertMemberWithRoleType: function(model, members, role) {
			if(members) {
				var count = 0;
				for(var x in members) {
					if(members[x]) count ++;
				}
				this.incFunc(count);
			}
			return this.proceed(arguments);
		},
		
		removeMembersWithRoleType: function(model, role, members) {
			if(members) {
				var count = 0;
				for(var x in members) {
					if(members[x]) count ++;
				}
				this.incFunc(count);
			}
			return this.proceed(arguments);
		},
		
		incFunc: function(inc) {
			// summary: Fired when a certain number of principals are added or removed
			//		from the list of ACL modifications to be made. 
			// inc: The number to add to the current number of principals which 
			//		will be affected by the ACL change.  
		}
	}
);

}
