/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.xml.SimpleXmlAccessor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.xml.SimpleXmlAccessor"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.xml.SimpleXmlAccessor");

dojo.require("com.ibm.xml.xpath");
dojo.require("com.ibm.domUtilities");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.xml.XmlNodeList");

dojo.declare("com.ibm.xml.SimpleXmlAccessor",
	null,
	{
		namespaces: {},
		
		constructor: function(args) {
			dojo.mixin(this, args);
		},
		
		evaluate: function(/*String*/ expr, /*Object*/ context, /*Boolean*/ single) {
			var ret = com.ibm.xml.xpath.evaluate(expr, context, this.namespaces, single);
			if(single) {
				if(ret)	ret = [ret];
				else ret = [];
			}
			ret = com.ibm.xml.XmlNodeList.apply(null, ret);
			ret.ns = this.namespaces;
			return ret;
		},
		
		//select: function(/*String*/ selector, /*Object*/ data, /*Boolean*/ single) {
		//	return this.evaluate(selector, data, single);
		//},
		
		prop: function(/*DOMNode*/ node, /*String*/ prop, /*Object?*/ value) {
			// summary:  Function to provide cross-browser support for properties of a queried
			//		node.  Supports textContent as a special property since not
			//		all browsers implement the textContent property of DOM nodes.
			
			if(arguments.length < 3) {
				switch(prop) {
					case "textContent":
						return dojox.data.dom.textContent(node);
					case "localName":
					case "baseName":
						return node[dojo.isIE ? "baseName" : "localName"];
					default:
						return node[prop];
				}
			}
			else {
				switch(prop) {
					case "textContent":
						dojox.data.dom.textContent(node, value);
						return true;
					default:
						node[prop] = value;
						return true;
				}
			}
		},
		attr: function(/*DOMNode*/ node, /*String*/ attr, /*Object?*/ value) {
			// summary: Gets/sets an attribute on a node.  Acts as a getter if value is 
			//		not specified (undefined) and acts as a setter if value is specified,
			//		even if it is set to null.  As a getter, this returns undefined if
			//		the attribute does not exist on the node instead of returning null
			//		or any empty string.  That way, callers can distinguish between an
			//		attribute's presence and an empty value.
			if(arguments.length < 3) {
				if(!com.ibm.domUtilities.hasAttribute(node, attr, this.namespaces)) return;
				return com.ibm.domUtilities.getAttribute(node, attr, this.namespaces);
			}
			else return com.ibm.domUtilities.setAttribute(node, attr, value, this.namespaces);
		},
		getSelf: function(/*DOMNode*/ node) {
			return node;
		},
		createElement: function(/*DOMDoc*/ doc, /*String*/ tagName, /*Object?*/ attrMap) {
			return com.ibm.domUtilities.createElement(doc, tagName, this.namespaces, attrMap);
		},
		createFromJson: function(/*DOMNode*/ node, /*Object*/ def) {
			return com.ibm.domUtilities.createFromJson(node.ownerDocument, def, this.namespaces, node);
		}
	}
);

(function(){
	var p = com.ibm.xml.SimpleXmlAccessor.prototype;
	p.select = p.evaluate;
})();

}
