/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.xml.XmlNodeList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.xml.XmlNodeList"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.xml.XmlNodeList");

dojo.require("com.ibm.domUtilities");
dojo.require("com.ibm.xml.xpath");

(function(){
	
	var xpath = function(expr, ctx, single) {
		return com.ibm.xml.xpath.evaluate.call(this, expr, ctx, this.ns, single);
	}
	
	var wrap = function(arr, ns) {
		arr.constructor = com.ibm.xml.XmlNodeList;
		dojo._mixin(arr, com.ibm.xml.XmlNodeList.prototype);
		arr.ns = ns;
		return arr;
	}
	
	com.ibm.xml.XmlNodeList = function() {
		var ret = wrap(Array.apply(null, arguments), null);
		return ret;
	}
	
	var xnl = com.ibm.xml.XmlNodeList, xnlp = xnl.prototype, d = dojo, dom = com.ibm.domUtilities;
	
	xnl.fromArray = function(arr, ns) {
		return wrap(arr, ns);
	}
	
	var flatten = function(arr, ctr) {
		if(arr && (arr instanceof Array || typeof arr == "array")) {
			var flatArr = ctr ? new ctr() : [];
			d.forEach(arr, function(item){
				flatArr = flatArr.concat(flatten(item, ctr));
			});
			return flatArr;
		}
		else return arr;
	}
	
	var createElement = function(def, parentNode) {
		return dom.createFromJson(parentNode.ownerDocument, def, this.ns, parentNode);
	}
	
	d.extend(xnl, {
		map: function(/*Function*/ func, /*Object*/ scope) {
			var ret = d.map(this, func, scope, xnl);
			ret.ns = this.ns;
			return ret;
		},
		indexOf: function(/*XmlNode|Function*/ pred, /*Number*/ startFrom, /*Boolean?*/ fromEnd) {
			var last = this.length || 0, jump = 1, i = 0;
			if(fromEnd) {
				jump = last = -1;
				i = this.length - 1;
			}
			if(startFrom != undefined) i = startFrom;
			// forked for performance reasons
			if(!d.isFunction(pred)) {
				while((fromEnd && i > last) || i < last) {
					if(pred == this[i]) {
						return i;
					}
					i += jump;
				}
			}
			else {
				while((fromEnd && i > last) || i < last) {
					if(pred(this[i])) {
						return i;
					}
					i += jump;
				}
			}
			return -1;
		},
		lastIndexOf: function(/*XmlNode|Function*/ pred, /*Number*/ startFrom) {
			return this.indexOf(pred, startFrom, true);
		},
		forEach: function(/*Function*/ func, /*Object*/ scope) {
			d.forEach(this, func, scope);
			return this;
		},
		removeProp: function(/*String*/prop) {
			switch(prop) {
				case "childNodes":
					this.prop(prop).forEach(function(nodeList){nodeList.remove();});
					return this;
				case "firstChild":
				case "lastChild":
				case "parentNode":
				case "nextSibling":
				case "previousSibling":
					this.prop(prop).remove();
					return this;
				case "text":
				case "textContent":
				case "xml":
				case "innerXML":
					return this.prop(prop, "");
				case "localName":
				case "baseName":
					return this;
				default:
					this.forEach(function(node){delete node[prop];}, this);
					return this;
			}
		},
		removeAttr: function(/*String*/attr) {
			this.forEach(function(node){
				com.ibm.domUtilities.removeAttribute(node, attr, this.ns);
			}, this);
			return this;
		},
		prop: function(/*String*/ prop, /*Object?*/ value) {
			var asXnl = false, f = null, ns = this.ns;
			if(arguments.length < 2) {
				switch(prop) {
					case "childNodes":
						f = function(node){
							var ret = xnl.apply(null, dojo._toArray(node[prop]));
							ret.ns = ns;
							return ret;
						}
						asXnl = true;
						break;
					case "firstChild":
					case "lastChild":
					case "parentNode":
					case "nextSibling":
					case "previousSibling":
						f = function(node){return node[prop];}
						asXnl = true;
						break;
					case "text":
					case "textContent":
						f = function(node){ return dom.textContent(node); };
						break;
					case "xml":
					case "innerXML":
						f = function(node){ return dom.innerXML(node); };
						break;
					case "localName":
					case "baseName":
						prop = [d.isIE ? "baseName" : "localName"];
					default:
						f = function(node){return node[prop];}
				}
				var retArr = d.map(this, f, this);
				if(asXnl) {
					retArr = xnl.apply(retArr, retArr);
					retArr.ns = ns;
				}
				return retArr;
			}
			else {
				var curVal = value;
				
				switch(prop) {
					case "text":
					case "textContent":
						f = function(node) { dojox.data.dom.textContent(node, curVal); };
						break;
					default:
						f = function(node) { node[prop] = curVal; };
				}
				if(dojo.isArrayLike(value)) {
					var sf = f, idx = 0;
					f = function(node) {
						curVal = value[idx++];
						if(curVal !== undefined) sf(node);
					}
				}
				
				d.map(this, f, this);
				return this;
			}
		},
		attr: function(/*String*/ attr, /*String?*/ value) {
			var ns = this.ns;
			if(arguments.length < 2) {
				return d.map(this, function(node){
					if(!dom.hasAttribute(node, attr, ns)) return;
					return dom.getAttribute(node, attr, ns);
				}, this);
			}
			else {
				var curVal = value;
				
				var f = function(node) {
					dom.setAttribute(node, attr, curVal, ns);
				};
				
				if(dojo.isArrayLike(value)) {
					var sf = f, idx = 0;
					f = function(node) {
						curVal = value[idx++];
						if(curVal !== undefined) sf(node);
					}
				}
				
				d.map(this, f, this);
				return this;
			}
		},
		hasAttr: function(/*String*/ attr) {
			return d.map(this, function(node){
				return dom.hasAttribute(node, attr, this.ns);
			}, this);
		},
		every: function(/*Function*/ func, /*Object*/ scope) {
			return d.every(this, func, scope);
		}, 
		some: function(/*Function*/ func, /*Object*/ scope) {
			return d.some(this, func, scope);
		},
		filter: function(/*String*/ xpathPredicate) {
			var resList = this, a = arguments, fIdx = 0;
			if(d.isString(xpathPredicate)) {
				resList = resList.select(".[" + xpathPredicate + "]");
				fIdx = 1;
			}
			if(a.length > 1) {
				resList = xnl.apply(resList, d.filter(resList, a[fIdx], a[fIdx+1]));
				resList.ns = this.ns;
			}
			return resList;
		},
		select: function(/*String*/ xpathExpr, /*Boolean*/ single) {
			if(!xpathExpr) return this;
			var resList = [];
			this.forEach(function(node){
				resList = resList.concat(xpath.call(this, xpathExpr, node, single) || []);
			}, this);
			
			resList = wrap(resList, this.ns);
			return resList;
		},
		remove: function() {
			return this.forEach(function(node){
				if(node.parentNode) {
					node.parentNode.removeChild(node);
				}
			}, this);
		},
		replace: function(/*Array*/nodeList) {
			for(var i=0; i<nodeList.length && i<this.length; i++) {
				this[i].parentNode.replaceChild(nodeList[i], this[i]);
			}
			return this;
		},
		destroy: function() {
			this.remove();
			this.splice(0, this.length);
			return this;
		},
		createFromJson: function(/*Object*/ def) {
			return this.forEach(dojo.partial(createElement, def), this);
		},
		toString: function() {
			return "XmlNodeList{ " + Array.prototype.toString.call(this) + " }";
		}
	});
	
	d.forEach(["slice", "splice", "concat"], function(name){
		xnlp[name] = function() {
			return wrap(Array.prototype[name].apply(this, arguments), this.ns);
		}
	}, this);
	
	d.forEach(["attributes", "baseURI", "childNodes", "firstChild", "lastChild", 
		"localName", "baseName", "namespaceURI", "nextSibling", "nodeName", "nodeType",
		"ownerDocument", "parentNode", "prefix", "previousSibling", "tagName", "innerXML",
		"text", "textContent"], function(name){
		xnlp[name] = function() {
			return this.prop(name);
		}
	}, this);
	
	// syntactic sugar for those who want it
	xnlp.$ = xnlp.select;
	xnlp._$ = xnlp.prop;
	xnlp.text = xnlp.textContent;
})();

}
