/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.xml.xpath"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.xml.xpath"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.xml.xpath");

/*
 * 
 * Internal API, not Public, therefore not supported as public APIs.
 * 
 */

dojo.require("ibm.portal.xml.xpath");

com.ibm.xml.xpath = ibm.portal.xml.xpath;

if(dojo.isIE) {
	com.ibm.xml.xpath.evaluate = function(expr, context, namespaces, single) {
		var result = null;
		if(namespaces) {
			var ns = "";
			for (var prop in namespaces) {
			    ns += "xmlns:"+prop+"='"+namespaces[prop]+"' ";
			}
			if (context.ownerDocument) {
			    context.ownerDocument.setProperty("SelectionNamespaces", ns);
			} else {
			    context.setProperty("SelectionNamespaces", ns);
			}
		}
        if(!single) { 
	        result = context.selectNodes(expr);
			var resultSet = [];
	        for (var i=0; i<result.length; i++) {
	            if (result[i]) {
	                resultSet.push(result[i]);
	            }
	        }
	        return resultSet;
        }
        else {
        	return context.selectSingleNode(expr);
        }
	}
}
else {
	com.ibm.xml.xpath.evaluate = function(expr, context, namespaces, single) {
		var result = null;
		var rootDoc = context;
    	if(!rootDoc.evaluate) rootDoc = context.ownerDocument;
    	try {
			result = rootDoc.evaluate( 
				expr, 
				context, 
				function(prefix) { return namespaces[prefix] || null;}, 
				single ? XPathResult.FIRST_ORDERED_NODE_TYPE : XPathResult.ORDERED_NODE_ITERATOR_TYPE, 
				null 
			);
    	}
    	catch(err) {
    		throw new Error("Error with xpath expr: " + expr + " - " + err);
    	}
		
		if(!single) {
			var thisResult;
		    var resultSet = new Array();
		    var len = 0;
		    do {
		        thisResult = result.iterateNext();
		        if (thisResult) {
		            resultSet[len] = thisResult;
		            len++;
		        }
		    } while ( thisResult );
		    return resultSet;
		}
		else {
			return result.singleNodeValue;
		}
	}
}

}
