<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="com.alphablox.blox.uimodel.core.event.*,
                 com.alphablox.blox.uimodel.core.*,
                 com.alphablox.blox.uimodel.*,
                 com.alphablox.blox.uimodel.dialog.cube.*,
                 com.alphablox.net.URLFactory,
                 com.alphablox.blox.AdminBlox,
                 com.alphablox.util.CouldNotCreateException,
                 com.alphablox.blox.repository.DataSource,
                 java.util.Iterator"%>

<%@ taglib uri='bloxtld' prefix='blox'%>
<head>
<blox:header />
</head>
<body>
<blox:container id="createCubeDialogContainer" width="1" height="1" visible="true">
<%
    BloxModel model = createCubeDialogContainer.getBloxModel();
    model.clear();
    model.getController().addEventHandler( new IEventHandler() {
            public boolean handleDialogClosedNotify( DialogClosedNotify event ) throws Exception {
                IModelDispatcher dispatcher = event.getComponent().getDispatcher();
                if ( countDialogs(dispatcher) == 0 ) {
                    dispatcher.sendClientCommand("top.location.href='"+URLFactory.getAdminURL("home/admin/cube/?init=true")+"';");
                    dispatcher.sendClientCommand("top.document.getElementById('cubeAdminFrame').src='"+URLFactory.getAdminURL("cubeadmin/blank.html")+"';");
                }
                return false;
            }

            private int countDialogs( IModelDispatcher dispatcher ) {
                int dialogCount = 0;
                for ( Iterator iterator=dispatcher.dialogs(); iterator.hasNext(); iterator.next() )
                    dialogCount++;
                return dialogCount;
            }
        }
    );
%>
</blox:container>
<%
    BloxModel model = createCubeDialogContainer.getBloxModel();
    Dialog dialog = new CubeAdminDialog( model );

    DataSource[] dataSources = (new AdminBlox()).getDataSources();
    boolean hasValidDataSources = false;

    for (int n = 0; n < dataSources.length; n++) {
        DataSource dataSource = dataSources[n];
         if ((!dataSource.isMDB()
            && dataSource.getUserName() != null
            && dataSource.getUserName().length() != 0) || dataSource.getAdapterName().equals(DataSource.ADAPTER_APPLICATIONSERVER)) {
            hasValidDataSources = true;
            break;
        }
    }

    if (!hasValidDataSources) {

	MessageBox messageBox = MessageBox.message(model.getDispatcher(), (CouldNotCreateException.class).getName(), CubeAdminConstants.NO_RDB_DATA_EXCEPTION );
        messageBox.setHeight(150);
        messageBox.setWidth(400);

        Component message = messageBox.searchForComponent("message");
        message.getParent().setHeight(70);
        message.getParent().setWidth(350);
        message.setAlignment(Component.ALIGN_CENTER);
        try {
            message.changed();
        } catch (ModelException e) {
            //e.printStackTrace();
        }

    }
    else {
        model.getTopLevelContainer().getDispatcher().showDialog( dialog );
    }
%>
</body>
