    <%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="java.io.File,
                 com.alphablox.server.Server,
                 com.alphablox.server.adapter.BaseAdapter,
                 com.alphablox.server.adapter.WASAdapterException,
                 com.alphablox.server.adapter.WebDescriptor,
                 java.util.List,
                 java.util.ArrayList,
                 java.util.Arrays,
                 com.alphablox.blox.uimodel.BloxModel,
                 com.alphablox.util.Message,
                 com.alphablox.blox.uimodel.core.event.ModelEvent,
                 com.alphablox.blox.uimodel.core.*,
                 java.util.Iterator,
                 com.alphablox.blox.uimodel.core.event.SelectionChangedEvent,
                 com.alphablox.server.application.Application,
                 com.alphablox.server.application.ApplicationManager,
                 com.alphablox.server.service.ServiceManager,
                 java.net.URLEncoder" %>
    <%@ page import="com.alphablox.net.URLFactory"%>

<%@ taglib uri="bloxtld" prefix='blox'%>

<html>

<%
    final String TITLE = "Import an Application";
%>

<head>
    <title><%= TITLE %></title>
    <link href="../admin/dialog.css" rel="stylesheet" type="text/css">
    <blox:header />
</head>

  <script language="JavaScript1.2">

    function setValues(moduleName, j2eeApp, uri, contextPath, docBase) {
        var target = ( MSIE ) ? window.dialogArguments : window.opener.document;		

        var nameEdit = target.getElementById('name');
        nameEdit.value = moduleName;

        var j2eeEdit = target.getElementById('j2eename');
        if (j2eeApp != '') {
            j2eeEdit.value = j2eeApp;
        }
        else {
            j2eeEdit.value = "";
        }

        var uriEdit = target.getElementById('uri');
        if (uri != '') {
            uriEdit.value = uri;
        }
        else {
            uriEdit.value = "";
        }

        var contextEdit = target.getElementById('contextpath');
        if (contextPath != '') {
            contextEdit.value = contextPath;
        }
        else {
            contextEdit.value = "";
        }

        var docEdit = target.getElementById('docbase');
        if (docBase != '') {
            docEdit.value = decodeURIComponent(docBase);
        }
        else {
            docEdit.value = "";
        }

        if ( MSIE )
           close();
        else
           window.close();
    }
  </script>

<%!
      final String NO_MODULES = "<no modules available>";

      WebDescriptor[] descriptors = null;

      private synchronized void getModuleNames(ComponentContainer container, WebDescriptor[] descriptors, DropDownList moduleList, String selectedJ2eeName) throws Exception {
          Button selectButton = (Button)container.searchForComponent("selectApplicationButton");
          boolean isWebsphere = Server.getServer().isIBMWebSphere();

          moduleList.clear();

          for (int i = 0; i < descriptors.length; i++) {
              // we can't import non-blox apps into websphere yet
              if (!descriptors[i].isBloxApp() && isWebsphere)
                     continue;

              final String moduleName = descriptors[i].getModuleName();
              final String j2eeName = descriptors[i].getJ2EEAppName();

              if ((moduleName.length() > 0) && (j2eeName.equalsIgnoreCase(selectedJ2eeName))) {
                  boolean showApplication = getAlphabloxApplication(j2eeName, moduleName);

                  if (showApplication) {
                      moduleList.add(moduleName, descriptors[i]);
                  }
              }
          }

          if (moduleList.size() == 0) {
              moduleList.add(NO_MODULES);
              moduleList.setDisabled(true);
              selectButton.setDisabled(true);
          }
          else {
              moduleList.setDisabled(false);
              selectButton.setDisabled(false);
          }

          moduleList.setSelected(0);
      }

      private synchronized boolean getAlphabloxApplication(String j2eeName, String moduleName) throws Exception {
          ApplicationManager appMan = (ApplicationManager)ServiceManager.getServiceManager().getService(ServiceManager.SVC_APPMGR, null);
          Application[] apps = appMan.getApplications();

          for (int i = 0; i < apps.length; i++) {
              String thisj2eeName = apps[i].getJ2EEAppName();
              String thisModuleName = apps[i].getModuleName();

              if ((j2eeName.equalsIgnoreCase(thisj2eeName)) && (moduleName.equalsIgnoreCase(thisModuleName))) {
                  return false;
              }
          }

          return true;
      }

      public class ApplicationsListDialog extends ComponentContainer {
          ComponentContainer resourceComponent = null;

          public void setupLists() throws Exception {
              DropDownList j2eeList = (DropDownList)resourceComponent.searchForComponent("j2eeDropDown");
              DropDownList moduleList = (DropDownList)resourceComponent.searchForComponent("moduleNamesDropDown");
              BaseAdapter adapter = (BaseAdapter)Server.getServer().getWASAdapter();

              adapter.clearCache();
              descriptors = adapter.getWebDescriptors();

              getJ2eeNames(descriptors,  j2eeList);

              if (j2eeList.size() > 0) {
                  j2eeList.setSelected(0);
              }

              int selectedIndex = j2eeList.getSelected();
              String selectedItem = (selectedIndex >= 0) ? (String)j2eeList.getUserObject(selectedIndex) : null;

              getModuleNames(resourceComponent, descriptors, moduleList, selectedItem);

              WebDescriptor selectedDescriptor = (WebDescriptor)moduleList.getUserObject(moduleList.getSelected());
              Static uri = (Static)resourceComponent.searchForComponent("uri");
              Static contextPath = (Static)resourceComponent.searchForComponent("contextPath");

              if (selectedDescriptor == null) {
                  uri.setTitle("");
                  contextPath.setTitle("");
              }
              else {
                  uri.setTitle(selectedDescriptor.getURI());
                  contextPath.setTitle(selectedDescriptor.getContextPath());
              }
          }

          private void init(PageContext pageContext) throws Exception {
              ServletContext jspContext = pageContext.getServletContext();
              String dialogXML = jspContext.getRealPath("jsp/getApplicationsList.xml");
              resourceComponent = (ComponentContainer)ModelResource.loadResource(dialogXML);

              this.add(resourceComponent);
              this.setAlignment(Component.ALIGN_CENTER);

              ArrayList allButtons = resourceComponent.searchForAllComponents(Button.class);
              for (Iterator button = allButtons.iterator(); button.hasNext();) {
                  Button nextButton = (Button)button.next();
                  nextButton.setThemeClass(nextButton.getDialogThemeClass());
                  try {
                      nextButton.changed();
                  }
                  catch (ModelException e) {
                      // swallow NoChangeRegistryException if thrown
                  }
              }

              ArrayList allStatics = resourceComponent.searchForAllComponents(Static.class);
              for (Iterator statics = allStatics.iterator(); statics.hasNext();) {
                  Static nextStatic = (Static)statics.next();
                  nextStatic.setThemeClass(nextStatic.getDialogThemeClass());
                  try {
                      nextStatic.changed();
                  }
                  catch (ModelException e) {
                      // swallow NoChangeRegistryException if thrown
                  }
              }


              resourceComponent.setController(new ApplicationsListController());
          }

          private void getJ2eeNames(WebDescriptor[] descriptors, DropDownList j2eeList) throws Exception {
              List list = new ArrayList();
              boolean isWebsphere = Server.getServer().isIBMWebSphere();

              j2eeList.clear();

              for (int i = 0; i < descriptors.length; i++) {
                  // we can't import non-blox apps into websphere yet
                  if (!descriptors[i].isBloxApp() && isWebsphere)
                         continue;

                  final String j2eeName = descriptors[i].getJ2EEAppName();

                  if (j2eeName.equalsIgnoreCase("AlphabloxPlatform"))
                      continue;

                  if (!list.contains(j2eeName)) {
                      list.add(j2eeName);
                  }
              }

              if ((list.size() == 0) || (list.size() == 1 && ((String)list.get(0)).length() == 0)) {
                  j2eeList.add("<Not Applicable>", "");
                  j2eeList.setDisabled(true);

                  return;
              }

              for (int i = 0; i < list.size(); i++) {
                  final String j2eeName = (String)list.get(i);
                  final String moduleName = descriptors[i].getModuleName();

                  boolean showApplication = getAlphabloxApplication(j2eeName, moduleName);

                  if (j2eeName.length() > 0 && showApplication) {
                      j2eeList.add(j2eeName, j2eeName);
                  }
              }
          }
      }


      public class ApplicationsListController extends Controller {
          public void actionSelectApplicationButton(ModelEvent event) throws Exception {
              Component component = event.getComponent();
              ComponentContainer topContainer = component.getTopLevelContainer();

              DropDownList moduleList = (DropDownList)topContainer.searchForComponent("moduleNamesDropDown");
              WebDescriptor descriptor = (WebDescriptor)moduleList.getUserObject(moduleList.getSelected());
              String encodedDocBase = URLEncoder.encode(descriptor.getDocBase().getAbsolutePath(), "UTF-8");

              component.getDispatcher().sendClientCommand("setValues('" + descriptor.getModuleName() + "', '" + descriptor.getJ2EEAppName() +
                                                          "', '" + descriptor.getURI() + "', '" + descriptor.getContextPath() + "', '" + encodedDocBase + "');");
          }

          public void actionCancel(ModelEvent event) throws ModelException {
              event.getComponent().getDispatcher().sendClientCommand("top.close()");
          }

          public boolean handleSelectionChangedEvent(SelectionChangedEvent event) throws Exception {
              final Component component = event.getComponent();
              final ComponentContainer container = component.getTopLevelContainer();

              if (component.getName().equals("j2eeDropDown")) {
                  DropDownList j2eeList = (DropDownList)component;
                  String selectedJ2eeName = (String)j2eeList.getUserObject(j2eeList.getSelected());
                  DropDownList moduleList = (DropDownList)container.searchForComponent("moduleNamesDropDown");

                  getModuleNames(container, descriptors, moduleList, selectedJ2eeName);

                  setApplicationInformation(container);
              }
              else if (component.getName().equals("moduleNamesDropDown")) {
                  setApplicationInformation(container);
              }
              else {
                  component.getDispatcher().sendClientCommand("Internal Error: Invalid Component");
                  return false;
              }

              container.changed();

              return true;
          }

          private void setApplicationInformation(ComponentContainer container) throws Exception {
              DropDownList moduleList = (DropDownList)container.searchForComponent("moduleNamesDropDown");
              Static uri = (Static)container.searchForComponent("uri");
              Static contextPath = (Static)container.searchForComponent("contextPath");

              int idx = moduleList.getSelected();
              WebDescriptor thisDescriptor = (WebDescriptor)moduleList.getUserObject(idx);

              if (thisDescriptor == null) {
                  uri.setTitle("");
                  contextPath.setTitle("");
              }
              else {
                  uri.setTitle(thisDescriptor.getURI());
                  contextPath.setTitle(thisDescriptor.getContextPath());
              }
          }
      }
%>

<%
    ApplicationsListDialog dialog = null;
    BloxModel model = null;
    String dialogName = "lookupAppsDialog";
%>

    <blox:container visible="false" id="applicationsListContainer" width="100%" height="100%">
    <%
        model = applicationsListContainer.getBloxModel();
        model.clear();

        dialog = new ApplicationsListDialog();
        dialog.setName(dialogName);
        dialog.init(pageContext);
        model.add(dialog);
    %>
    </blox:container>


    <%
        model = applicationsListContainer.getBloxModel();
        dialog = (ApplicationsListDialog)model.searchForComponent(dialogName);
        dialog.setupLists();
    %>


<body class="default">
    <br>
    <table width="100%" border="0" cellpadding="0" cellspacing="0">
        <tr><td align="left"><img src="<%= URLFactory.getAdminURL( "/home/i/small-logo.gif") %>"></td></tr>
    </table>

    <p></p>

    <table width="96%" border="0" cellpadding="0" cellspacing="0">
        <tr><td class="Title"><%= TITLE %></td></tr>
        <tr><td class="Border">&nbsp;</td></tr>
    </table>

    <table class="contents" width="96%" border="0" cellpadding="0" cellspacing="0">
        <tr><td style="font-size:10px;">&nbsp;</td></tr>
        <tr><td class="dialogBackground" valign="top" align="center">
               <blox:display bloxRef="applicationsListContainer" />
            </td></tr>
    </table>
</body>



</html>