<!--
    Copyright  2003 Alphablox, Inc. All rights reserved.
-->
<%@ page import="com.alphablox.blox.AdminBlox,
                 com.alphablox.blox.repository.Server,
                 com.alphablox.printprocessor.*,
                 com.alphablox.printprocessor.local.*,
                 java.net.InetAddress"%>
<%@ page import="com.alphablox.net.URLFactory"%>


<jsp:useBean id="adminBlox" class="com.alphablox.blox.AdminBlox" scope="session" />

<%!
  String compLevelToString(int level) {
    switch(level) {
	  case 0: return "0 - No Compression";
	  case 1: return "1 - Minimal";
	  case 2: return "2 - Minimal";
	  case 3: return "3 - Moderate";
	  case 4: return "4 - Moderate";
	  case 5: return "5 - High";
	  case 6: return "6 - High";
	  case 7: return "7 - Very High";
	  case 8: return "8 - Very High";
	  case 9: return "9 - Full";
	  default: return "Unknown";
	}
  }
%>

<%
    final String NA = "N/A";
    final String USING_REMOTE = "PDF Report Server";
    final String USE_REMOTE = "Use PDF Report Server";
    final String USING_LOCAL = "Internal Server";
    final String USE_LOCAL = "Use Internal Server";

    Server server = adminBlox.getServer();
    String host = server.getPrintProcessorHost();
    int port = server.getPrintProcessorPort();
	int compression = server.getPrintProcessorCompression();
    PrintProcessor pp = com.alphablox.server.Server.getServer().getPrintProcessor();
    boolean localProcessor = true;
    String processorStr;
    String portStr;
    String hostStr;
    String compressionStr;
    String tc = "darkRow";

    if (pp instanceof PrintProcessorRemoteInterface) {
      localProcessor = false;
    }

    if (localProcessor) {
      processorStr = USING_LOCAL;
      portStr = NA;
      hostStr = NA;
      compressionStr = NA;
    }
    else {
      processorStr = "PDF Report Server";
      portStr = String.valueOf(port);
      hostStr = host;
      compressionStr = compLevelToString(compression);
    }
%>
<html>
<head>
    <meta http-equiv="Pragma" content="No-cache"/>
    <link href="styles.css" rel="stylesheet">
    <title>PDF Reports - DHTML</title>
    <style>
      div.logo {
        position: absolute;
        top: 2px;
        left: 4px;
        z-index: 2;
      }

      div.title {
        font: bold 100% Verdana, Helvetica, "Times New Roman";
        margin-left: 15px;
        margin-right: 100px;
      }

      div.note {
        font: normal 90% Verdana, Helvetica, "Times New Roman";
        color: red;
        margin-left: 10px;
        width: 375px;
      }

      .bold { font-weight: bold; }

      TD.darkRow { background-color: #E6E6CE; }
      TD.lightRow { background-color: #EFF0E2; }
      TD.buttonBar { background-color: #CCCC99; }

	  input, select {
	    font: normal 80% Verdana, Helvetica, "Times New Roman";
	  }

      body, td {
        font: normal 72% Verdana, Helvetica, "Times New Roman";
        background-color: white;
        margin-left: 48px;
        margin-top: 50px;
      }
    </style>
</head>

<script language="JavaScript1.3">
  var NA = "<%= NA %>";
  var gPort, gName, gCompression;
  var currentMillis = 60000;

  function editFn() {
    document.getElementById('edit').disabled = true;
    var serverProcessorEditLabel = serverProcessor.firstChild;
    var sProcessorType = serverProcessorEditLabel.firstChild.nodeValue;
    if (sProcessorType == "<%= USING_REMOTE %>") {
      serverProcessorEdit.selectedIndex = 1;
      gPort = hostPort.innerHTML;
      gName = hostName.innerHTML;
      gCompression = compression.innerHTML;

      setRemoteSettings(true);
    }
    else {
      serverProcessorEdit.selectedIndex = 0;
    }

    serverProcessor.style.display = "none";
    serverProcessorEdit.style.display = "inline";

    var compressionLevel;

    if (compression.innerHTML == NA) {
      compressionLevel = 0;
    }
    else {
      compressionLevel = compression.innerHTML.charAt(0);
    }
    compressionEdit.selectedIndex = compressionLevel - 0;

    document.getElementById('save').disabled = false;
    document.getElementById('cancel').disabled = false;
  }

  function setRemoteSettings(on) {
    if (on) {
      if (hostPort.innerHTML != NA) {
        hostPortEdit.value = hostPort.innerHTML;
      }

      hostPort.style.display = "none";
      hostPortEdit.style.display = "inline";

      if (hostName.innerHTML != NA) {
        hostNameEdit.value = hostName.innerHTML;
      }
      hostName.style.display = "none";
      hostNameEdit.style.display = "inline";

      compression.style.display = "none";
      compressionEdit.style.display = "inline";
    }
    else {
      hostPort.innerHTML = NA;
      hostPort.style.display = "inline";
      hostPortEdit.style.display = "none";

      hostName.innerHTML = NA;
      hostName.style.display = "inline";
      hostNameEdit.style.display = "none";

      compression.innerHTML = NA;
      compression.style.display = "inline";
      compressionEdit.style.display = "none";
    }
  }

  function processorSelect() {
    var sProcessor = serverProcessorEdit[serverProcessorEdit.selectedIndex].text;
    if (sProcessor == "<%= USE_REMOTE %>") {
      setRemoteSettings(true);
    }
    else {
      setRemoteSettings(false);
    }
  }

  function cancelFn() {
    document.getElementById('save').disabled = true;
    document.getElementById('cancel').disabled = true;

    textToLabels(true);

    document.getElementById('edit').disabled = false;
  }

  function saveFn() {
    var sProcessor = serverProcessorEdit[serverProcessorEdit.selectedIndex].text;
    if (sProcessor == "<%= USE_REMOTE %>") {
      if (hostPortEdit.value == "") {
        alert("Please enter a Host Port for the remote processor");
        return;
      }

      var portNum = parseInt(hostPortEdit.value);
      if (isNaN(portNum)) {
        alert("Please enter a valid Host Port number for the remote processor");
        return;
      }

      if (hostNameEdit.value == "") {
        alert("Please enter a Host Name for the remote processor");
        return;
      }

      serverAvail.style.color = "black";
      serverAvail.innerHTML = "Checking...";
    }

    document.getElementById('save').disabled = true;
    document.getElementById('cancel').disabled = true;

    textToLabels(false);

    var hostP;
    var hostN;
    var comp;

    if (sProcessor == "<%= USE_LOCAL %>") {
      hostP = "-1";
      hostN = "localhost";
      comp = 0;
    }
    else {
      hostP = hostPort.innerHTML;
      hostN = hostName.innerHTML;
      comp = compression.innerHTML.charAt(0);

    }

    document.getElementById('edit').disabled = false;

    controller.saveSettings(hostN, hostP, comp);
  }

  function textToLabels(revert) {

    if (!revert) {
      var sProcessor = serverProcessorEdit[serverProcessorEdit.selectedIndex].text;

      var serverProcessorEditLabel = serverProcessor.firstChild;
      if (sProcessor == "<%= USE_REMOTE %>") {
        serverProcessorEditLabel.firstChild.nodeValue = "<%= USING_REMOTE %>";
        hostPort.innerHTML = hostPortEdit.value;
        hostName.innerHTML = hostNameEdit.value;
        compression.innerHTML = "" + compressionEdit[compressionEdit.selectedIndex].text;
      }
      else {
	serverProcessorEditLabel.firstChild.nodeValue = "<%= USING_LOCAL %>";
      }
    }
    else {
      var serverProcessorEditLabel = serverProcessor.firstChild;
      var sProcessorType = serverProcessorEditLabel.firstChild.nodeValue;

      if (sProcessorType == "<%= USING_LOCAL %>") {
        hostPort.innerHTML = NA;
        hostName.innerHTML = NA;
        compression.innerHTML = NA;
      }
      else {
        hostPort.innerHTML = gPort;
        hostName.innerHTML = gName;
        compression.innerHTML = gCompression;
      }
    }

    serverProcessorEdit.style.display = "none";
    serverProcessor.style.display = "inline";

    hostPortEdit.style.display = "none";
    hostPort.style.display = "inline";

    hostNameEdit.style.display = "none";
    hostName.style.display = "inline";

    compressionEdit.style.display = "none";
    compression.style.display = "inline";
  }

  function closeWindow() {
    if (document.getElementById('edit').disabled == true) {
      alert("Please save or cancel your changes before closing the dialog.");
      return;
    }

    close();
  }
</script>

<body>
   <iframe name="controller" style="display:none;" height="200" width="400" src="controller.jsp"></iframe>
   <div class="logo"><img src="<%= URLFactory.getAdminURL( "/home/i/logo.gif") %>" /></div>

   <div class="title">General Information</div>
   <table id="generalinfo" name="generalinfo" border="0" cellpadding="2" cellspacing="0">
     <tr><td colspan="4" style="background-image: url(dot.gif);"></td></tr>

     <tr>
       <td class="<%= tc %>" width="20" height="25" valign="middle">&nbsp;</td>
       <td width="180" class="<%= tc %>" nowrap>Status</td>
       <td width="180" class="<%= tc %> bold" id="serverAvail" nowrap>Checking...</td>
       <td class="<%= tc %>" width="20">&nbsp;</td>
     </tr>

<% tc = "lightRow"; %>

     <tr>
       <td class="<%= tc %>" height="25">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Server</td>
       <td class="<%= tc %> bold" valign="middle" nowrap>
         <span id="serverProcessor"><label for="serverProcessorEdit"><%= processorStr %></label></span>
         <select name="serverProcessorEdit" id="serverProcessorEdit" style="display:none" onchange="processorSelect();">
           <option name="local"><%= USE_LOCAL %></option>
           <option name="remote"><%= USE_REMOTE %></option>
         </select>
       </td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>

<% tc = "darkRow"; %>

     <tr>
       <td class="<%= tc %>" height="25" valign="middle">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap><label for="hostNameEdit">Host Name</label></td>
       <td class="<%= tc %> bold" valign="middle" nowrap>
         <span id="hostName"><%= hostStr %></span>
         <input type="text" name="hostNameEdit" id="hostNameEdit" size="22" style="display:none">
       </td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>

<% tc = "lightRow"; %>

     <tr>
       <td class="<%= tc %>" height="25" valign="middle">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap><label for="hostPortEdit">Host Port</label></td>
       <td class="<%= tc %> bold" valign="middle" nowrap>
         <span id="hostPort"><%= portStr %></span>
         <input type="text" name="hostPortEdit" id="hostPortEdit" size="6" maxlength="5" style="display:none">
       </td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>

<% tc = "darkRow"; %>

     <tr>
       <td class="<%= tc %>" height="25" valign="middle">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Compression</td>
       <td class="<%= tc %> bold" valign="middle" nowrap>
         <span id="compression"><label for="compressionEdit"><%= compressionStr %></label></span>
         <select name="compressionEdit" id="compressionEdit" style="display:none">
           <option name="compression0"><%= compLevelToString(0)%></option>
           <option name="compression1"><%= compLevelToString(1)%></option>
           <option name="compression2"><%= compLevelToString(2)%></option>
           <option name="compression3"><%= compLevelToString(3)%></option>
           <option name="compression4"><%= compLevelToString(4)%></option>
           <option name="compression5"><%= compLevelToString(5)%></option>
           <option name="compression6"><%= compLevelToString(6)%></option>
           <option name="compression7"><%= compLevelToString(7)%></option>
           <option name="compression8"><%= compLevelToString(8)%></option>
           <option name="compression9"><%= compLevelToString(9)%></option>
         </select>
       </td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>

<% tc = "buttonBar"; %>

     <tr>
       <td class="<%= tc %>">&nbsp;</td>
       <td class="<%= tc %>" colspan="2" valign="middle" align="center">
         <button id="edit" name="edit" style="width:80px" onClick="editFn();">Edit</button>&nbsp;&nbsp;&nbsp;&nbsp;
         <button id="save" name="save" style="width:80px"onClick="saveFn();" disabled>Save</button>&nbsp;&nbsp;&nbsp;&nbsp;
         <button id="cancel" name="cancel" style="width:80px"onClick="cancelFn();" disabled>Cancel</button></td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>
   </table>

   <p/>

<% tc = "darkRow"; %>

   <div class="title">Activity Information</div>
   <table id="activityinfo" name="activityinfo" border="0" cellpadding="2" cellspacing="0">
     <tr><td colspan="4" style="background-image: url(dot.gif);"></td></tr>
     <tr>
       <td class="<%= tc %>" width="20" height="25">&nbsp;</td>
       <td class="<%= tc %>" width="180" valign="middle" nowrap>Server Time</td>
       <td class="<%= tc %> bold" width="180" id="serverTime" valign="middle" nowrap>Unknown</td>
       <td class="<%= tc %>" width="20">&nbsp;</td>
     </tr>
<% tc = "lightRow"; %>
     <tr>
       <td class="<%= tc %>" width="20" height="25">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Total Processing Time</td>
       <td class="<%= tc %> bold" id="processingTime" valign="middle" nowrap>Unknown</td>
       <td class="<%= tc %>" width="20">&nbsp;</td>
     </tr>
<% tc = "darkRow"; %>
     <tr>
       <td class="<%= tc %>" height="25">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Total Requests</td>
       <td class="<%= tc %> bold" id="totalRequests" valign="middle" nowrap>Unknown</td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>
<% tc = "lightRow"; %>
     <tr>
       <td class="<%= tc %>" height="25">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Failed Requests</td>
       <td class="<%= tc %> bold" id="failedRequests" valign="middle" nowrap>Unknown</td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>
<% tc = "darkRow"; %>
     <tr>
       <td class="<%= tc %>" height="25">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Active Requests</td>
       <td class="<%= tc %> bold" id="activeRequests" valign="middle" nowrap>Unknown</td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>
<% tc = "lightRow"; %>
     <tr>
       <td class="<%= tc %>" height="25">&nbsp;</td>
       <td class="<%= tc %>" valign="middle" nowrap>Memory (megabytes)</td>
       <td class="<%= tc %> bold" id="memoryUsage" valign="middle" nowrap>Unknown</td>
       <td class="<%= tc %>">&nbsp;</td>
     </tr>
   </table>

   <table style="margin-left:10px;" border="0" cellpadding="2" cellspacing="4">
   <tr>
     <td><label for="refreshRate">Refresh status interval</label>
       <select id="refreshRate" name="refreshRate" onchange="controller.reloadPage();currentMillis = this[this.selectedIndex].value;">
        <option value="2000">2 seconds</option>
        <option value="4000">4 seconds</option>
        <option value="6000">6 seconds</option>
        <option value="10000">10 seconds</option>
        <option value="15000">15 seconds</option>
        <option value="20000">20 seconds</option>
        <option value="30000" selected>30 seconds</option>
        <option value="45000">45 seconds</option>
        <option value="60000">1 minute</option>
        <option value="120000">2 minutes</option>
        <option value="300000">5 minutes</option>
       </select>
     </td>
     <td align="right"><input type="button" id="reload" style="width:100px;margin-left:10px;" value="Reload Now" onclick="controller.reloadPage();">&nbsp;</td>
   </tr>
   </table>

   <div class="note">For DHTML clients only.</div>

   <p/>

   <button name="close" id="Close" style="width:80px;margin-left:10px;" onClick="closeWindow()">Close</button>
</body>
</html>
