<%@ page import="com.alphablox.server.Server" %>
<%@ page import="com.alphablox.resource.AlphaBlox" %>
<%@ taglib uri='bloxtld' prefix='blox'%>

<%
    final String contextName = Server.getServerContextName();
%>

<html>
<head>

<title>DHTML Client Browser Compatibility Verification</title>

<SCRIPT LANGUAGE="javascript" src="/<%= contextName %>/jslib/browserCheck.js"></SCRIPT>

<script>

var haveLanguage = <%= request.getHeader( "accept-language" ) != null ? "true" : "false" %>;

function determineProblem( )
{
    var problem = getDHTMLBrowserProblemCode();

    if ( problem != BROWSER_NOT_MSIE ) {
        browserApplication.style.display = "none";

        switch ( problem )
        {
            case BROWSER_IS_COMPATIBLE:
                browserCompatible.style.display = "inline";
                break;
            case BROWSER_NOT_V55_OR_LATER:
                browserVersion.style.display = "inline";
                break;
            case BROWSER_BAD_SCRIPT_ENGINE:
                scriptVersion.style.display = "inline";
                break;
            case BROWSER_BAD_XMLHTTP_VERSION:
                xmlVersion.style.display = "inline";
                break;
        }
    }

    if ( haveLanguage == false )
        languageMissing.style.display = "inline";
}
</script>

<%
	String theme = (request.getParameter("theme") != null) ? request.getParameter("theme") : Server.getServer().getDefaultTheme();
	String themeImagePath = (!theme.equalsIgnoreCase("purple")) ? "/" + contextName + "/theme/"+theme+"/i/" : "/" + contextName + "/theme/i/";
	String copyright = AlphaBlox.getDefaultString(AlphaBlox.COPYRIGHT);
%>

<LINK REL="stylesheet" HREF="/<%= contextName %>/theme/<%= theme %>/<%= theme %>.css" TYPE="text/css">
<LINK REL="stylesheet" HREF="/<%= contextName %>/theme/<%= theme %>/<%= theme %>_dhtml.css" TYPE="text/css">
<LINK REL="stylesheet" HREF="/<%= contextName %>/theme/<%= theme %>/dhtml_view.css" TYPE="text/css">

</head>

<body onload="determineProblem();" class="csApBg csBckClr">

<form>

	<DIV id="dialogGuts" align="center" valign="middle">

	<TABLE cellspacing="0" cellpadding="0" border="0" style="WIDTH: 100%; HEIGHT: 100%">
		<TR>
			<TD align="center" valign="middle">

		<DIV class="csLblFnt csThmClr csCmpBrdr csCmpBg csDlg" style="WIDTH: 410px;">
			<TABLE style="WIDTH: 400px; HEIGHT: 185px" cellspacing="0" cellpadding="0" border="0">
				<TBODY>
					<TR>
						<TD><SPAN style="FONT-SIZE: 1pt; WIDTH: 10px; HEIGHT: 10px"></SPAN>
						</TD>
					</TR>
					<TR>
						<TD>
							<DIV class="csCmpBg csFntClr csDlgCntrl">
								<TABLE cellspacing="0" cellpadding="0" border="0">
									<TBODY>
										<TR>
											<TD valign="top"><SPAN style="FONT-SIZE: 1pt; WIDTH: 20px; HEIGHT: 10px"></SPAN>
											</TD>
											<TD valign="top">
												<img src="<%= themeImagePath %>/brand.gif" alt="<%= copyright %>" border="0" hspace="10">
											</TD>
											<TD valign="middle">

<div id="browserApplication" style="display:inline;">
<h1 class="legend">Your browser is not supported by the Alphablox DHTML client</h1><br>
<span class="label">Cause of the problem:</span><br>
<span class="label">
You must use Microsoft Internet Explorer 5.5 or later.</span>
</div>

<div id="browserCompatible" style="display:none;">
<h1 class="legend">Your installed browser is compatible with the Alphablox DHTML client!</h1><br>
</div>

<div id="browserVersion" style="display:none;">
<h1 class="legend">Your browser is not supported by the Alphablox DHTML client</h1><br>
<span class="label">Cause of the problem:</span><br>
<span class="label">
You must upgrade Microsoft Internet Explorer to version 5.5 or later.</span>
</div>

<div id="scriptVersion" style="display:none;">
<h1 class="legend">Your browser is not supported by the Alphablox DHTML client</h1><br>
<span class="label">Cause of the problem:</span><br>
<span class="label">
You must upgrade the scripting engine used by Internet Explorer to version 5.5 or later.</span>
</div>

<div id="xmlVersion" style="display:none;">
<h1 class="legend">Your browser is not supported by the Alphablox DHTML client</h1><br>
<span class="label">Cause of the problem:</span><br>
<span class="label">
You must upgrade the installed MSXML parser to version 3.0 service pack 2 or later.<!--   See <a href="http://msdn.microsoft.com/downloads/list/xmlgeneral.asp">MSXML downloads</a>. --></span>
</div>

<div id="languageMissing" style="display:none;">
<br>
<h1 class="legend"><b>Warning: A language preference is not set in this browser.  This condition can prevent communication with the server in some Internet Explorer installations.  To address this, use the Languages button in Tools - Internet Options... to set a preferred language. </h1><br>
</div>

											</TD>
											<TD><SPAN style="FONT-SIZE: 1pt; WIDTH: 20px; HEIGHT: 10px"></SPAN>
											</TD>
										</TR>
									</TBODY>
								</TABLE>
							</DIV>
						</TD>
					</TR>
					<TR>
						<TD><SPAN style="FONT-SIZE: 1pt; WIDTH: 10px; HEIGHT: 10px"></SPAN>
						</TD>
					</TR>
					<TR>
						<TD align="right">
							<DIV class="csCmpBg csFntClr csDlgCntrl">
								<TABLE cellspacing="0" cellpadding="0" border="0">
									<TBODY>
										<TR>
											<TD>
												<INPUT class="csCmpBg csThmClr csCmpBrdr csBtn csDfltBtnWdth" onclick="window.history.back()" type="button" value="Back" name="back">
											</TD>
											<TD width="20px">
											</TD>
										</TR>
									</TBODY>
								</TABLE>
							</DIV>
						</TD>
					</TR>
					<TR>
						<TD align="center">
						    <br>
							<SPAN class="csLblFnt csThmClr"><%= copyright %></SPAN>
						</TD>
					</TR>
					<TR>
						<TD><SPAN style="FONT-SIZE: 1pt; WIDTH: 10px; HEIGHT: 10px"></SPAN>
						</TD>
					</TR>
				</TBODY>
			</TABLE>
		</DIV>

			</TD>
		</TR>
	</TABLE>

	</DIV>

</form>

</body>
</html>
