<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.alphablox.blox.comments.CommentSet,
                 java.util.Arrays,
                 com.alphablox.blox.comments.Comment,
                 com.alphablox.server.Server,
                 com.alphablox.resource.Messages,
                 com.alphablox.blox.*,
                 com.alphablox.util.ObjectComparator"%>
<%@ taglib uri='bloxtld' prefix='blox'%>

<blox:resourceBundle bundle="com.alphablox.resource.AlphaBloxBundle" />

<blox:bloxContext />

<%
    String context = request.getParameter("context");
    String bloxName = request.getParameter("bloxName");

    if (context == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NEW_INVALID_PARAMS, new Object[]{context}));

    CommentSet commentSet = (CommentSet) session.getAttribute(context + ".Comments.currentCommentSet");
    if (commentSet == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENTSET_FOUND, new Object[]{"commentNew.jsp"}));

    CommentsBlox commentsBlox = (CommentsBlox) session.getAttribute(context + ".Comments.currentCommentsBlox");
    if (commentsBlox == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENTBLOX_FOUND, new Object[]{"commentNew.jsp"}));

    String cellValue = (String) session.getAttribute(context + ".Comments.CellValue");

%>
<html>
<head>
    <title>New Comment</title>
    <%= AbstractBlox.renderHtmlHeader(bloxRequest, bloxResponse) %>
	<link href="comments.css" rel="stylesheet" type="text/css">

    <script language="JavaScript" src="commentUI.js"></script>
    <script language="JavaScript">
        // Setup the js variables defined in commentUI.js.
        context = "<%= context %>";

        // Setup the client blox so we can refresh the client immediatly.
        var blox;

        if (window.opener.<%= bloxName %> != null) {
            blox = window.opener.<%= bloxName %>;
        } else {
            blox = window.opener.opener<%= bloxName %>;
        }

        noCommentTextMessage = '<%= Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENT_TEXT) %>';
        confirmCommentDeleteMessage = '<%= Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_CONFIRM_COMMENT_DELETE) %>';
    </script>
</head>

<body class="csCmpBg csCmpBrdr csWndwClr" onload="document.saveForm.elements[0].focus();">

<form name="saveForm" method="post" action="saveComment.jsp">

<table width="100%" cols="3" border="0" align="center" class="clsMenuOptions">
<%
    String[] fieldNames = commentsBlox.getFieldNames();
    Arrays.sort(fieldNames, ObjectComparator.getStringComparator(bloxContext.getLocale()));

    if (contains(Comment.FIELD_CELLVALUE,fieldNames)) {
    %>
        <tr>
            <td width="20%" class="heading"><blox:message key="COMMENTS_DIALOG_CELLVALUE"/>:</td>
            <td colspan="2" class="reduced"><%= cellValue %></td>
        </tr>
    <%
    }

    for (int i = 0; i < fieldNames.length; i++) {
        String fieldName = fieldNames[i];
        if (!CommentsBlox.isProtectedField(fieldName) &&
                !Comment.FIELD_CELLVALUE.equals(fieldName)) {   %>
            <tr>
            <td width="20%" class="heading"><%= fieldName %>:</td>
            <td colspan="2">
                <input type="text" name="field_<%= i %>"
                    class="reduced"
                    style="width:100%"
                    tabindex="<%= i+1 %>"/>
            </td>
            </tr><%
        }
    }
%>
    <tr><td colspan="3">&nbsp;</td></tr>

    <tr>
        <td colspan="3" class="heading" style="text-align: left"><blox:message key="COMMENTS_DIALOG_COMMENTTEXT"/>:</td>
    <tr>
        <td colspan="3">
        <textarea rows="8" name="field_<%= Comment.FIELD_COMMENTTEXT %>"
            class="reduced"
            style="width: 100%;"
            tabindex="<%= fieldNames.length+1 %>"></textarea>
        </td>
    </tr>
</table>
<br />
<!-- buttons -->
<div style="width: 100%; text-align: center;">
    <span style="line-height:5px;"><br /></span>
    <a id="saveButton" href="javascript:saveComment( 'saveForm', 'field_<%=Comment.FIELD_COMMENTTEXT%>' );"
        onmouseover="this.style.border='thin outset';"
        onmouseout="this.style.border='thin groove';"
        onmousedown="this.style.border='thin inset';"
        onmouseup="this.style.border='thin outset';"
        class="button"><blox:message key="COMMENTS_DIALOG_SAVE"/></a>
    <a id="cancelButton" href="javascript:cancelComment();"
        onmouseover="this.style.border='thin outset';"
        onmouseout="this.style.border='thin groove';"
        onmousedown="this.style.border='thin inset';"
        onmouseup="this.style.border='thin outset';"
        class="button"><blox:message key="COMMENTS_DIALOG_CANCEL"/></a>

    <!-- Spacer -->
    <span style="line-height:5px;"><br /><br /></span>
</div>

<input type="hidden" name="field_<%= Comment.FIELD_CELLVALUE %>" value="<%= cellValue %>" />

</form>

</body>
</html>


<%!
    public boolean contains(String field, String[] fieldNames) {
        for (int x = 0; x < fieldNames.length; x++) {
            if (field.equals(fieldNames[x]))
                return true;
        }
        return false;
    }
%>