// JavaScript for listing comments and displaying a single comment.

// These 4 variables need to be set in the including JSP.
var context;
var blox;
var noCommentTextMessage;
var confirmCommentDeleteMessage;
var _themeName;

// Load commentDisplay.jsp into the bottom half.

function sortComments( field ) {
    var queryString = "eventName=eventSortComments&context=" + context + "&sortField=" + field;

    var result = talkToServer("commentsUIController.jsp", queryString);

    //Only reload the page if things went smoothly
    if (!showErrorMessage(result)) {
        refreshClientBlox();
        window.location.reload();
    }
}

function displayComment( index ) {
    var queryString = "theme=" + _themeName
        + "&commentIndex=" + index
        + "&context=" + context;

    var result = talkToServer("commentDisplay.jsp", queryString);

    document.getElementById("commentDiv").innerHTML = result;
}

// Open commentNew.jsp in a new window.
function newComment() {
    var url = "commentNew.jsp?theme=" + _themeName
        + "&bloxName=" + blox.getName()
        + "&context=" + context;

    var windowName = "newComment";
    var windowFeatures = "height=300,width=400,resizable,scrollbars,titlebar=no";

    var newCommentWindow = window.open(url, windowName, windowFeatures);
    newCommentWindow.focus();
}

// Call deleteComment.jsp
function deleteComment(formName) {
    var deleteLink = document.getElementById("deleteLink");
    var indexes = new Array();
    var listForm = document.getElementById(formName);
    var isCommentSelected = false;
    var queryString = "eventName=deleteComment&context=" + context;

    if (deleteLink.disabled)
        return;

    // Get the post parameters from the form.
    for(var i=0; i<listForm.elements.length; i++) {
        name = listForm.elements[i].name;
        value = listForm.elements[i].value;

        if (name == "commentsSelected" && listForm.elements[i].checked) {
            queryString += "&commentsSelected=" + i;
	        isCommentSelected=true;
        }
    }

    if( isCommentSelected ) {
        if (!confirm(confirmCommentDeleteMessage))
            return;

        var result = talkToServer("commentsUIController.jsp", queryString);

        // Only reload the page if things went smoothly
        if (!showErrorMessage(result)) {
            refreshClientBlox();
            window.location.reload();
        }
    }
}

/*
 *  APIs for the new comment dialog
 */
function saveComment( formName, commentTextFieldName ) {
    var saveForm = document.getElementById( formName );

    var commentText = eval("saveForm." + commentTextFieldName + ".value");
    if (commentText.length == 0) {
        alert(noCommentTextMessage);
        return;
    }

    var queryString = "eventName=saveComment"
            + "&context=" + context;

    for(var i=0; i<saveForm.elements.length; i++) {
        name = encodeURIComponent( saveForm.elements[i].name );
        value = encodeURIComponent( saveForm.elements[i].value );

        queryString += "&" + name + "=" + value;
    }

    var response = talkToServer("commentsUIController.jsp", queryString);

    if (!showErrorMessage(response)) {
        // Only reload if the parent window if it is a list of comments.
        if (window.opener.name == "eventDisplayComments") {
            window.opener.location.reload();
        } else {
            refreshClientBlox();
        }
        window.close();
    }
}

function cancelComment() {
    window.close();
}

// Enable or Disable the Delete link based on if any comments are currently selected
function enableOrDisableDeleteLink() {
    var listForm = document.getElementById('listForm');
    var deleteLink = document.getElementById("deleteLink");

    for(var i=0; i<listForm.elements.length; i++) {
        if (listForm.elements[i].name == "commentsSelected" && listForm.elements[i].checked) {
            deleteLink.disabled=false;
            return;
        }
    }
    deleteLink.disabled=true;
}

// Checks what is returned from the server for any
// error messages.
//      return: true if there was an error
function showErrorMessage(message) {
	if (message.indexOf("Error") != -1 || message.indexOf("Exception") != -1) {
		alert(message);
		return true;
	}

	return false;
}

// Checks what is returned from the server for any
// error messages.
var errorMessage;
var detailedErrorMessage;
function showErrorMessageWindow(message, details) {
	if (message.indexOf("Error") != -1) {
		errorMessage = message;
		detailedErrorMessage = details;

		var errorUrl = "errorPage.jsp";
		window.open(errorUrl, "errorWindow", "height=100,width=640,resizable");
		return true;
	}

	return false;
}

// Refresh the client blox
function refreshClientBlox() {
    blox.call("refresh.jsp");
}

// Use this method to make a call to the server.
function talkToServer(url, body) {
   // Use bloxHttp available from the blox:header
   var xmlhttp = bloxHttp._xmlHttp;

   xmlhttp.open("POST", url, false);
   xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
   xmlhttp.send(body);

   return xmlhttp.responseText;
}

