<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.alphablox.server.Server,
                 com.alphablox.resource.Messages,
                 com.alphablox.blox.comments.CommentSet,
                 com.alphablox.blox.comments.Comment,
                 com.alphablox.blox.comments.CommentComparator,
                 com.alphablox.server.session.SessionManager,
                 com.alphablox.util.TextFormat,
                 com.alphablox.blox.comments.CommentSetAddress,
                 com.alphablox.blox.data.mdb.MDBMetaData,
                 java.util.Comparator,
                 com.alphablox.blox.*"%>
<%@ taglib uri='bloxtld' prefix='blox'%>

<blox:resourceBundle bundle="com.alphablox.resource.AlphaBloxBundle" />

<blox:bloxContext />

<%
    String context = request.getParameter("context");
    if (context == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_LIST_INVALID_PARAMS, new Object[]{context}));

    CommentSet commentSet = (CommentSet) session.getAttribute(context+".Comments.currentCommentSet");
    DataBlox dataBlox = (DataBlox) session.getAttribute(context+".Comments.DataBlox");
    Comment[] comments = commentSet.getComments();
    CommentsBlox commentsBlox = dataBlox.getCommentsBlox();
    Comparator cc = commentsBlox.getCommentComparator();
%>
<!-- buttons -->
<form id="listForm" style="margin:0 0 0 0; padding:0 0 0 0;">

<table style="height:100%; width:100%;" cellpadding="0" cellspacing="0" border="0">
    <!-- Buttons -->
    <tr>
        <td>
<div class="cmntWrpr">
    <span style="line-height:5px;"><br /></span>    <!-- spacer -->
    <a href="javascript:newComment();"
        onmouseover="this.className='cmntBtnHghlght';"
        onmouseout="this.className='cmntBtn';"
        onmousedown="this.className='cmntBtnDprsd';"
        onmouseup="this.className='cmntBtnHghlght';"
        class="cmntBtn">
        <span class="clsMenuOptions"><blox:message key="COMMENTS_DIALOG_NEW"/></span>
    </a>

    <span class="vsprtr"></span>

    <a id="deleteLink" disabled
        href="javascript:deleteComment( 'listForm' );"
        onmouseover="this.className='cmntBtnHghlght';"
        onmouseout="this.className='cmntBtn';"
        onmousedown="this.className='cmntBtnDprsd';"
        onmouseup="this.className='cmntBtnHghlght';"
        class="cmntBtn" style="color:black;">
        <span class="clsMenuOptions"><blox:message key="COMMENTS_DIALOG_DELETE"/></span>
    </a>
    <span style="line-height:5px;"><br /><br /></span>      <!-- spacer -->
</div>
        </td>
    </tr>
    <!-- End of Buttons -->
    <tr><td>
        <table class="cmntWrpr" width="100%"><tr>
          <td><span class="heading"><blox:message key="COMMENTS_DIALOG_ADDRESS"/>:</span></td>
          <td><%= getCommentSetAddress(dataBlox, commentSet) %></td>
        </table>
    </td></tr>
    <!-- List of comments -->
    <tr>
        <td height="100%">
<div class="cmntWrpr" style="position:relative; height:100%; overflow:auto; background-color:white;">
    <table cols="4" border="0" cellpadding="2" cellspacing="1" width="100%">
        <!-- Column Headers -->
        <tr class="clsColumnHeaders" style="text-align: left; font-weight:bold;">
            <td class="clsColumnHeaders" width="5%" align="center" valign="baseline"><blox:message key="COMMENTS_DIALOG_SELECT"/></td>
            <td class="clsColumnHeaders" style="cursor:default" width="95" valign="baseline" onclick="javascript:sortComments('Comment');"><blox:message key="COMMENTS_DIALOG_COMMENTTEXT"/>&nbsp;<%= getSortImageStr(Comment.FIELD_COMMENTTEXT,cc) %></td>
            <td class="clsColumnHeaders" style="cursor:default" width="10%" valign="baseline" onclick="javascript:sortComments('Author');"><blox:message key="COMMENTS_DIALOG_AUTHOR"/>&nbsp;<%= getSortImageStr(Comment.FIELD_AUTHOR,cc) %></td>
            <td class="clsColumnHeaders" style="cursor:default" width="1%" nowrap align="left" valign="baseline" onclick="javascript:sortComments('Date');"><blox:message key="COMMENTS_DIALOG_TIMESTAMP"/><%= getSortImageStr(Comment.FIELD_TIMESTAMP,cc) %></td>
        </tr>

        <!-- Loop through all comments -->
<%
    BloxContext bloxContext = BloxContextFactory.getBloxContext(request, response);
    BloxRequest bloxRequest = bloxContext.registerRequest(request, response);

    for (int commentIdx = 0; commentIdx < comments.length; commentIdx++) {
        Comment comment = comments[commentIdx];
        String displayUrl = "javascript:displayComment(" + commentIdx + ");";
        String commentText = comment.getCommentText();
        String commentHTML;

        if (commentText.length() > 40) {
            commentText = commentText.substring(0,40) + "...";
        }

        if (commentText.trim().length() > 0)
            commentHTML = deHTMLify(commentText);
        else
            commentHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
%>
        <tr class="clsDataCell" style="text-align: left;">
            <td width="5%" align="center" valign="baseline">
                <input type="checkbox" name="commentsSelected" value="<%= commentIdx %>" onClick="enableOrDisableDeleteLink()"
                       <%= (comment.getAuthor() != null && comment.getAuthor().equalsIgnoreCase(bloxRequest.getBloxSession().getUser())) ? "" : " disabled"%>>
            </td>
            <td width="95" valign="baseline">
                <a href="javascript:" onclick="<%= displayUrl %>">
                <%= commentHTML %>
                </a></td>
            <td width="10%" valign="baseline"><%=comment.getAuthor()%></td>
            <td width="1%" align="right" nowrap valign="baseline"><%=comment.getTimestamp()%></td>
        </tr>
        <%
    }
%>
    </table>
</div>
        </td>
    </tr>
    <!-- End of List of Comments -->
</table>

</form>

<%!
    static private String[][] entities = {
        {"&", "&amp;"},     // This must be first, because this array is used to do substitutions, and we can't
        {"\"", "&quot;"},   // have & being substituted in the following strings.
        {"<", "&lt;"},
        {">", "&gt;"}
    };

    public String getSortImageStr(String field, Comparator comparator) {
        String descImage = "<IMG SRC=\"descTriangle.gif\">";
        String ascImage = "<IMG SRC=\"ascTriangle.gif\">";

        if (comparator != null && !(comparator instanceof CommentComparator))
            return "";

        CommentComparator commentComparator = (CommentComparator)comparator;

        if(commentComparator == null) {
            if(field.equals(Comment.FIELD_TIMESTAMP)) {
                return descImage;
            }
        }
        else {
            if(commentComparator.getField().equals(field)) {
                return (commentComparator.getOrder() == CommentComparator.DESCENDING) ? descImage : ascImage;
            }
        }

        return "";
    }

    public String deHTMLify(String s) {
        for (int idx = 0; idx < entities.length; idx++) {
            String[] entity = entities[idx];

            if (s.indexOf(entity[0]) >= 0) {
                s= TextFormat.replace(s, entity[0], entity[1]);
            }
        }

        return s;
    }

    public String getCommentSetAddress(DataBlox dataBlox, CommentSet commentSet) {
        StringBuffer buffer = new StringBuffer();

        try {
            CommentSetAddress commentSetAddress=commentSet.getAddress();

            String[] dimensions=commentSetAddress.getDimensions();
            MDBMetaData metaData = (MDBMetaData) dataBlox.getMetaData();

            for (int x = 0; x < dimensions.length; x++) {
                // get the unique names
                String dimension = dimensions[x];
                String member = commentSetAddress.getDimensionMember(dimension);

                String dimensionName = dimension;
                String memberName = member;

                try {
                    // convert the unique names to display names
                    dimensionName = metaData.resolveDimension(dimension).getDisplayName();
                    memberName = metaData.resolveMember(member).getDisplayName();
                } catch (Exception e) {
                }

                if (x > 0)
                    buffer.append(", ");

                buffer.append(dimensionName).append(": ");
                buffer.append(memberName);
            }

            return deHTMLify(buffer.toString());
        } catch (Exception e) {
            // We don't know what happened... but we'll set the address to ""
            return "";
        }
    }
%>