<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.alphablox.util.Message,
                 com.alphablox.blox.comments.Comment,
                 com.alphablox.blox.comments.CommentComparator,
                 com.alphablox.blox.data.mdb.MDBResultSet,
                 com.alphablox.blox.data.mdb.Cell,
                 com.alphablox.blox.comments.CommentSet,
                 com.alphablox.server.session.SessionManager,
                 com.alphablox.server.service.ServiceManager,
                 com.alphablox.server.session.Session,
                 com.alphablox.server.Server,
                 com.alphablox.resource.Messages,
                 com.alphablox.server.request.DecodedServletRequest,
                 java.util.Comparator,
                 com.alphablox.blox.*,
                 com.alphablox.blox.data.mdb.Axis,
                 java.util.Locale"%>
<%@ taglib uri='bloxtld' prefix='blox'%>

<blox:bloxContext />

<%
    DecodedServletRequest decodedRequest = new DecodedServletRequest();
    decodedRequest.initialize(bloxRequest);

    String mdbBloxName = decodedRequest.getParameter("mdbBloxName");
    String columnString = decodedRequest.getParameter("col");
    String rowString = decodedRequest.getParameter("row");
    String eventName = decodedRequest.getParameter("eventName");
    String appName = decodedRequest.getParameter("appName");
    String abSessionId = decodedRequest.getParameter("abSessionId");
    String cellValue = decodedRequest.getParameter("value");
	String themeName =  decodedRequest.getParameter("theme");

    BloxContext applicationBloxContext = bloxContext.getBloxContextByApplication(appName);
    Blox mdbBlox;

    if(applicationBloxContext != null) {
	mdbBlox = applicationBloxContext.getBlox(mdbBloxName);
    }
    else {
        mdbBlox = bloxContext.getBlox(mdbBloxName);
    }

    // The cellValue was not supplied in the query string until post 5.0... so this is done for backward compatibility.
    if (cellValue == null)
        cellValue = "";

    // Redirect depending on the passed in eventName
    if ("eventAddComments".equals(eventName)) {
        try {
            String context = initializeContext(bloxContext, session, mdbBlox, rowString, columnString, cellValue,
                appName, abSessionId);
            %>
            <jsp:forward page="commentNew.jsp">
                <jsp:param name="context" value="<%= context %>" />
                <jsp:param name="bloxName" value="<%= mdbBloxName %>" />
            </jsp:forward>  <%
        } catch (Exception e) {
            // If there is an exception, forward off to the error handler.
            new Message(Message.ERROR, "Add Comment Dialog", e).send();
            String exceptionParam = session.getId() + "." + mdbBloxName + ".Comments.exception";
            session.setAttribute(exceptionParam , e);
            %>
            <jsp:forward page="errorPage.jsp">
                <jsp:param name="error" value="Error opening Add Comment dialog." />
                <jsp:param name="detailsParam" value="<%= exceptionParam %>" />
            </jsp:forward>  <%
        }
    }
    else if ("eventDisplayComments".equals(eventName)) {
        try {
            String context = initializeContext(bloxContext, session,
                    mdbBlox, rowString, columnString, cellValue,
                appName, abSessionId);
            %>
            <jsp:forward page="cellCommentsDisplay.jsp">
                <jsp:param name="context" value="<%= context %>" />
                <jsp:param name="bloxName" value="<%= mdbBloxName %>" />
				<jsp:param name="themeName" value="<%= themeName %>" />
            </jsp:forward>  <%
        } catch (Exception e) {
            // If there is an exception, forward off to the error handler.
            String exceptionParam = session.getId() + "." + mdbBloxName + ".Comments.exception";
            session.setAttribute(exceptionParam , e);
            %>
            <jsp:forward page="errorPage.jsp">
                <jsp:param name="error" value="Error opening Display Comments dialog." />
                <jsp:param name="detailsParam" value="<%= exceptionParam %>" />
            </jsp:forward>  <%
        }
    }
    else if ("eventSortComments".equals(eventName)) {
        try {
            String sortField = decodedRequest.getParameter("sortField");
            String context = decodedRequest.getParameter("context");
            DataBlox mdbDataBlox = (DataBlox)session.getAttribute(context+".Comments.DataBlox");
            mdbBloxName = mdbDataBlox.getBloxName();
            sortComments(session, context, mdbDataBlox, sortField, bloxContext.getLocale());
            %>
            <jsp:forward page="cellCommentsDisplay.jsp">
                <jsp:param name="context" value="<%= context %>" />
                <jsp:param name="bloxName" value="<%= mdbBloxName %>" />
            </jsp:forward>  <%
        } catch (Exception e) {
            // If there is an exception, forward off to the error handler.
            String exceptionParam = session.getId() + "." + mdbBloxName + ".Comments.exception";
            session.setAttribute(exceptionParam , e);
            %>
            <jsp:forward page="errorPage.jsp">
                <jsp:param name="error" value="Error opening Display Comments dialog." />
                <jsp:param name="detailsParam" value="<%= exceptionParam %>" />
            </jsp:forward>  <%
        }
    }
    else if ("saveComment".equals(eventName)) {
        %>
        <jsp:forward page="saveComment.jsp" />  <%
    }
    // This isn't even being used right now.
    else if ("deleteComment".equals(eventName)) {
        %>
        <jsp:forward page="deleteComment.jsp" />  <%
    }
    else {
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_UNKNOWN_EVENT_TYPE, new Object[]{ eventName }));
    }
%>

<%!
public void sortComments(HttpSession session, String context, DataBlox mdbDataBlox, String sortField, Locale locale) throws Exception {
    String columnString = (String) session.getAttribute(context+".Comments.ColumnCoordinates");
    String rowString = (String) session.getAttribute(context+".Comments.RowCoordinates");
    int column = Integer.parseInt( columnString );
    int row = Integer.parseInt( rowString );

    //Set the sort
    if(sortField != null) {
        if(sortField.equals("Comment")) {
            sortField = Comment.FIELD_COMMENTTEXT;
        }
        else if(sortField.equals("Author")) {
            sortField = Comment.FIELD_AUTHOR;
        }
        else if(sortField.equals("Date")) {
             sortField = Comment.FIELD_TIMESTAMP;
        }

        CommentsBlox commentBlox = mdbDataBlox.getCommentsBlox();
        Comparator comparator = commentBlox.getCommentComparator();

        int prevOrder = 0;
        String prevField = null;

        if(comparator != null && (comparator instanceof CommentComparator)) {
            prevOrder = ((CommentComparator)comparator).getOrder();
            prevField = ((CommentComparator)comparator).getField();
            if(sortField.equals(prevField)) {
                comparator = new CommentComparator(sortField, prevOrder * -1, locale);
             }
             else {
                comparator = new CommentComparator(sortField, CommentComparator.ASCENDING, locale);
             }
         }
         else {
             comparator = new CommentComparator(sortField, CommentComparator.ASCENDING, locale);
         }

         commentBlox.setCommentComparator(comparator);
    }

    // Now that we have a data blox, get the current commentSet and commentsBlox
    // and store them in the session.
    MDBResultSet resultSet = (MDBResultSet) mdbDataBlox.getResultSet();
    Cell cell = null;
	if(resultSet.getAxisCount() == 2) {
		cell = resultSet.getCells().getCell(column, row);
	}
	else {
		Axis columnAxis = resultSet.getAxis(Axis.COLUMN_AXIS);
		if(columnAxis != null) {
			cell = resultSet.getCells().getCell(column);
		}
		else {
			cell = resultSet.getCells().getCell(row);
		}
	}

    CommentSet sortedCommentSet = cell.getCommentSet();

    session.setAttribute(context+".Comments.currentCommentSet", sortedCommentSet);

    return;
}

public String initializeContext(BloxContext bloxContext,
                              HttpSession session,
                              Blox mdbBlox,
                              String rowString,
                              String columnString,
                              String cellValue,
                              String appName,
                              String abSessionId) throws Exception
{
//    System.out.println("Inside initializeContext");
    // Verify the decodedRequest parameters
    if (mdbBlox == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NULL_NOT_ALLOWED, new Object[]{"mdbBlox"}));

    if (columnString == null || rowString == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NULL_NOT_ALLOWED, new Object[]{"Row and Column"}));

    if (appName == null || abSessionId == null) {
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NULL_NOT_ALLOWED, new Object[]{"AppName and AbxSessionId"}));
    }

    int column = Integer.parseInt( columnString );
    int row = Integer.parseInt( rowString );

    // Get the MDB data blox.
    DataBlox mdbDataBlox = null;

    if (mdbBlox instanceof DataViewBlox) {
        mdbDataBlox = ((DataViewBlox) mdbBlox).getDataBlox();
    }
    else if (mdbBlox instanceof DataBlox) {
        mdbDataBlox = (DataBlox) mdbBlox;
    } else {
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_INVALID_MDBBLOX, new Object[]{mdbBlox}));
    }

    // Now that we have a data blox, get the current commentSet and commentsBlox
    // and store them in the session.
    MDBResultSet resultSet = (MDBResultSet) mdbDataBlox.getResultSet();
    Cell cell = null;
	if(resultSet.getAxisCount() == 2) {
		cell = resultSet.getCells().getCell(column, row);
	}
	else {
		Axis columnAxis = resultSet.getAxis(Axis.COLUMN_AXIS);
		if(columnAxis != null) {
			cell = resultSet.getCells().getCell(column);
		}
		else {
			cell = resultSet.getCells().getCell(row);
		}
	}

    CommentSet commentSet = cell.getCommentSet();

    // The mdbBloxName will be the context for all session variables
    String context = session.getId() + "." + mdbDataBlox.getBloxName();
    session.setAttribute(context+".Comments.currentCommentSet", commentSet);
    session.setAttribute(context+".Comments.currentCommentsBlox", mdbDataBlox.getCommentsBlox());
    session.setAttribute(context+".Comments.DataBlox", mdbDataBlox);
    //Need the cell column/row coordinates in order to find the correct CommentsSet to sort
    session.setAttribute(context+".Comments.ColumnCoordinates", columnString);
    session.setAttribute(context+".Comments.RowCoordinates", rowString);
    session.setAttribute(context+".Comments.CellValue", cellValue);

    return context;
}
%>