<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="java.io.ByteArrayOutputStream,
                 java.io.PrintStream,
                 com.alphablox.server.request.DecodedServletRequest"%>
<%@ taglib uri='bloxtld' prefix='blox'%>
<blox:resourceBundle bundle="com.alphablox.resource.AlphaBloxBundle" />

<%
    DecodedServletRequest decodedRequest = new DecodedServletRequest();
    decodedRequest.initialize(request);

    String error = decodedRequest.getParameter("error");
    String detailsParamName = decodedRequest.getParameter("detailsParam");

    Exception exception = (Exception) session.getAttribute( detailsParamName );
%>

<html>
<head>
    <title><blox:message key="COMMENTS_DIALOG_ERROR_TITLE" /></title>
    <link href="styles.css" rel="stylesheet">
    <style>
    .detailDiv {
        height:100%;
        width:100%;
        border:thin inset;
        background-color:white;
        text-align: left;
        overflow:auto;
    }
    .errorPage {
        background-color: #C0C0C0;
        font: 9pt Arial, Helvetica, sans-serif;
        border: 0px;
    }
    </style>
    <script>
    function showError() {
        document.getElementById("errorDiv").innerHTML = "<blox:message key="COMMENTS_DIALOG_ERROR" />: <%=error%>";
        document.getElementById("closeButton").focus();
    }

    var isHidden = true;
    var hiddenHeight = null;
    var visibleHeight = null;

    function showDetails() {
        var buttonText;
        var detailsDiv = document.getElementById("detailsDiv");

        if (isHidden) {
            hiddenHeight = document.body.clientHeight;
            if (visibleHeight == null)
                visibleHeight = hiddenHeight + 75;

            window.resizeBy(0, +(visibleHeight - hiddenHeight));

            buttonText = '<blox:message key="COMMENTS_DIALOG_ERROR_HIDE_DETAILS"/>';
            detailsDiv.style.display = "";
        } else {
            visibleHeight = document.body.clientHeight;
            window.resizeBy(0, -(visibleHeight - hiddenHeight));

            buttonText = '<blox:message key="COMMENTS_DIALOG_ERROR_SHOW_DETAILS"/>';
            detailsDiv.style.display = "none";
        }

        var button = document.getElementById("detailButton");
        button.value = buttonText;

        isHidden = !isHidden;
    }
    </script>
</head>

<body onload="showError();" class="errorPage">
    <div style="height:100%;width:100%;">
        <table height="100%" width="100%">
            <tr height="1">
                <td id="errorDiv" valign="top" style="font: bold 11pt;">
                </td>

                <td valign="top" align="right" nowrap>
                    <input type="button" id="detailButton" onclick="showDetails();" value='<blox:message key="COMMENTS_DIALOG_ERROR_SHOW_DETAILS"/>' tabindex="2" />
                    <input type="button" id="closeButton" onclick="window.close();" value='<blox:message key="COMMENTS_DIALOG_ERROR_CLOSE"/>' tabindex="1" />
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <div id="detailsDiv" class="detailDiv" style="position:absolute;display:none;border: solid 1px blue;">
                        <pre><b><%
                        ByteArrayOutputStream baos = new ByteArrayOutputStream();
                        exception.printStackTrace(new PrintStream(baos));
                        out.print(baos); %>
                        </b></pre>
                    </div>
                </td>
            </tr>
        </table>
    </div>
</body>
</html>