<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.alphablox.blox.comments.CommentSet,
                 com.alphablox.blox.comments.Comment,
                 com.alphablox.server.Server,
                 com.alphablox.resource.Messages,
                 com.alphablox.server.request.DecodedServletRequest,
                 java.util.Arrays,
                 com.alphablox.blox.*,
                 com.alphablox.util.ObjectComparator"%>
<%@ taglib uri='bloxtld' prefix='blox'%>

<blox:bloxContext />

<%
    DecodedServletRequest decodedRequest = new DecodedServletRequest();
    decodedRequest.initialize(bloxRequest);

    String context = decodedRequest.getParameter("context");

    if (context == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_SAVE_INVALID_PARAMS, new Object[]{context}));

    CommentSet commentSet = (CommentSet) session.getAttribute(context + ".Comments.currentCommentSet");
    if (commentSet == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENTSET_FOUND, new Object[]{"saveComment.jsp"}));

    CommentsBlox commentsBlox = (CommentsBlox) session.getAttribute(context + ".Comments.currentCommentsBlox");
    if (commentsBlox == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENTBLOX_FOUND, new Object[]{"saveComment.jsp"}));

    Comment comment = new Comment();

    String[] fieldNames = commentsBlox.getFieldNames();
    Arrays.sort(fieldNames, ObjectComparator.getStringComparator(bloxContext.getLocale()));

    for (int i = 0; i < fieldNames.length; i++) {
        if (!CommentsBlox.isProtectedField(fieldNames[i])) {
            String fieldValue = decodedRequest.getParameter("field_" + i);

            if (fieldValue != null) {
                String trimmedValue=fieldValue.trim();

                if (!trimmedValue.equals(""))
                    comment.setField( fieldNames[i], trimmedValue );
            }
        }
    }

    if (contains(Comment.FIELD_CELLVALUE, fieldNames)) {
        String cellValue = decodedRequest.getParameter("field_"+Comment.FIELD_CELLVALUE);
        if (!cellValue.equals(""))
            comment.setField(Comment.FIELD_CELLVALUE, cellValue);
    }
    comment.setField(Comment.FIELD_COMMENTTEXT, decodedRequest.getParameter("field_"+Comment.FIELD_COMMENTTEXT));

    commentSet.addComment( comment );
%>

<%!
    public boolean contains(String field, String[] fieldNames) {
        for (int x = 0; x < fieldNames.length; x++) {
            if (fieldNames[x].equals(field))
                return true;
        }
        return false;
    }
%>