<%@ taglib uri="bloxtld" prefix="blox" %>
<%@ page import="com.alphablox.blox.*" %>
<%@ page import="com.alphablox.blox.data.*" %>
<%@ page import="com.alphablox.blox.data.rdb.*" %>
<%@ page import="com.alphablox.server.session.Session,
                 com.alphablox.server.session.SessionManager,
                 com.alphablox.server.service.ServiceManager,
		         com.alphablox.net.URLFactory"%>
<%@ page errorPage="error.jsp" %>
<%@ page contentType='text/html; charset=UTF-8' %>


<html>
<blox:header />
<head>
<!-- using a stylesheet that defines the styles for the interactive context menus-->
	<link rel="stylesheet" href="<%= URLFactory.getServerURL( "/report/report.css")%>" />

	<style>

	h1 {
  		font-size: 16pt;
  		color: #993399;
  		font-family: "Trebuchet MS", Verdana, Arial, Helvetica, sans-serif; background-position: center
  	}

	p {
  		font-family: Trebuchet MS,Verdana, Arial, Helvetica, sans-serif;
  		font-size: 9pt;
  		font-style: normal;
  	}
	</style>
</head>
<body>

<%
	String bloxRef = request.getParameter("bloxRef");
	String columnCoordinate = request.getParameter("colIndex");
	String rowCoordinate = request.getParameter("rowIndex");
	String appName = request.getParameter("appName");
	String abSessionId = request.getParameter("abSessionId");
	String essReportName = request.getParameter("drillThroughReportName");

	if(bloxRef == null) {
		throw new RuntimeException("Cannot perform drill through without valid bloxRef");
	}

	if(columnCoordinate == null) {
		throw new RuntimeException("Cannot perform drill through without valid column coordinate");
	}

	if(rowCoordinate == null) {
		throw new RuntimeException("Cannot perform drill through without valid row coordinate");
	}

	if(appName == null) {
		throw new RuntimeException("Cannot perform drill through without valid appName");
	}

	if(abSessionId == null) {
		throw new RuntimeException("Cannot perform drill through without valid abSessionId");
	}

	// Get the MDB data blox.
   	Blox mdbBlox = null;
    DataBlox mdbDataBlox = null;

	BloxContext applicationBloxContext = bloxContext.getBloxContextByApplication(appName);

	if(applicationBloxContext != null) {
		mdbBlox =  applicationBloxContext.getBlox(bloxRef);
	}
    else {
    	mdbBlox = bloxContext.getBlox(bloxRef);
	}

    if (mdbBlox instanceof DataViewBlox) {
            mdbDataBlox = ((DataViewBlox) mdbBlox).getDataBlox();
   	}
    else if (mdbBlox instanceof DataBlox) {
        	mdbDataBlox = (DataBlox) mdbBlox;
    }
	else {
        	throw new RuntimeException("Referenced blox is of wrong type or null");
    }

	int column = Integer.parseInt( columnCoordinate );
    int row = Integer.parseInt( rowCoordinate );

	ReportBlox reportBlox;
	String reportName = request.getParameter("reportName");
	if(reportName == null) {
		reportName = "defaultName";
	}

	Object blox = session.getAttribute(reportName);
	if(blox != null) {
		reportBlox = (ReportBlox)blox;
	}
	else {
		reportBlox = new ReportBlox();
	}

	reportBlox.setId(reportName);
	reportBlox.setInteractive(true);

	RDBResultSetDataBlox rdbrsdb = new RDBResultSetDataBlox();
	if(essReportName != null) {
		rdbrsdb.setDrillThroughReportName(essReportName);
	}
	rdbrsdb.setColumnCoordinate(column);
	rdbrsdb.setRowCoordinate(row);
	rdbrsdb.setDataBlox(mdbDataBlox);
	rdbrsdb.getRDBResultSet();
        
    reportBlox.setInput(rdbrsdb);

	//This is a little weak :(
	if(applicationBloxContext != null) {
		reportBlox.setUrlPrefix(applicationBloxContext.getContextPath() + "/" + URLFactory.ALPHABLOX_SERVER_PREFIX);
	}
	else {
		reportBlox.setUrlPrefix(bloxContext.getContextPath() + "/" + URLFactory.ALPHABLOX_SERVER_PREFIX);
	}

	session.setAttribute(reportName,reportBlox);

	if(applicationBloxContext != null) {
		reportBlox.init(applicationBloxContext, reportName);
	}
	else {
		reportBlox.init(bloxContext, reportName);
	}

	reportBlox.write(out);
%>
</body>
</html>
