<%@ page import="com.alphablox.server.Server,
                 com.alphablox.resource.AlphaBlox,
                 com.alphablox.server.request.DecodedServletRequest"%>
<%@ page import="com.alphablox.net.URLFactory"%>

<%@ page contentType="text/html; charset=UTF-8" %>

<%-- Import the Blox custom tag libraries --%>
<%@ taglib uri="bloxtld" prefix="blox"%>

<html>
<head>
<blox:header/>

<%
    // Because the incoming title is in UTF-8 and because the web server messes with
    // it, this code is neccessary to get a Unicode version of the title that can be
    // inserted into the HTML page (then translated back to UTF-8).
    DecodedServletRequest decodedRequest = new DecodedServletRequest( );
    decodedRequest.initialize(request);

    final String BLOX_NAME = decodedRequest.getParameter("bn");
    final String APP_NAME = decodedRequest.getParameter("an");

    final String REPORT_ID = request.getParameter("rid");
    final String THEME = request.getParameter("theme");
    String requestParams = "render=pdfreportfit&bn=" + BLOX_NAME + "&an=" + APP_NAME + "&rid=" + REPORT_ID + "&theme=" + THEME;
%>

  <title>Alphablox PDF Report</title>
  <meta http-equiv="Pragma" content="no-cache">
  <style>
    body {
        font: normal 10px Verdana, Helvetica, "Times New Roman";
        background-color: #E0E0E0;
        margin: 0px 0px 0px 0px;
    }

    .title {
      font-weight: bold;
      font-size: 16px;
    }

    td.waitText {
      padding-top: 10px;
      padding-bottom: 10px;
      text-align: center;
      font-weight: bold;
      font-size: 12px;
    }

    td.errorText {
      padding-left: 10px;
      font-size: 11px;
    }

    .closeButton {
      font-size: 10px;
    }

    A:link, A:visited, A:hover {
      color: red;
    }

  </style>
</head>

<script language="JavaScript1.2">
  returnValue = null;

  function handleError() {
    var features = "innerWidth=650,innerHeight=400,resizable=yes,center=yes,dependent";

    window.open("reportFitError.jsp", null, features);

    close();
  }

  function pluginEnabled() {
    var plugins = navigator.plugins;
    for ( var i = 0; i < plugins.length; i++ ) {
       plugin = plugins[i];
       if ( plugin.name.indexOf("Adobe Acrobat") > -1 )
            return true;
    }
    return false;
  }

  function setWidth(width) {
    var query = location.search;
    var requestWidth = null;
    var theme = "coleman";
    var rid=bloxid;
    var debug ="false";
    var contextPath = null;
    var bloxid = null;
    var appName = null;
    if ((query !=null) && (query != "")) {
        query = location.search.substring(1);

        var pairs = query.split("&");

        for (var i = 0; i < pairs.length; i++){
            var pos = pairs[i].indexOf('=');

            if (pos == -1) {
              continue;
            }

            var arg = pairs[i].substring(0,pos);
            var value = pairs[i].substring(pos +1);

            if(arg == "debug") {
		        debug = value;
		    }
            else if(arg == "theme") {
                theme = value;
		    }
            else if(arg == "an") {
		        appName = value;
		    }
            else if(arg == "bn") {
		        rid = bloxid = value;
		    }
            else if(arg == "cp") {
		        contextPath = value;
		    }
        }
    }

    var widestblox = "blox0";
    var pos = width.indexOf('_');
    widestblox = width.substring(0,pos);
    requestWidth = width.substring(pos +1);

    if (requestWidth != null) {
        var renderReportURL = contextPath + "/abx/pdfreport/blox" + rid + "?render=pdfreport&bn=" + bloxid +
                  "&an=" + appName +  "&rid=" + rid + "&theme=" + theme + "&debug=" + debug;

        var winURL = encodeURI(renderReportURL + "&AAS_width=" + requestWidth + "&AAS_widestblox=" + widestblox);
        // do the right thing if the plugin is not installed.
        if (pluginEnabled()) {
            window.open(winURL, "_pdf", "location=no,menubar=no,personalbar=no,scrollbars=yes,status=no,resizable=yes,toolbar=no");
        } else {
            document.getElementById( "myframe" ).src = winURL;
        }
        document.getElementById( "waitText" ).style.display = "none";
        document.getElementById( "waitText" ).style.visibility = "hidden";
        document.getElementById( "closeButton" ).style.display = "";
        document.getElementById( "closeButton" ).style.visibility = "visible";

        setTimeout( "window.close();", 1000 * 60 );
    }
    else
        close();
  }
</script>

<body>
  <table border="0" cellpadding="2" cellspacing="0" width="100%" height="100%">
    <tr>
      <td valign="top" height="50" nobr>&nbsp;<img src="<%= URLFactory.getServerURL( "/images/logo.gif")%>"/></td>
    </tr>
    <tr>
      <td class="waitText" valign="top" align="center">
        <span id="waitText"><%= AlphaBlox.getDefaultString(AlphaBlox.PDF_BEING_GENERATED) %></span>
        <input id="closeButton" class="closeButton" style="display:none;" type="button" value="Close Window" onClick="javascript:window.close()"/>
      </td>
    </tr>
  </table>

  <iframe id="myframe" style="visibility:hidden" width="400" height="100" src="reportFitIframe.jsp?<%=requestParams%>"></iframe>
</body>
</html>

