/*
 * Copyright 2001 AlphaBlox Corporation. All rights reserved.
 */

/* 
 * Miscellaneous dhtml utilities
 */

function getElement( id ) {
	var item = document.getElementById(id);
	if ( item == null )
		alert( "Item '" + id + "' not found." );

	return item;
}

function getAncestorWithClass( item, className ){
	while( item != null && item.className != className ) {
		item = item.parentElement;
	}
	
	if ( item == null )
		alert( "Parent class='" + className + "' not found." );
		
	return item;
}

function getAncestorWithClassFF( item, className ){
	while( item != null && item.getAttribute("class") != className ) {
		item = item.parentNode;
	}
	
	if ( item == null )
		alert( "Parent class='" + className + "' not found." );
		
	return item;
}

function _setVisible( item, visible  ) {
	item.style.display = visible ? "block" : "none" ;
}

function isVisible( item  ) {
	return item.style.display == "block" ;
}

function getBounds( item ) {
	var x = item.offsetLeft;
	var y = item.offsetTop;

	for ( var parent = item.offsetParent; parent != null; parent = parent.offsetParent ) {
		x += parent.offsetLeft;
		y += parent.offsetTop;

		//with ( parent.currentStyle ) {
		if(isIE()) {
			x += toNumber( parent.currentStyle.borderLeftWidth );
			y += toNumber( parent.currentStyle.borderTopWidth );
		}
		else
		{
		}
	}

	var height = item.offsetHeight;

	var width = item.offsetWidth;

	if ( height == 0 )
	{
	    if(isIE())     
		height = item.style.pixelHeight;
	    else
		height = item.style.height;
	}
	if ( width == 0 )
	{
	    if(isIE())
		width = item.style.pixelWidth;
	    else
		width = item.style.width;
	}
	var z =  {
		left: x,
		top: y,
		width: width,
		height: height
	};

	return z;
}

function setBounds( item, bounds ) {
	var x = bounds.left;
	var y = bounds.top;

	for ( var parent = item.offsetParent; parent != null; parent = parent.offsetParent ) {

		x -= parent.offsetLeft;
		y -= parent.offsetTop;

		//with ( parent.currentStyle ) {
		if(isIE()) {
			x += toNumber( parent.currentStyle.borderLeftWidth );
			y += toNumber( parent.currentStyle.borderTopWidth );
		}
	}

	if(isIE()) {
	    with ( item.style ) {
		pixelLeft = x;
		pixelTop = y;
		pixelWidth = bounds.width;
		pixelHeight = bounds.height;
	    }
        }
	else
	{
		item.style.left = x;
		item.style.top = y;
		item.style.width = bounds.width;
		item.style.height = bounds.height;
	}
}

function isWithinBounds( item, x, y) {

	x += document.body.scrollLeft;
	y += document.body.scrollTop;

	var bounds = getBounds( item );

	var margin = 2;
	
	return !( (x > (bounds.left + bounds.width - margin)) || (x < (bounds.left + margin )) || (y > (bounds.top  + bounds.height -margin)) || (y < (bounds.top  + margin)));
}



function toNumber( value ) {
	var number = parseInt( value );
	return isNaN( number ) ? 0 : number;
}

function _getParent( item ) {
	return item.offsetParent;
}

function withinTarget(x, item ) {
	var bounds = getBounds( item );

	if( x > bounds.left && x < bounds.left + bounds.width)
	    return true;
        else
	    return false;
}

function showPos(x, y)
{
	window.status = "(" + x + ", " + y + ")";
}

function centerOnPage( item ) {

	var itemBounds = getBounds( item );

	if(isIE())   {
  	    var documentBounds = getBounds( document.body );
	    itemBounds.left = ( documentBounds.width - itemBounds.width ) / 2 + document.body.scrollLeft;
  	    itemBounds.top = ( documentBounds.height - itemBounds.height ) / 2 + document.body.scrollTop;
	    setBounds( item, itemBounds );
        }
	else
	{
	    itemBounds.left = ( window.innerWidth - itemBounds.width ) / 2 + window.scrollX;
	    itemBounds.top = ( window.innerHeight - itemBounds.height ) / 2 + window.scrollY;
	    item.style.left = itemBounds.left;
	    item.style.top = itemBounds.top;
	}
}

function getXPos(event)
{
	if(isIE())
	    return event.x;
	else
	    return event.clientX;
}

function getYPos(event)
{
	if(isIE())
	    return event.y;
	else
	    return event.clientY;
}

