package com.ibm.alphablox.tooling.relational.controller;

import com.alphablox.blox.repository.Log;
import com.alphablox.blox.uimodel.core.ComponentContainer;
import com.alphablox.blox.uimodel.core.Controller;
import com.alphablox.blox.uimodel.core.event.ModelEvent;
import com.ibm.alphablox.tooling.relational.PageController;

public class OperatorController extends Controller {
    private TreeHandler treeHandler;
    private SQLEditorHandler editorHandler;

//    private final ComponentContainer operatorContainer;
//    private PrintStream out = System.out;
//    private PageController pageController;
//    private OperationContext operationContext;
    
    public OperatorController(ComponentContainer operatorContainer, PageController pageController){
//        this.operatorContainer = operatorContainer;
//        this.pageController = pageController;
    }

    /**
     * @return the editorHandler
     */
    public SQLEditorHandler getEditorHandler() {
        return editorHandler;
    }

    /**
     * @param editorHandler the editorHandler to set
     */
    public void setEditorHandler(SQLEditorHandler editorHandler) {
        this.editorHandler = editorHandler;
    }

    /**
     * @return the treeHandler
     */
    public TreeHandler getTreeHandler() {
        return treeHandler;
    }

    /**
     * @param treeHandler the treeHandler to set
     */
    public void setTreeHandler(TreeHandler treeHandler) {
        this.treeHandler = treeHandler;
    }
    
    //action handler
    
    public void actionNewQuery(ModelEvent event) throws Exception{
        editorHandler.newBlankQuery();
    }

    public void actionInsert(ModelEvent event) throws Exception{
        String str = treeHandler.getSqlPart();
        if(str.trim().length()>0){
            editorHandler.insertQuery(str);    
        }else{
            Log.sendMessage(Log.MESSAGE_LEVEL_ERROR, 
                    "rMetaDataBrowser", 
                    "No node select to be inserted!");
        }
    }
//  
//    public void actionRemove( ModelEvent event ) throws Exception {
//        editorHandler.removeSelected();
//    }

//    public void setOperationContext(OperationContext operationContext) {
//        this.operationContext = operationContext;
//    }
}
