package com.ibm.alphablox.tooling.relational.util;

import com.alphablox.blox.DataBlox;

public abstract class SQLFactory {
    
    abstract public String getSampleString(String colName, String schemaName, String tableName);
    abstract public String generateValidateSql(String sql);
    
    public final String getResultSetSizeSql(String sql) {
        String upperSql = sql.toUpperCase();
        int fromIdx = upperSql.indexOf("FROM"); //$NON-NLS-1$
        String newSql = "SELECT count(*) " + sql.substring(fromIdx); //$NON-NLS-1$
        return newSql;
    }
    
    public static SQLFactory getInstance(DataBlox db) {
        try {
            String name = db.getMetaData().getDatabaseProductName();
        
            if(name.indexOf("DB2") >= 0) {
                return new DB2SQLFactory();
            }else if(name.indexOf("Oracle") >= 0){
                return new OracleSQLFactory();
            }else {
                return new GenericSQLFactory();
            }
        }
        catch(Exception e) {};
        return new DB2SQLFactory();
    }
    
    protected void getBasicShowSql(String colName, String schemaName, String tableName, StringBuffer sb) {
        sb.append("Select DISTINCT ").append(colName) //$NON-NLS-1$
            .append(" From ").append(schemaName) //$NON-NLS-1$
            .append(".").append(tableName); //$NON-NLS-1$
    }
    
    public boolean isGeneric() {
        // TODO Auto-generated method stub
        return false;
    }
}
