package com.ibm.alphablox.tooling.relational.view;

import com.alphablox.blox.DataBlox;
import com.alphablox.blox.repository.Log;
import com.alphablox.blox.uimodel.core.*;
import com.ibm.alphablox.tooling.relational.Messages;
import com.ibm.alphablox.tooling.relational.RMBConstants;

public class SQLEditorContainerBuilder implements IViewPartBuilder {

    private ComponentContainer sqlContainer;

    /* (non-Javadoc)
     * @see com.ibm.alphablox.tooling.relational.view.IViewPartBuilder#build(java.lang.Object, int, int, java.lang.String)
     */
    public ComponentContainer build(int h, int w, String style) throws ModelException{
        sqlContainer = new ComponentContainer(RMBConstants.SQLCONTAINER_ID);
        sqlContainer.setHeight(h);
        sqlContainer.setWidth(w);
        sqlContainer.setStyle(style);
        sqlContainer.setScrollingEnabled(true);
        sqlContainer.setLayout(new VerticalLayout());
        sqlContainer.setValignment( Component.VALIGN_TOP );

        sqlContainer.add(new Static(Messages.getString("SQLEditorContainerBuilder.Title")));
        Edit sqlEdit = new Edit(RMBConstants.SQL_EDITOR_ID,"");
        sqlEdit.setLines(19);
        sqlEdit.setCharactersPerLine(52);
        sqlEdit.setTrackCaretPosition(true);
        sqlEdit.setTrackScrolling(false);
        sqlEdit.setHeight(sqlContainer.getHeight()-50);
        sqlContainer.add(sqlEdit);
        
        Button validateButton = new Button(RMBConstants.ACTION_VALIDATE, Messages.getString("SQLEditorContainerBuilder.RunQuery"));
        validateButton.setTooltip(Messages.getString("OperatorContainerBuilder.ValidateSQL")); //$NON-NLS-1$
        sqlContainer.add(validateButton);
        
        return sqlContainer;
    }

    /* (non-Javadoc)
     * @see com.ibm.alphablox.tooling.relational.view.IViewPartBuilder#setDataBlox(com.alphablox.blox.DataBlox)
     */
    public void setDataBlox(DataBlox db) {
        Edit edt = sqlContainer.getEdit(RMBConstants.SQL_EDITOR_ID);
        try{
            edt.setValue(db.getQuery());
            edt.changed();
        }catch(Exception ex){
            Log.sendException(Log.MESSAGE_LEVEL_ERROR, "RMB no query", ex);
        }
        
    }

}