package com.ibm.alphablox.tooling.relational.view;

public class ViewPartBuilderFactory {
    
    DBItemInfoContainerBuilder dbItemInfoContainerBuilder;
    OperatorContainerBuilder operatorContainerBuilder;
    SQLEditorContainerBuilder sqlEditorContainerBuilder;
    TreeContainerBuilder treeContainerBuilder;
    RadioContainerBuilder radioContainerBuilder;
    
    public static IViewPartBuilder getDBItemInfoContainerBuilder(){
        return new DBItemInfoContainerBuilder();
    }
    
    public static IViewPartBuilder getOperatorContainerBuilder(){
        return new OperatorContainerBuilder();
    }
    
    public static IViewPartBuilder getSQLEditorContainerBuilder(){
        return new SQLEditorContainerBuilder();
    }
    
    public static IViewPartBuilder getTreeContainerBuilder(){
        return new TreeContainerBuilder();
    }
    
    public static IViewPartBuilder getRadioContainerBuilder(){
        return new RadioContainerBuilder();
    }
}
