<%@ page import="com.alphablox.blox.*,
                 com.alphablox.server.service.BloxBuilderService,
                 com.alphablox.server.service.ServiceManager,
                 com.ibm.alphablox.bloxbuilder.common.proxy.BloxProxy,
                 com.ibm.alphablox.bloxbuilder.common.proxy.ChartBloxProxy,
                 com.ibm.alphablox.bloxbuilder.common.proxy.GridBloxProxy,
                 com.ibm.alphablox.bloxbuilder.common.proxy.PresentBloxProxy,
                 com.ibm.alphablox.bloxbuilder.tooling.livelayout.LiveLayoutBlox,
                 com.ibm.alphablox.bloxbuilder.common.proxy.DataBloxProxy,
                 com.alphablox.util.Message,
                 java.io.PrintWriter,
                 com.alphablox.blox.uimodel.ModelConstants,
                 com.alphablox.blox.repository.DataSource,
                 com.alphablox.util.LocalizedException,
                 com.alphablox.blox.uimodel.core.event.DialogOpenedNotify,
                 com.alphablox.blox.uimodel.core.event.IEventHandler,
                 com.alphablox.blox.uimodel.BloxModel,
                 com.alphablox.blox.uimodel.core.Component"%>

<!--
    IBM Confidential
    OCO Source Materials
    5724-L14
    (c) Copyright IBM Corp. 2007
    The source code for this program is not published or otherwise divested of its trade secrets,
    irrespective of what has been deposited with the U.S. Copyright Office.
-->

<%@ page pageEncoding="ISO-8859-1" %> <!-- encoding this page was written in -->
<%@ page contentType="text/html;charset=UTF-8" %>  <!-- encoding for response -->
<%@ taglib uri='bloxtld' prefix='blox'%>

<%
    request.setCharacterEncoding("UTF-8");  // encoding for request

    final String bloxWidth = "100%";
    final String bloxHeight = "90%";
    final BloxBuilderService manager = (BloxBuilderService)ServiceManager.getService(ServiceManager.SVC_BLOXBUILDER, null);
%>

<%!
    void testConnect(AdminBlox adminBlox, String dataSourceName, String userName, String password) throws Exception {
        DataSource ds = null;
        ds = adminBlox.getDataSource(dataSourceName);
        if ((userName == null) || (password == null)) {
            ds.testConnection();
        }
        else {
            ds.testConnection(userName, password);
        }
    }

    void removeUnwantedDialogOptions(ViewBlox viewBlox) {
        try {
            final BloxModel model = viewBlox.getBloxModel();

            if ((viewBlox instanceof GridBlox) ||
                (viewBlox instanceof PresentBlox)) {
                model.addEventHandler(new GridHandler());
            }
            else if (viewBlox instanceof ChartBlox) {
                model.addEventHandler(new ChartHandler());
            }
        }
        catch (Exception e) {
            new Message(Message.ERROR, "Live Layout", e).send();
        }
    }


    class GridHandler implements IEventHandler {
        public boolean handleDialogOpenedNotify(DialogOpenedNotify event) throws Exception {
            if ("gridOptionsDialog".equals(event.getDialog().getName())) {
                Component c = event.getDialog().searchForComponent("displayGridLTR");

                if (c != null) {
                    c.getParent().setVisible(false);
                }

                c = event.getDialog().searchForComponent("enableAutoSize");

                if (c != null) {
                    c.setVisible(false);
                }
            }

            return false;
        }
    };

    class ChartHandler implements IEventHandler {
        public boolean handleDialogOpenedNotify(DialogOpenedNotify event) throws Exception {
            if ("chartOptionsDialog".equals(event.getDialog().getName())) {
                Component c = event.getDialog().searchForComponent("displayChartLTR");

                if (c != null) {
                    c.setVisible(false);
                }
            }

            return false;
        }
    };
%>

<html>
<head>
    <title>Live Layout: Blox</title>
    <blox:header />
</head>
<style>
    .debug {font: normal 8pt "courier new", courier, "sans serif";}
    .debug-error {font: normal 8pt "courier new", courier, "sans serif"; color: red;}
</style>
<body>
<blox:resourceBundle bundle="com.alphablox.resource.MessagesBundle"  />
<blox:admin id="adminBlox" />
<%
    final String uniqueId = request.getParameter("ObjectId");
    final String debug = request.getParameter("Debug");
    final String defaultDataSource = request.getParameter("DefaultDataSource");
    final LiveLayoutBlox llBlox = (LiveLayoutBlox)manager.getTempData(uniqueId);
    final BloxProxy proxy = llBlox.getBloxProxy();
    final DataBloxProxy dataProxy = llBlox.getDataProxy();
    final BloxContext context = BloxContextFactory.getBloxContext(request, response);
    final String dataSourceName = (String)dataProxy.getPropertyValue("DataSourceName");
    final String userName = (String)dataProxy.getPropertyValue("UserName");
    final String password = (String)dataProxy.getPropertyValue("Password");

    ViewBlox liveLayoutBlox, defaultBlox;
    DataBlox liveLayoutDataBlox = new DataBlox();
    DataBlox dafaultDataBlox = new DataBlox();
    Exception testConnectEx = null;

    if ("true".equals(defaultDataSource)) {
        %><div><blox:message key="290"/></div><%
    }
    else {
        try {
            testConnect(adminBlox, dataSourceName, userName, password);
        }
        catch (Exception e) {
            %><div><blox:message key="291"><blox:messageArg value="<%= dataSourceName %>" /></blox:message></div><%
            dataProxy.setStringValue("DataSourceName", "Canned");
            testConnectEx = e;
        }
    }


    BloxProxy defaultProxy = (BloxProxy)proxy.clone();
    DataBloxProxy defaultDataProxy = (DataBloxProxy)dataProxy.clone();

    try {
        liveLayoutDataBlox.init(bloxContext, "LiveLayoutData" + System.currentTimeMillis());
        dataProxy.setBlox(liveLayoutDataBlox);

        if (proxy instanceof GridBloxProxy) {
            liveLayoutBlox = new GridBlox();
            defaultBlox = new GridBlox();
        }
        else if (proxy instanceof ChartBloxProxy) {
            liveLayoutBlox = new ChartBlox();
            defaultBlox = new ChartBlox();
        }
        else if (proxy instanceof PresentBloxProxy) {
            liveLayoutBlox = new PresentBlox();
            defaultBlox = new PresentBlox();
        }
        else {
            throw new Exception("Got a bad proxy: " + proxy.getClass().getName());
        }

        // get the default properties into a default proxy
        defaultBlox.init(context, "LiveLayout_default" + System.currentTimeMillis());
        defaultProxy.setBlox(defaultBlox);
        llBlox.setDefaultBloxProxy(defaultProxy);

        dafaultDataBlox.init(bloxContext, "LiveLayoutData_Default" + System.currentTimeMillis());
        defaultDataProxy.setBlox(dafaultDataBlox);
        llBlox.setDefaultDataBloxProxy(defaultDataProxy);

        liveLayoutBlox.init(context, "LiveLayout" + System.currentTimeMillis());
        ((DataViewBlox)liveLayoutBlox).setDataBlox(liveLayoutDataBlox);
        proxy.setBlox(liveLayoutBlox);

        final String[] removedButtons = new String[]{ModelConstants.FILE_EXPORT_TO_EXCEL,
                                                     ModelConstants.FILE_EXPORT_TO_PDF,
                                                     ModelConstants.FILE_MENU};
        liveLayoutBlox.getBloxModel().removeNamedActions(removedButtons);
        liveLayoutBlox.render(bloxRequest, out, null, bloxWidth, bloxHeight);

        removeUnwantedDialogOptions(liveLayoutBlox);

    }
    catch (Throwable t) {
        // put some optional debug information here
        if ("true".equalsIgnoreCase(debug)) {
            %><pre class='debug-error'><%
            t.printStackTrace(new PrintWriter(out));
            %></pre><%
        }
        else {
            %><h3><%= t.getClass().getName() %>: <%= t.getLocalizedMessage() %></h3><%
        }

        new Message(Message.ERROR, "Live Layout", t).send();
    }

    // put some optional debug information here
    if ("true".equalsIgnoreCase(debug)) {
        if (testConnectEx != null) { %>
            <p class='debug' >Connection exception: <%= testConnectEx.getClass().getName() + ": " + testConnectEx.getLocalizedMessage() %></p><%
        }

        String query = dataProxy.getStringValue("Query");
        %>
        <p class='debug'>DataSource: <%= dataSourceName %>; Query: <%= query %>; UserName <%= userName %></p>
        <p class='debug'>view proxy: <%= proxy.toString() %></p>
        <p class='debug'>view defaultProxy: <%= defaultProxy.toString() %></p>
        <p class='debug'>data proxy: <%= dataProxy.toString() %></p>
        <p class='debug'>data defaultProxy: <%= defaultDataProxy.toString() %></p>
<%
    }
%>
</body>
</html>