/*
 * Copyright 2002 Alphablox Corporation. All rights reserved.
 * User: rraghavan
 * Date: Sep 6, 2002
 * Time: 3:32:01 PM
 */
package fastforward;

public class Acl {
    private String name;

    private Acl parent;
    private String[] groups=new String[0];

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String[] getGroups() {
        return groups;
    }

    public void setGroups(String[] groups) {
        this.groups = groups;
    }

    public boolean hasAccess(User user) {
        boolean ret = false;
        if (groups.length == 0)
            ret = true;

        for (int x = 0; x < groups.length && ret == false; x++) {
            if (user.isInGroup(groups[x]))
                ret = true;
        }
        // we are recursive -- no child ACL can grant access
        // more freely than any of its ancestors.
        if (ret == true && parent != null)
            ret = parent.hasAccess(user);

        return ret;
    }

    public Acl getParent() {
        return parent;
    }

    public Acl(Acl parent) {
        this.parent = parent;
    }
}
