package fastforward;

import com.alphablox.blox.ServerBloxException;

/*
 * Copyright 2003 Alphablox Corporation. All rights reserved.
 * User: dmessink
 * Date: Feb 4, 2003 3:43:59 PM
 */

/**
 * Defines an interface used to validate report parameters as entered by an adminstrator in the admin page.
 * A ReportValidator may be assigned to a Template to validate template parameter values entered by the administrator.
 */
public interface ReportValidator {
    /**
     * Uses the given ReportData to access and report errors on template parameter values as defined by the adminstrator.
     * @param data a ReportData object representing the parameter values entered in the template's edit page
     * @throws ServerBloxException
     */
    public void validate(ReportData data) throws ServerBloxException;
}
