package fastforward;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXParseException;
import com.alphablox.util.XmlFile;

/*
 * Copyright 2003 Alphablox Corporation. All rights reserved.
 * User: dmessink
 * Date: Feb 20, 2003 2:47:12 PM
 */

public class XMLErrorHandler implements ErrorHandler {
    XmlFile configFile;
    XmlParseException exception;

    public XMLErrorHandler(XmlFile configFile) {
        this.configFile = configFile;
    }

    public XmlParseException getException() {
        return exception;
    }

    public void error(SAXParseException exc) {
        exception = new XmlParseException(exc.getLocalizedMessage());
    }

    public void fatalError(SAXParseException exc) {
        exception = new XmlParseException(exc.getLocalizedMessage());
    }

    public void warning(SAXParseException exc) {
        exception = new XmlParseException(exc.getLocalizedMessage());
    }

    public boolean exceptionThrown() {
        return (exception != null);
    }
}
