######################################################################
#
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2010. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#  
######################################################################

import sys
from java.util import Properties
from java.io import FileInputStream

# return code, 0 for success, -1 for failure
rc = 0;

	
#------------------------------------------------------------------------------
# Get the current mappings of the app
#------------------------------------------------------------------------------	
def getAppMappings(appName):
	appModuleList = AdminApp.listModules(appName,'-server')
	moduleList = appModuleList.splitlines()
	appInfoList = moduleList[0].split('#')
        return appInfoList[2]

# update the server mappings 
#------------------------------------------------------------------------------	
def updateAppServerMappings(appName, serverMappings):
	appModuleList = AdminApp.listModules(appName,'-server')
	moduleList = appModuleList.splitlines()
        for appInfo in moduleList:
           appInfoList = appInfo.split('#')
           appInfoList[2] = serverMappings
           appInfoList[0] = getDisplayName(appInfoList[0] + '#' + appInfoList[1])
           appInfoList[1] = appInfoList[1].replace('+',',')
           detailOption = [appInfoList]
           options = ['-MapModulesToServers',detailOption]
           print " -- Update module " + appInfoList[1]

           AdminApp.edit(appName, options)

#------------------------------------------------------------------------------
#  get the module display name
#------------------------------------------------------------------------------
def getDisplayName(moduleName):
        moduleInfo = AdminApp.view(moduleName,['-MapModulesToServers'])
        moduleInfoList = moduleInfo.splitlines()
        for infoLine in moduleInfoList:
           if(infoLine[0:7] == 'Module:'):
               return infoLine[9:]

           

#-----------------------------------------------------------------
# Main
#-----------------------------------------------------------------
print "updateSeverMappings"
   # need the location of ears as a parameter
try:         
   rc = 0
   # Get the current mappings for wps application
   print 
   print
   print "Starting the mapping of the applications"
   serverMappings = getAppMappings("wps")
   print "Servers wps is associated with  " + serverMappings

   # apply the wps mappings to the apps
   updateAppServerMappings('AlphabloxPlatform', serverMappings) 
   updateAppServerMappings('ApplicationStudio', serverMappings)
   updateAppServerMappings('IBM_WBM_REST_PROXY', serverMappings)

   AdminConfig.save()
      
except java.lang.Exception,e:
   print "1 FatalErrors:" 
   print " Failed to update Mappings of the applications:",e
   raise

