@echo off
setlocal
REM ***************************************************************
REM  Licensed Material - Property of IBM
REM 
REM  5724-M24 
REM 
REM  Copyright IBM Corp. 2010.  All rights reserved.
REM 
REM  US Government Users Restricted Rights - Use, duplication or
REM  disclosure restricted by GSA ADP Schedule Contract with IBM
REM  Corp.
REM ***************************************************************


REM ***************************************************************
REM  Be sure to update dmgrConfig.properties to your configuration
REM ***************************************************************

FOR /F "tokens=*" %%i in ('find /v"#" ^< dmgrConfig.properties') do SET %%i


if "%ADMINUSERNAME%" NEQ "" GOTO START
   echo -
   echo Please provide needed settings in dmgrConfig.properties
   GOTO END


          
:START          
REM ******************************************************
@echo -                            
@echo  START of install task execution
REM ******************************************************

SET CURRENT_DIR ="%CD%"
CD.. 
SET WBM_LOC="%CD%"
CD %CURRRNT_DIR%
        
REM ******************************************************
REM  Copy files to the Deployment Manager 
REM ******************************************************

@echo -                            
@echo -                            
@echo move the WAS plugins to be used                                               
if exist "%WBM_LOC%\plugins" erase "%WBM_LOC%\plugins" /Q
mkdir %WBM_LOC%\plugins
if %WAS_VERSION% == 61 copy %WBM_LOC%\abx.62.plugins\plugins %WBM_LOC%\plugins 
if %WAS_VERSION% == 70 copy %WBM_LOC%\abx.70.plugins\plugins %WBM_LOC%\plugins 
@echo move logging support jar
copy %WBM_LOC%\temp\was602\lib\wbminstall_log.jar %WAS_LOC%\lib  
if [%ERRORLEVEL%] GTR [0] GOTO END 


@echo -                            
@echo -                            
@echo Install files task                            
call %WAS_LOC%\bin\ws_ant -Dwbm.portdash.installed.id=700 -Dwbm.install.instance.id=70 -Dwbm.installType.PortalDashboard=installNewPortalDashboard -Dinstall.widgets.nativePortlets=true -Dwbm.install.abx.portalviews=%ABX_INSTALL% -Dwas602.install.root=%WAS_LOC% -Dwas.install.root=%WBM_LOC% -Dportal.install.root=%WBM_LOC% -Dportal.profileType=deploymentManager -DtraceLevel=all -f %WBM_LOC%\actions\CopyPortalDashboardFiles.ant
if [%ERRORLEVEL%] GTR [0] GOTO END 
@echo -                            
@echo -                            
@echo Initialize new plugins
call %WAS_PROFILE_PATH%\bin\osgiCfgInit.bat


REM ******************************************************
@echo -                            
@echo -                            
@echo  Deploy REST Proxy and Human Task settings  
REM ******************************************************

call %WAS_LOC%\bin\ws_ant -DconfigureHumanTask=%CONFIGHUMANTASK% -DhumanTaskWPSHostname=%HUMANTASKHOST% -DhumanTaskWPSRMIPort=%HUMANTASKPORT% -Dbspace.hostName=%BSPACEHOST% -Dbspace.serverPort=%BSPACEPORT% -Dbspace.secureServerPort=%BSPACESECUREPORT% -Drest.hostName=%RESTHOST% -Drest.serverPort=%RESTPORT% -Drest.secureServerPort=%RESTSECUREPORT% -Dwas602.admin.user=%ADMINUSERNAME% -Dwas602.admin.password=%ADMINPASSWORD% -Dportal.cluster.name=%CLUSTERNAME% -Dportal.server.name= -Dportal.profile.nodename=%NODENAME% -Dportal.profile.cellname=%CELLNAME% -Dportal.profile.name=%WAS_PROFILE% -Dwbm.installType.PortalDashboard=installNewPortalDashboard -Dinstall.widgets.nativePortlets=true -Dwbm.install.abx.portalviews=%ABX_INSTALL% -Dwas602.install.root=%WAS_LOC% -Dwas.install.root=%WBM_LOC% -Dportal.install.root=%WBM_LOC% -Dportal.profile.path=%WBM_LOC% -Dportal.profileType=deploymentManager -DtraceLevel=all -f %WBM_LOC%\actions\AugmentPortalDashboardProfile.ant
if [%ERRORLEVEL%] == [0] GOTO NEXT1
  echo "check log %WAS_LOC%\logs\manageprofiles\%WAS_PROFILE%_augment.log" 
  echo "check log %WAS_LOC%\profiles\%WAS_PROFILE%\logs\installPortalDashboardRestProxy.log"  
  GOTO END


:NEXT1
REM ******************************************************
@echo -                            
@echo -                            
@echo  Create Monitor data source for Alphablox
REM ******************************************************
 
call %WAS_LOC%\bin\ws_ant -Ddb.dbName=%DBNAME% -Ddb.dbUserId=%DBUSERID% -Ddb.dbPassword=%DBPASSWORD% -Ddb.dbHostName=%DBHOSTNAME% -Ddb.dbServerPort=%DBPORT% -Ddb.dbType=%DBTYPE% -Ddb.dbSchemaName=%DBSCHEMA% -Ddb.portalJdbcClassPath=%DBCLASSPATH% -Ddb.dbJdbcDriverType=%DBDRIVERTYPE% -DconfigureHumanTask=%CONFIGHUMANTASK% -DhumanTaskWPSHostname=%HUMANTASKHOST% -DhumanTaskWPSRMIPort=%HUMANTASKPORT% -Dbspace.hostName=%BSPACEHOST% -Dbspace.serverPort=%BSPACEPORT% -Dbspace.secureServerPort=%BSPACESECUREPORT% -Drest.hostName=%RESTHOST% -Drest.serverPort=%RESTPORT% -Drest.secureServerPort=%RESTSECUREPORT% -Dwas602.admin.user=%ADMINUSERNAME% -Dwas602.admin.password=%ADMINPASSWORD% -Dportal.cluster.name=%CLUSTERNAME% -Dportal.server.name= -Dportal.profile.nodename=%NODENAME% -Dportal.profile.cellname=%CELLNAME% -Dportal.profile.name=%WAS_PROFILE% -Dwbm.installType.PortalDashboard=installNewPortalDashboard -Dinstall.widgets.nativePortlets=true -Dwbm.install.abx.portalviews=%ABX_INSTALL% -Dwas602.install.root=%WAS_LOC% -Dwas.install.root=%WBM_LOC% -Dportal.install.root=%WBM_LOC% -Dportal.profile.path=%WBM_LOC% -Dportal.profileType=deploymentManager -DtraceLevel=all -f %WBM_LOC%\actions\AugmentABXPortalDashboardProfile.ant
if [%ERRORLEVEL%] == [0] GOTO NEXT2
  echo "check log %WAS_LOC%\logs\manageprofiles\%WAS_PROFILE%_augment.log" 
  echo "check log %WAS_LOC%\profiles\%WAS_PROFILE%\logs\installABXPortalDashboard.log"  
  GOTO END


:NEXT2
REM ******************************************************
@echo -                            
@echo -                           
@echo  Deploy Alphablox service
REM ******************************************************
 
call %WAS_LOC%\bin\ws_ant -DenableAdminSecurity=true -Ddb.dbSchemaName=%DBSCHEMA% -Dportal.soap.port=8880 -Dwas602.admin.user=%ADMINUSERNAME% -Dwas602.admin.password=%ADMINPASSWORD% -Dportal.cluster.name=%CLUSTERNAME% -Dportal.server.name=dummy -Dportal.profile.nodename=%NODENAME% -Dportal.profile.cellname=%CELLNAME% -Dportal.profile.name=%WAS_PROFILE% -Dwbm.installType.PortalDashboard=installNewPortalDashboard -Dinstall.widgets.nativePortlets=true -Dwbm.install.abx.portalviews=%ABX_INSTALL% -Dwas602.install.root=%WAS_LOC% -Dwas.install.root=%WBM_LOC% -Dportal.install.root=%WBM_LOC% -Dportal.profile.path=%WAS_PROFILE_PATH% -Dportal.profileType=deploymentManager -DtraceLevel=all -f %WBM_LOC%\actions\ConfigABX.ant
if [%ERRORLEVEL%] == [0] GOTO NEXT3
  echo "check log %WAS_LOC%\profiles\%WAS_PROFILE%\logs\deployABXservice.log"  
  GOTO END


:NEXT3
REM ******************************************************
@echo -                            
@echo -                           
@echo  Add the Monitor theme to Portal
REM ******************************************************
REM ** get the portal ear
if exist temp\wptheme erase temp\wptheme /Q
mkdir temp\wptheme
call %WAS_PROFILE_PATH%\bin\wsadmin -conntype NONE -c "$AdminApp export wps temp/wptheme/wps.ear"
if [%ERRORLEVEL%] == [0] GOTO NEXT4
   echo ""
   echo " Problem exporting the wps ear"
   GOTO NEXT7

:NEXT4
REM ** expand the ear
call %WAS_LOC%\bin\EARExpander -ear  %WBM_LOC%\temp\wptheme\wps.ear -operationDir %WBM_LOC%\temp\wptheme\wps_expanded -operation expand
if [%ERRORLEVEL%] == [0] GOTO NEXT5
   echo ""
   echo " Problem expanding the wps ear"
   GOTO NEXT7

:NEXT5
REM ** add the monitor theme
@echo -                            
@echo - 
@echo copy theme files 
copy %WBM_LOC%\theme\WBMonitor %WBM_LOC%\temp\wptheme\wps_expanded\wps.war\themes\html

REM ** delete the exported ear
erase %WBM_LOC%\temp\wptheme\wps.ear

REM ** rebuild the ear
call %WAS_LOC%\bin\EARExpander -ear  %WBM_LOC%\temp\wptheme\wps.ear -operationDir %WBM_LOC%\temp\wptheme\wps_expanded -operation collapse
if [%ERRORLEVEL%] == [0] GOTO NEXT6
   echo ""
   echo " Problem creating the new wps ear"
   GOTO NEXT7

:NEXT6
REM ** update the ear 
call %WAS_PROFILE_PATH%\bin\wsadmin -conntype NONE -c "$AdminApp install temp/wptheme/wps.ear {-update -appname wps -nodeployejb}"
if [%ERRORLEVEL%] == [0] GOTO NEXT7
   echo ""
   echo " Problem deploying the new wps ear"
   GOTO NEXT7


:NEXT7

REM ** update the mappings

REM ******************************************************
@echo -                            
@echo -  
REM ******************************************************
call %WAS_PROFILE_PATH%\bin\wsadmin -conntype NONE -lang jython -f "%WBM_LOC%\actions\updateServerMappings.py"
if [%ERRORLEVEL%] == [0] GOTO NEXT8
   echo ""
   echo " Problem updating the server mappings"
   GOTO NEXT8
 

:NEXT8
@echo -                            
@echo - 


:END                           

endlocal
@echo on
