#!/bin/sh

# ***************************************************************
#  Licensed Material - Property of IBM
# 
#  5724-M24 
# 
#  Copyright IBM Corp. 2010.  All rights reserved.
# 
#  US Government Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM
#  Corp.
# ***************************************************************


# ***************************************************************
#  Be sure to update updateAlphablox.properties to your configuration
# ***************************************************************

. updateAlphablox.properties

# ******************************************************
echo "-"                            
echo  START of install task execution
# ******************************************************


CURRENT_DIR=`pwd`
cd ..
WBM_LOC=`pwd`
cd $CURRENT_DIR
         
# ******************************************************
#  Copy files to the Deployment Manager 
# ******************************************************

echo "-"                            
echo "-"                            
echo "move the WAS plugins to be used"
if [ -d $WBM_LOC/plugins ]; then
   rm -r $WBM_LOC/plugins
fi                                               
mkdir $WBM_LOC/plugins
if [ $WAS_VERSION == 61 ]; then 
   cp $WBM_LOC/abx.62.plugins/plugins/* $WBM_LOC/plugins 
   elif [ $WAS_VERSION == 70 ]; then
     cp $WBM_LOC/abx.70.plugins/plugins/* $WBM_LOC/plugins 
fi
echo "move logging support jar"
cp $WBM_LOC/temp/was602/lib/wbminstall_log.jar $WAS_LOC/lib
if [ "$?" -ne "0" ]; then
  exit 1
fi
  


echo "-"                            
echo "-"                            
echo "Install files task"
$WAS_LOC/bin/ws_ant.sh -Dwbm.portdash.installed.id=700 -Dwbm.install.instance.id=70 -Dwbm.installType.PortalDashboard=installNewPortalDashboard -Dinstall.widgets.nativePortlets=$DASHBOARD_INSTALL -Dwbm.install.abx.portalviews="true" -Dwas602.install.root=$WAS_LOC -Dwas.install.root=$WBM_LOC -Dportal.install.root=$WBM_LOC -Dportal.profileType=$PROFILE_TYPE -DtraceLevel=all -f $WBM_LOC/actions/CopyPortalDashboardFiles.ant 
if [ "$?" -ne "0" ]; then
  exit 1
fi

echo "-"                            
echo "-"                            
echo "Initialize new plugins"
$WAS_PROFILE_PATH/bin/osgiCfgInit.sh

# only update ears on a stand alone system                       
if [ "$PROFILE_TYPE" != "standAlone" ]; then
  echo "Update complete" 
  exit 1
fi

# ******************************************************
echo "-"                            
echo "-"                           
echo "Update Alphablox service ears"
# ******************************************************
 
$WAS_LOC/bin/ws_ant.sh -Dportal.profileType=$PROFILE_TYPE -Dportal.profile.name=$WAS_PROFILE -Dwbm.install.abx.portalviews="true" -Dwas602.install.root=$WAS_LOC -Dwas.install.root=$WBM_LOC -Dportal.install.root=$WBM_LOC -Dportal.profile.path=$WAS_PROFILE_PATH -DtraceLevel=all -f $WBM_LOC/actions/UpdateABXears.ant
if [ "$?" -ne "0" ]; then
  echo "check log ${WAS_LOC}/profiles/${WAS_PROFILE}/logs/updateABXears.log" 
  exit 1
fi

echo "-"                            
echo "-"                            

