/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.aggregation"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.aggregation"] = true;
dojo.provide( "com.ibm.aggregation" );

dojo.declare( "com.ibm.aggregation.Aggregator", 
			  null, 
			  {
			  	// summary: Aggregates and render the appropriate information based
				//		on the navigational state. 
				// description: The Aggregator is responsible for rendering the page. An 
				//		aggregated page consists of two parts: the Navigation and the Page.
				//		The rendering is based on the navigational state provided by the 
				//		Navgiation object.
				// _navigation: com.ibm.aggregation.Navigation - the navgiation implementation
				// _pages: com.ibm.aggregation.Page - the page that this Aggregator object will render
				// _stateInfo: Object - information about the state 			  
			  	navigation: null,
				page: null,
				stateInfo: null,			  
			  	start: function () {
					// summary: Starts the aggregation rendering process.
					// description: Pulls the aggregation information and starts
					//		the rendering process. The information is based on the
					//		current navigational state provided by the Navigation 
					//		object.
					dojo.unimplemented( "com.ibm.aggregation.Aggregator.start" );
				} 	
			  }
);

dojo.declare( "com.ibm.aggregation.Page", 
			  null,
			  {
			  	// summary: A page that contains one or more Fragments.
				// description: Describes a page which contains one or more Fragments. The
				//		Fragments are arranged according to a layout provided by this page.
				// _fragments: Array of com.ibm.aggregation.Fragment - the fragments on this page.
				_fragments: new Array(),
				render: function ( /*dojo.dom.DOMDocument*/ state ) {
					// summary: Renders the page.
					// description: Renders the page and all its fragments in its specified layout.
					// state: com.ibm.aggregation.NavigationState - the current navigation state
					dojo.unimplemented( "com.ibm.aggregation.Page.render" );
				},
				getFragment: function ( /*String*/ fragId ) {
					// summary: Retrieves the Fragment on this page that matches the given id.
					// description: Retrieves the Fragment with the given id and returns the
					//		Fragment object. Returns null if no fragment with the given id can
					//		be found.
					// fragId: String - the fragment id
					// returns: com.ibm.aggregation.Fragment or null
					dojo.unimplemented( "com.ibm.aggregation.Page.getFrament" ); 
				}
					
			  } 
);

dojo.declare( "com.ibm.aggregation.Fragment",
			  null,
			  {
			  	// summary: An HTML fragment.
				// id: the unique identifier for this fragment
				id: null,
				_markup: null,
				render: function ( /*NavigationalState*/ state) {
					// summary: Renders this HTML fragment.
					// description: Renders this HTML fragment. Processes any included javascript using 
					// 		the specified javascript filter. 
					// state: the current navigational state
					dojo.unimplemented( "com.ibm.aggregation.Fragment.render" );
				}	
			  }
);

dojo.declare( "com.ibm.aggregation.FragmentMarkup",
			  null,
			  {
			  	update: function ( /*HTMLElement*/elementToUpdate, /*String*/markup ) {
					// summary: Update the specified element with the given markup.
					// elementToUpdate: HTMLElement - the element to update
					// markup: the markup string.
					dojo.unimplemented( "com.ibm.aggregation.FragmentMarkup.update" );	
				}	
			  }
);

dojo.declare( "com.ibm.aggregation.Navigation",
			  null,
			  {
			  	// summary: Contains all the information about the navigation for this aggregation.
				// description: Contains the information about navigating from page to page in the
				//		aggregation. 
				render: function ( /*dojo.dom.DOMDocument*/ state ) {
					// summary: Renders the navigation based on the navigational state.
					// state: the current navigational state
					dojo.unimplemented( "com.ibm.aggregation.Navigation.render" );
				}
			  }
);

}
