/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.customize.CustomizeController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.CustomizeController"] = true;
 // This is an API for controllers that customize the look of a page

dojo.provide("com.ibm.customize.CustomizeController");
dojo.declare("com.ibm.customize.CustomizeController",
	[dijit._Widget],
	{

		parent: null,		// a reference to the controller's parent, if any
		dirty: false,		// true if there are changes pending
		started: false,		// true if the widget is started up
		refresh: true,		// true if a page refresh is required to show saved changes
		
		startup: function(){
			// summary: does any necessary preliminary work
			this.started = true;
		},
		
		makeDirty: function(/*bool*/change){
			// summary: changes the dirty attribute
			// change: value to assign to the dirty attribute
			this.dirty = change;
		},
		
		processChange: function(/*Object*/args){
			// summary: used as an event handler for when a user clicks on an item
		},
		
		apply: function(/*Object*/args){
			// summary: applies a change associated with a selected item to the page
		},
		
		undo: function(/*Object*/args){
			// summary: reverts any changes made
		},
		
		beforeSubmit: function(/*Object*/args){
			// summary: Called before submit and returns a Deferred object which should be used
			// 		to get notified when the controller is ready to be submitted.  Attach a callback
			//		to this Deferred to call the controller's submit function instead of calling
			//		it directly.
		},
		
		submit: function(/*Object*/args){
			// summary: saves any pending changes
			// args: args may contain an onComplete handler
			if(this.dirty) this.makeDirty(false);
			if(args.onComplete) args.onComplete();
		}
});

}
