/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.MashupCatalogFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupCatalogFeedStore"] = true;
dojo.provide("com.ibm.data.MashupCatalogFeedStore");

dojo.require("com.ibm.data.CatalogMixin");
dojo.require("com.ibm.data.OpenSearchFeedStore");

dojo.declare("com.ibm.data.MashupCatalogFeedStore", 
		[com.ibm.data.OpenSearchFeedStore,com.ibm.data.CatalogMixin],
		{
			itemClass: "com.ibm.data.MashupCatalogFeedItem",
			searchable: false,
			
			namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces, {
		        "ext" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions",
				"model" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
				"base" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base"
		    }),
		       
			constructor: function( /*Map*/ args ) {
				this._features['dojo.data.api.Identity'] = true;
				var serviceDoc = com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG;
				var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(serviceDoc);
				this.isPortal = (serviceJson.idprefix == "id") ? false : true;
				
				this.url = serviceJson.url + "@"+ serviceJson.idprefix + ":" + this.category;
				var mashupsIdPostfix = this.isPortal ? "" : "_c_default";
				this.url = this.url + mashupsIdPostfix;
			},
				
			mapItem: function(/*item*/item){
				var map = {};
				var bigId = this.getValue(item, "id", null);
				if(this.isPortal) var ids = /^catalog:oid:(.+)@oid:.+/.exec(bigId);
				else var ids = /^catalog:id:(.+)@/.exec(bigId);
				map["id"] = ids.length > 1 ? ids[1] : "";
				map["label"] = this.getValue(item, "title", "untitled");
				map["description"] = this.getValue(item, "summary", "");
				map["thumbnail"] = this.getValue(item, "thumbnail", "");
				if(!map.thumbnail && builderConfig.builderPath) map["thumbnail"] = builderConfig.builderPath + "/images/gray_generic_widget_icon.png";
				return map;
			},
				
			prepareQuery: function(keywordArgs) {
				if(keywordArgs.count) {
					if(this.isPortal) keywordArgs.query["max-results"] = keywordArgs.count;
					else keywordArgs.query.num = keywordArgs.count;
					if(keywordArgs.start == null) {
						keywordArgs.start = 0;
					}
					if(this.isPortal) keywordArgs.query["start-index"] = keywordArgs.start;
					else keywordArgs.query.start = keywordArgs.start;
				}
				return keywordArgs;
			},
			
			getSourceLabel: function(){
				var categories = com.ibm.mm.builder.utils.toolboxUtil.getCategories();
				for (var i = 0; i < categories.length; i++) {
					var category = categories[i];
					var enTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(category,"en");
					if(enTitle == this.category) return com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(category);
				}
				return false;
			}
});

dojo.declare( "com.ibm.data.MashupCatalogFeedItem",
		com.ibm.data.OpenSearchFeedItem, 
		{
			namespaces: dojo.mixin({}, com.ibm.data.MashupCatalogFeedStore.prototype.namespaces),
			
	        attrMappings: dojo.mixin({}, com.ibm.data.OpenSearchFeedItem.prototype.attrMappings, {
				thumbnail: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='icon']", targetName: "href", type: "attr"}
			})
		}
);

}
