/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.AtomPocHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.AtomPocHandler"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.AtomPocHandler");

dojo.require("com.ibm.data.resolver.XmlPocHandler");
dojo.require("com.ibm.query.rules.Atom");

dojo.declare("com.ibm.data.resolver.AtomPocHandler",
	com.ibm.data.resolver.XmlPocHandler,
	{
		queryRules: dojo.mixin({}, com.ibm.query.rules.Atom.syndication.common, com.ibm.query.rules.Atom.syndication.entry),
		
		bodyQueryRules: dojo.mixin({}, com.ibm.query.rules.Atom.syndication.common),
				
		namespaces: {
			"atom" : "http://www.w3.org/2005/Atom"
		},
		mergeItems: function(/*Item*/ updateItem, /*Item*/ existingItem) {
			if(this.resolver.isDirty(existingItem)) {
				existingItem._backupData = updateItem.data;
				// if we already modified an item, we've potentially cleaned up
				// much of the data that we either don't want or don't need
				// when writing it, so we don't want to add that back in here,
				// so just update the backup data with the latest results
				/*
				for(var i = 0; i < existingItem._writeLog.length; i++) {
					var op = existingItem._writeLog[i];
					if(op.values) {
						this.setValues(updateItem, op.attribute, op.values);
					}
					else if(op.value !== undefined){
						this.setValue(updateItem, op.attribute, op.value);
					}
					else this.unsetValue(updateItem, op.attribute);
				}
				*/
			}
			else existingItem.data = updateItem.data;
			return existingItem;
		},
		processEntryData: function(entryData) {
			var tempItem = this.dataToItem(entryData);
			var tempItemId = this.getIdentity(tempItem);
			var existingItem = this.resolver._fromCache(tempItemId);
			if(existingItem) {
				tempItem = this.mergeItems(tempItem, existingItem);
			}
			return tempItem;
		},
		parseFeed: function(request, xmlDoc) {
			var items = [], root = null, result = this.engine.select("/atom:feed", xmlDoc, true);
			if(result.length == 0) {
				result = this.engine.select("/atom:entry", xmlDoc);
				if(result.length == 0) {
					// the root is not an atom:feed or atom:entry
					throw new Error(this.resolver.fmt("errorDataFormat"));
				}
				else {
					// the root is an atom:entry element, so there's only one item
					root = result[0];
					items.push(this.processEntryData(root));
				}
			}
			else {
				// the root is an atom:feed element
				root = result[0];
				result = result.select("./atom:entry");
				if(result.length > 0) {
					result.forEach(function(entry){
						items.push(this.processEntryData(entry));
					}, this);
				}
			}
			
			return {items: items, root: root};
		},
		processFetch: function(/*DOMDoc*/ xmlDoc, /*Request*/ request) {
			// summary: Extension point for descendants or consumers of this store to handle
			//		responses from server requests for data.  Most subclasses can leave this
			// 		function as-is, but if special handling is required that cannot be done
			// 		with other extension points, this can be overridden as well.
			// xmlDoc: DOMDoc of the response from an IO request
			// request: Request used to fetch the result
			// returns: Object map with two properties:
			//		items: Array of the items fetched
			//		meta: Object map of meta data associated with the request
			var composite = this.parseFeed(request, xmlDoc),
				meta = {root: composite.root, resultSize: composite.items.length};
			
			if(!this._nsSynced) {
				this.syncNamespaces(composite.root);
				this._nsSynced = true;
			}
			
			dojo.forEach(composite.items, function(item){
				item._cachedMeta.requestMeta = meta;
			}, this);
			
			return {items: composite.items, meta: meta};
		},
		processSave: function(/*Item*/ item) {
			// transform an item of this POC handler into an ioArgs for IO transmission
			this.inherited(arguments);
			var args = {
				data: com.ibm.domUtilities.stringFromDoc(item.data), 
				headers: {},
				handleAs: this.definition.handleAs
			};
			
			args.headers[this.resolver.headers.CONTENT_TYPE] = "application/atom+xml";
			
			if(!this.resolver.isCreated(item)) {
				args.load = dojo.hitch(this, function(response, ioArgs) {
					var entries = this.engine.select("//atom:entry", response);
					var cid = this.getIdentity(item);
					if(entries && entries.length > 0) {
						item.data = entries[0];
						item.cid = item.id;
						delete item.id;
						var genId = this.getIdentity(item);
					}
					return response;
				});
			}
			args.query = this.getSaveQuery(item);
			return args;
		},
		getSaveQuery: function(/*item*/ item) {
			// overwrite this for custom logic
			var q = {
				uri: this.getIdentity(item)
			};
			if(this.resolver.isCreated(item)) {
				// merge updates
				q.mode = "merge";
			}
			return q;
		},
		getLabel: function(/* item */ item){
			return this.getValue(item, "title");
		},
		getLabelAttributes: function(/* item */ item){
			return ["title"];
		},
		
		getIdentity: function(/* item */ item){
			if(!item.id) {
				item.id = this.getValue(item, "id");
			}
			return item.id;
		},
		getIdentityAttributes: function(/* item */ item){
			return ["id"];
		},
		instantiateTemplate: function(template, args, parentInfo) {
			var xmlDoc = this.inherited(arguments);
			var nodes = this.engine.select("//atom:entry", xmlDoc);
			if(nodes && nodes.length > 0) {
				xmlDoc = nodes[0];
			}
			return xmlDoc;
		}
	}
);

}
