/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.ServiceDocument"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.ServiceDocument"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.ServiceDocument");

dojo.require("com.ibm.data.APPServiceDocument");
dojo.require("com.ibm.data.resolver.ResolverQueryRules");

dojo.declare("com.ibm.data.resolver.ServiceDocument",
	com.ibm.data.APPServiceDocument,
	{
		namespaces: com.ibm.data.resolver.ResolverQueryRules.namespaces,
		
		digest: "",
		
		constructor: function(args) {
			this._categoryNS = {};
		},
		
		getServiceCollections: function() {
			return this.acc.select("/app:service/app:workspace/service:collection", this.doc); //XmlNodeList
		},
		getServiceCollectionsByCategory: function(/*String*/ category) {
			return this.acc.select("/app:service/app:workspace/service:collection[" +
					"app:categories/atom:category[@term='" + category + "']]", this.doc); //XmlNodeList
		},
		getServiceCollectionsByTitle: function(/*String*/ title) {
			return this.acc.select("/app:service/app:workspace/service:collection[" +
					"atom:title[. = '" + title + "']]", this.doc); //XmlNodeList
		},
		
		getMultipartMixedCollection: function() {
			return this.acc.select("/app:service/app:workspace/service:collection[" +
					"app:categories/atom:category[@term='multipart'] and " +
					"app:accept = 'multipart/mixed']", this.doc); //XmlNodeList
		},
		
		getMultipartSitemapCollection: function() {
			return this.acc.select("/app:service/app:workspace/service:collection[" +
					"app:categories/atom:category[@term='multipart'] and " +
					"app:categories/atom:category[@term='sitemap']", this.doc); //XmlNodeList
		},
		
		getMultipartHuffmanCollection: function() {
			return this.acc.select("/app:service/app:workspace/service:collection[" +
					"app:categories/atom:category[@term='multipart'] and " +
					"app:categories/atom:category[@term='huffman']", this.doc); //XmlNodeList
		},
		
		getNamespaces: function(/*String*/ category) {
			if(!this._categoryNS[category]) {
				var nsMap = {}, 
					nsNodes = this.acc.select("/app:service/app:workspace/app:collection/" +
						"app:categories/atom:category[@term='" + category + "']", this.doc, true)
						.select("../atom:category[@scheme]"),
					nsKeys = nsNodes.attr("term"),
					nsUris = nsNodes.attr("scheme"),
					prefix = "enabler-ns-";
				dojo.forEach(nsKeys, function(key, index){
					var i = key.indexOf(prefix);
					if(i > -1) {
						key = key.substr(i + prefix.length);
					}
					nsMap[key] = nsUris[index];
				}, this);	
				
				this._categoryNS[category] = nsMap;
			}
			return this._categoryNS[category];
		},
		toString: function() {
			return "Resolver ServiceDocument {" + this.url + "}";
		}
	}
);

(function(){
	var dfds = {};
	com.ibm.data.resolver.ServiceDocument.retrieve = function(url, callback) {
		if(!dfds[url]) {
			dfds[url] = new dojo.Deferred();
			dojo.xhrGet({
				url: url,
				load: function(resp, ioArgs) {
					var loc = ioArgs.xhr.getResponseHeader("Content-Location"),
						digest = ioArgs.xhr.getResponseHeader("X-Request-Digest");
					
					dfds[url].callback(new com.ibm.data.resolver.ServiceDocument({
						doc: resp,
						contentLocation: loc,
						url: url.substr(0, url.indexOf("model/service")),
						digest: digest
					}));
				},
				error: function(err, ioArgs) {
					dfds[url].errback(err);
				},
				handleAs: "xml"
			});
		}
		dfds[url].addBoth(callback);
	}
})();

}
