/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.tree.ResolverTreePreloadingStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.tree.ResolverTreePreloadingStrategy"] = true;
dojo.provide("com.ibm.data.resolver.tree.ResolverTreePreloadingStrategy");

dojo.require("com.ibm.strategy.Strategy");

dojo.declare("com.ibm.data.resolver.tree.ResolverTreePreloadingStrategy",
	com.ibm.strategy.Strategy,
	{
		// summary: This strategy can be applied to widgets which mix in the com.ibm.widgets.TreeModeled
		//		module to provide tree-modeled data backed widget support.  This strategy is used
		//		to seed data from a preloaded TreeModeled widget back into the resolver store
		//		by assuming that the model backing the TreeModeled widget is an instance of a PocTreeModel.
		//		As with any strategy, it can be applied to a widget constructor module, effectively
		//		applying it to the prototype for all instances of that widget.
		
		// extensions: Array
		//		Array of strings indicating which functions in this strategy should be used
		//		to wrap functions of the same name in the object this strategy is applied to.
		//		Extensions cannot be named "strategyInit", "around", or "proceed", as these
		//		reserved words for strategy management.
		extensions: ["seedPreloadedData"],
		
		seedPreloadedData: function() {
			var me = this.getStrategyContext().instance;
			if(me.preloaded) {
        		var st = me.model.resolver;
        		me.item = this.propToItem(me.item, st);
				var children = dojo.mixin([], {loaded: true, preloaded: true});
				dojo.forEach(me.getChildren(), function(wij){
					wij.item = this.propToItem(wij.item, st, {parent: me.item});
					children.push(wij.item);
				}, this);
				
				st.setValues(me.item, "children", children);

				return true;
			}
			return false;
		},
		
		propToItem: function(prop, st, parentInfo) {
			if(dojo.isString(prop)) {
    			prop = dojo.fromJson(com.ibm.domUtilities.decodeXML(prop));
    		}
			if(!st.isItem(prop)) {
				prop = st.seedStore(prop, parentInfo);
			}
			return prop;
		}
	}
);

}
