/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.debug"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.debug"] = true;
dojo.provide( "com.ibm.portal.debug" );

//To satisfy dojo.require
//TODO: convert all ibm.portal.debug statements to com.ibm.portal.debug stmts
dojo.provide( "ibm.portal.debug" );

ibm.portal.debug.setTrace = function ( /*String*/functionName ) {
	ibm.portal.debug._traceString = functionName;
}

ibm.portal.debug._isDebugEnabled = function () {
	var retVal = false;
	
	if ( typeof ( ibmPortalConfig ) != "undefined" ) {
		if ( ibmPortalConfig && ibmPortalConfig.isDebug ) {
			retVal = true;
		}
	}
	
	return retVal;	
}

ibm.portal.debug.text = function( str, functionName ) {
	//First check that ibmPortalConfig is defined. Next check to see if the
	//isDebug flag is enabled. We don't want to actually print the statement
	//if we can avoid it since it can be expensive performance-wise. If a trace
	//string is defined, we only want to print debug statements that match that trace string.
	//otherwise, we print everything. This way the debug output can be filtered down. The 
	//one caveat is that not all functions specify a function name.
	if ( typeof ( ibmPortalConfig ) != "undefined" ) {
		if ( ibmPortalConfig && ibmPortalConfig.isDebug ) {
			var traceStr = ibm.portal.debug._traceString;
			if ( traceStr ) {
				if ( functionName ) {
					if ( functionName.indexOf( traceStr ) >= 0 ) {
						window.console.log(str);
					}
				}
			}
			else {
				window.console.log(str);
			}		
		}
	}	
} 

ibm.portal.debug.entry = function ( functionName, args ) {
	if ( ibm.portal.debug._isDebugEnabled() ) {
	
		var debugStr = functionName + " --> entry; { ";
		
		if ( args && args.length > 0 )
		{
			for ( arg in args ) {
				debugStr = debugStr + args[arg] + " ";
			}
		} 
		
		debugStr = debugStr + " } ";
		
		ibm.portal.debug.text( debugStr, functionName );
	}	
}

ibm.portal.debug.exit = function( functionName, retValue ) {
	if ( ibm.portal.debug._isDebugEnabled() ) {
		var debugStr = functionName + " --> exit;"
		if ( typeof( retValue ) != "undefined" )
		{
			debugStr = debugStr +" { " + retValue + " } ";
		}		
		ibm.portal.debug.text( debugStr, functionName );
	}			
}

ibm.portal.debug.escapeXmlForHTMLDisplay = function( string ) {
	string = string.replace( /</g, "&lt;" );
	string = string.replace( />/g, "&gt;" );
	
	return string;
}

}
