/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.services.NavigationModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.services.NavigationModel"] = true;
dojo.provide( "com.ibm.portal.services.NavigationModel" );

dojo.require( "dojo.dnd.common" );

dojo.require( "com.ibm.portal.services.PortalRestServiceRequest" );
dojo.require( "com.ibm.portal.xslt" );


dojo.declare( "com.ibm.portal.services.NavigationNode",
			  null,
			  {
			  	constructor: function ( /*HTMLDivElement*/ div, /*String*/nmPrefix ) {
					if ( !div ) { return null; }
					
					this._nmPrefix = nmPrefix;
					this.URI = div.getAttribute( "id" ).substring( nmPrefix.length );
					this.hasChildren = ( div.getAttribute( 'hasChildren' ) == "true" );
					this.isLabel = ( div.getAttribute( 'contentNodeType' ) == 'LABEL' );
					this.isExternalURL = ( div.getAttribute( 'contentNodeType' ) == 'EXTERNAL-URL' );
					this.isInternalURL = ( div.getAttribute( 'contentNodeType' ) == 'INTERNAL-URL' );
					this.isStaticPage = ( div.getAttribute( 'contentNodeType' ) == 'STATIC-PAGE' );
					this.title = div.getAttribute( 'localizedTitle' );
								
					if ( div.getAttribute( "lmURI" ) ) {
						this.layoutModel = div.getAttribute( "lmURI" );
					}
					
					if ( div.getAttribute( "cmURI" ) ) {
						this.contentModel = div.getAttribute( "cmURI" );
					}
					
					if ( div.getAttribute( "childrenURI" ) ) {
						this.childrenURI = div.getAttribute( 'childrenURI' );
					}
					
					if ( div.getAttribute( "navLevel" ) ) {
						this.navigationLevel = div.getAttribute( "navLevel" );
					}
					
					if ( div.getAttribute( "childOf" ) ) {
						this.childOf = div.getAttribute( "childOf" );
					}
					
					if ( div.getAttribute( "theme" ) ) {
						this.theme = div.getAttribute( "theme" );
					}
					
					if ( div.getAttribute( "themePolicy" ) ) {
						this.themePolicy = div.getAttribute( "themePolicy" ); 
					}
					
					if ( div.getAttribute( "applicationGuid" ) ) {
						this.applicationGuid = div.getAttribute( "applicationGuid" );
					}
					
					this._children = null;
			    },
			  	_deserialize: function () {
					var div = document.createElement( "DIV" );
					div.setAttribute( "id" , this._nmPrefix + this.URI );
					div.setAttribute( "hasChildren", this.hasChildren.toString() );
					div.setAttribute( "localizedTitle", this.title );
					
					if ( this.isLabel ) { div.setAttribute( "contentNodeType", "LABEL" ); }
					if ( this.isExternalURL ) { div.setAttribute( "contentNodeType", "EXTERNAL-URL" ); }
					if ( this.isInternalURL ) { div.setAttribute( "contentNodeType", "INTERNAL-URL" ); }
					if ( this.isStaticPage ) { div.setAttribute( "contentNodeType", "STATIC-PAGE" ); }
					if ( !this.isLabel && !this.isExternalURL && !this.isInternalURL && !this.isStaticPage ) { div.setAttribute( "contentNodeType", "COMPOSITION" ); }
					
					if ( this.layoutModel ) { div.setAttribute( "lmURI", this.layoutModel ); }
					if ( this.contentModel ) { div.setAttribute( "cmURI", this.contentModel ); }
					if ( this.childrenURI ) { div.setAttribute( "childrenURI", this.childrenURI ); }
					if ( this.navigationLevel ) { div.setAttribute( "navLevel", this.navigationLevel ); }
					if ( this.childOf ) { div.setAttribute( "childOf", this.childOf ); }
					if ( this.theme ) { div.setAttribute( "theme", this.theme ); }
					if ( this.themePolicy ) { div.setAttribute( "themePolicy", this.themePolicy ); }
					if ( this.applicationGuid ) { div.setAttribute( "applicationGuid", this.applicationGuid ); }
					
					return div;
				},
				getLayoutModel: function ( /*Function*/callbackFn, /*Array?*/fnArguments ) {
					// summary: Retrieve the layout model feed for this navigation node.
					// description: Retrieves the layout model feed for this navigation node
					//		asynchronously. The provided callback function will be called
					//		with the 3 standard dojo.io.bind arguments as well as any of the
					//		fnArguments passed in to this function.
					// callbackFn: the function to call when the layout model is loaded
					// fnArguments: any arguments to pass through to the callback function
					ibm.portal.debug.entry( "NavigationNode.getLayoutModel", [ callbackFn, fnArguments ] );
					var url = new com.ibm.portal.services.ContentHandlerURL( this.layoutModel, null, null, "&mdname=WIDTH" );
					var serviceReq = new com.ibm.portal.services.PortalRestServiceRequest( url );
					serviceReq.read( callbackFn, fnArguments );
					ibm.portal.debug.exit( "NavigationNode.getLayoutModel" );
				},
				getChildren: function ( /*Function?*/callbackFn ) {
					// summary: Retrieve the children of this node.
					// callbackFn: the function to call when the retrieval process is finished. if
					//		null, the retrieval is done synchronously
					// returns: Array of the children nodes or NULL if callbackFn not specified
					ibm.portal.debug.entry( "NavigationNode.getChildren", [ callbackFn ]);
					if ( this._children != null ) {
						return this._children;
					}
					ibm.portal.debug.text( "Children have not been previously requested." );
					this._children = new Array();
					var div = dojo.byId( this._nmPrefix + this.URI );
					
					ibm.portal.debug.text( "Found associated div element: " + div );
					
					//Unless the _children array is populated, we can't guarantee all the child nodes have been
					//populated. One or more nodes may have been loaded by the NavigationSelectionModel creation as
					//part of a "-all" request. Checking if the div has children nodes is not sufficient before 
					//sending this request. We may end up with some duplication as a result, but this is, unfortunately,
					//the only way to guarantee all of the children have been loaded.
					ibm.portal.debug.text( "Fetching children nodes: " + this.childrenURI );
					com.ibm.portal.services.NAVIGATION_MODEL.getNode( this.childrenURI );
					
					div = dojo.byId( this._nmPrefix + this.URI );
					ibm.portal.debug.text( "Div now has " + div.childNodes.length + " elements. " );
					
					for ( var i = 0; i < div.childNodes.length; i++ ) {
						ibm.portal.debug.text( "Adding child node: " + div.childNodes[i] );
						this._children.push( new com.ibm.portal.services.NavigationNode( div.childNodes[i], this._nmPrefix ) )	
					}
					
					ibm.portal.debug.exit( "NavigationNode.getChildren", [ this._children ] );
					
					return this._children;	
				},
				removeChild: function ( /*String*/ childId ) {
					// summary: Removes a child of this navigation node.
					// childId: The id of the child to remove
					ibm.portal.debug.entry( "NavigationNode.removeChild", [ childId ]);
					if( this._children ) {
						for(var i = 0; i < this._children.length; i++) {
							if(childId == this._children[i].URI) {
								this._children.splice(i, 1);
								break;
							}
						}
					}
					var thisNodeElem = dojo.byId(this._nmPrefix + this.URI);
					if(thisNodeElem) {
						var childNodeElem = dojo.byId(this._nmPrefix + childId);
						if(childNodeElem && childNodeElem.parentNode == thisNodeElem) {
							thisNodeElem.removeChild(childNodeElem);
							delete childNodeElem;
						}
					}
					
					ibm.portal.debug.exit( "NavigationNode.removeChild", [ childId ]);
				},
				getContentURL: function() {
					// summary: Retrieve the external URL associated with this NavigationNode if it's node type is EXTERNAL-URL.
					// description: Retrieves the external URL associated with this NavigationNode. If the node type is not EXTERNAL-URL,
					//		then return null. If a callback is provided, then the function is called with the url string as it's lone parameter. If
					//		no callback is provided, the function is executed synchronously, otherwise it is asynchronous.
					// callbackfn: *OPTIONAL* callback function when the url is retrieved, takes the url string as the only parameter
					ibm.portal.debug.entry( "NavigationNode.getExternalURL" );
					ibm.portal.debug.exit( "NavigationNode.getExternalURL", [ this.contentModel ] );
					return this.contentModel;
				}
			  }
);

dojo.declare( "com.ibm.portal.services.NavigationModel",
			  null,
			  {
			  	constructor: function () {
					this._containerCreated = false;
					this._nodeContainer = "";  
					this._xsltURL = dojo.moduleUrl( "com", "ibm/portal/services/");
					this._uniqueNamesMap = {};
				},
			  	_createRootDiv: function () {
					//create the container div for all of model information		  
				  	var div = document.createElement( "DIV" );
					div.style.display = "none";
					div.setAttribute( "id", dojo.dnd.getUniqueId() ); 
					dojo.body().appendChild( div );
					this._nodeContainer = div.getAttribute( "id" );
					this._containerCreated = true;	
				},
				_newContentHandlerURL: function ( /*String*/uri, /*int or String*/levels ) {
					return new com.ibm.portal.services.ContentHandlerURL( uri, levels, "download", "&mdname=RenderMode&mdname=com.ibm.portal.ThemePolicy&mdname=com.ibm.portal.applicationGuid" );
				},
				namespaces: {
		            "xsl" : "http://www.w3.org/1999/XSL/Transform",
		            "thr" : "http://purl.org/syndication/thread/1.0",
		            "atom" : "http://www.w3.org/2005/Atom",
		            "xhtml" : "http://www.w3.org/1999/xhtml",
		            "model" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements",
		            "base" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0/ibm-portal-composite-base",
		            "portal" : "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model",
		            "xsi" : "http://www.w3.org/2001/XMLSchema-instance"
		        },
		        getCompleteAncestorPath: function ( /*String*/uri ) {
		        	// summary: Retrieve all ancestor nodes including the given uri.
		        	// description: Retrieves the given node and all the parent nodes
		        	//		associated with that node.
		        	// uri: the unique identifier of the node
					ibm.portal.debug.entry( "NavigationModel.getCompleteAncestorPath", [ uri ] );
					
					if ( !this._containerCreated ) {
						this._createRootDiv();
					}
					
					var node = this._getCachedNode( uri );
		        	var returnArray = new Array(), done = false;
					
					if ( node == null ) {
						//Retrieve the parent node up to the content root and merge it into our local cache
		        				var url = this._newContentHandlerURL( uri, "-all" );
					        	var serviceReq = new com.ibm.portal.services.PortalRestServiceRequest( url, null, false, true );
								var me = this;
								
								serviceReq.read( 
									function ( type, data, xhr, args ) {
										
										var results = me._doSelModelTransform( data, uri );
										var tempNode = document.createElement('div');
										tempNode.innerHTML = results;
										var reversePath = new Array();
										var currentNode = tempNode.firstChild.firstChild;
										var containerDiv = dojo.byId( me._nodeContainer );
										while ( currentNode ) {
											//reversePath.push( new com.ibm.portal.services.NavigationNode( currentNode, me._nodeContainer ) );
											var newDiv = new com.ibm.portal.services.NavigationNode( currentNode, me._nodeContainer )._deserialize();
											containerDiv.appendChild( newDiv );
											containerDiv = newDiv;
											currentNode = currentNode.childNodes[0];
										}
									}
								);
					}
					
					node = this._getCachedNode( uri );
		        	
		        	while ( node != null && !done ) {
		        		returnArray.push( node );
		        		if ( node.childOf ) {
		        			//Check to see if we have retrieved the parent node.
		        			var nextNode = this._getCachedNode( node.childOf );
		        			if ( nextNode != null ) {
		        				node = nextNode;
		        			}
		        			else {
		        				//Retrieve the parent node up to the content root and merge it into our local cache
		        				var url = this._newContentHandlerURL( node.childOf, "-all" );
					        	var serviceReq = new com.ibm.portal.services.PortalRestServiceRequest( url, null, false, true );
								var me = this;
								
								serviceReq.read( 
									function ( type, data, xhr, args ) {
										var results = me._doSelModelTransform( data, node.childOf );
										var reversePath = new Array();
										var tempNode = document.createElement('div');
										tempNode.innerHTML = results;
										var currentNode = tempNode.firstChild.firstChild;
										while ( currentNode ) {
											reversePath.push( new com.ibm.portal.services.NavigationNode( currentNode, me._nodeContainer ) );
											currentNode = currentNode.childNodes[0];
										}
										
										var prevNode = node.childOf;
										for ( var i = (reversePath.length - 1); i >= 0; i-- ) {
											var containerDiv = dojo.byId( me._nodeContainer );
											var newDiv = reversePath[ i ];
											
											var placeHolderID = "placeholder_" + me._nodeContainer + prevNode;
											var placeHolderDiv = dojo.byId( placeHolderID );
											
											if ( placeHolderDiv ) {
												containerDiv.appendChild( newDiv._deserialize() );
												var div1 = dojo.byId( me._nodeContainer + prevNode );
												div1.innerHTML = placeHolderDiv.innerHTML;										
												//dojo.dom.removeNode( placeHolderDiv );
												placeHolderDiv.parentNode.removeChild(placeHolderDiv);
											}
											else {
												var prevNodeID = me._nodeContainer + prevNode;
												var prevNodeDiv = dojo.byId( prevNodeID );
												if ( prevNodeDiv ) {
													var div = newDiv._deserialize();
													div.innerHTML = prevNodeDiv.parentNode.innerHTML;
													containerDiv.appendChild( div );
													
													//dojo.dom.removeNode( prevNodeDiv );
													prevNodeDiv.parentNode.removeChild(prevNodeDiv);
												}
											}	
										
										}
									}
								);
								
								node = this._getCachedNode( node.childOf );;
		        			}
		        		}else {
		        			done = true;
		        		}
		        				
		        	}
		        	
					returnArray = returnArray.reverse();
		        	
		        	ibm.portal.debug.exit( "NavigationModel.getCompleteAncestorPath",[returnArray] );
		        	return returnArray;
		        },
			  _doSelModelTransform: function ( /*XMLDocument*/xml, /*String*/rootNode ) {
					ibm.portal.debug.entry( "NavigationModel._doSelModelTransform");
                        var trf = com.ibm.portal.xslt.TRANSFORMER_FACTORY.newTransformer( this._xsltURL + "NavigationSelectionModel.xsl" );
                        if (trf == null) {
                            ibm.portal.debug.text("XSL transformer is null");
                        }
					var results = trf.transformToDocument( xml, {"nmPrefix":this._nodeContainer,"rootNode":rootNode}, true );
		        	this._doUniqueNamesMapping( xml );
					ibm.portal.debug.exit( "NavigationModel._doSelModelTransform", results );
		        	return results;
		        },
		        _doUniqueNamesMapping: function( /*XMLDocument*/xml ) {
                        var trf = com.ibm.portal.xslt.TRANSFORMER_FACTORY.newTransformer( this._xsltURL + "NMUniqueNamesMapping.xsl" );
                        if (trf == null) {
                            ibm.portal.debug.text("XSL transformer is null");
                        }
                        var results = trf.transformToDocument( xml, {}, true );
                        var array = eval( results );
                        for (var i = 0; i < array.length; i++ ) {
                            this._uniqueNamesMap[array[i].uniqueName] = array[i].objectID;
                        }	
		        },
		        _getCachedNode: function ( /*String*/ uri ) {
		        	// summary: Retrieves the requested node from the "cached" location, if it exists there.
		        	// uri: the node to lookup
		        	// returns: the requested node or NULL if not found in the "cache"
		        	ibm.portal.debug.entry( "NavigationModel._getCachedNode", [ uri ] );
		        	
		        	var retVal = null;
		        	retVal = dojo.byId( this._nodeContainer + uri ); 
		        	
		        	//try by unique name
		        	if ( retVal == null ) {
		        		var uniqueName = uri;
		        		if ( uri.indexOf("cm:oid:") == 0 ) {
		        			uniqueName = uri.substring(7);
		        			uniqueName = uniqueName.replace( /%252520/g, ' ' );
		        		} 
		        		retVal = dojo.byId( this._nodeContainer + this._uniqueNamesMap[ uniqueName ] );
		        	}
		        	
		        	if ( retVal != null ) {
		        		retVal = new com.ibm.portal.services.NavigationNode( retVal, this._nodeContainer );
		        	}
		        	
		        	ibm.portal.debug.exit( "NavigationModel._getCachedNode", [ retVal ] );
		        	return retVal; //com.ibm.portal.services.NavigationNode
		        },
		        _getObjectIDFromUniqueName: function ( /*XMLDocument*/ xmlDoc, /*String*/requestedURI ) {
		        	ibm.portal.debug.entry( "_getObjectIDFromUniqueName", [ xmlDoc, requestedURI ] );
		        	
		        	requestedURI = requestedURI.substring(7);
		        	//requestedURI = requestedURI.replace( /%252520/g, ' ' );
		        	var atomIdXPath = "/atom:feed/atom:entry/atom:id[@portal:uniquename='"+requestedURI+"']";
					var nodes = com.ibm.portal.xpath.evaluateXPath( atomIdXPath, xmlDoc, this.namespaces );
					var result = null;
					
					if ( nodes != null && nodes.length > 0 ) {
						result = dojox.data.dom.textContent( nodes[0] );
					}
					
					ibm.portal.debug.exit( "_getObjectIDFromUniqueName", [ result ] );
					
					return result;
		        },
				getNode: function ( /*String*/ uri, /*Boolean?*/async, /*Function?*/ callbackfn ) {
					// summary: Retrieves the NavigationNode associated with
					//		the given uri.
					// description: Looks in memory for the requested NavigationNode. If
					//		it has not been loaded yet, uses a synchronous request to load
					//		the requested uri and it's children (if they exist). Returns
					//		null if the requested node cannot be found.
					// uri: the unique identifier of the node
					// async: indicates whether retrieving the node should be a blocking operation
					//		the default value is false
					// callbackfn: function to call when node is loaded - only valid if "async" is 
					//		true 
					// returns: NavigationNode or null if not found
					ibm.portal.debug.entry( "NavigationModel.getNode", [ uri, async, callbackfn ] );
					
					if ( !this._containerCreated ) {
						this._createRootDiv();
					}
					
					var retVal = this._getCachedNode( uri );
					
					ibm.portal.debug.text( "result of dom lookup: " + retVal );
										
					if ( !retVal ) {
						if ( !( uri.indexOf("cm:oid:") == 0 ) && !( uri.indexOf( "?uri=" ) == 0  )) {
							uri = "cm:oid:" + uri;
						}
					
						//not loaded yet, load from the REST service
						var url = this._newContentHandlerURL( uri, 2 );
						var serviceReq = new com.ibm.portal.services.PortalRestServiceRequest( url, null, false, true );
						var me = this;
						serviceReq.read( 
							function ( type, data, xhr, args ) {
								ibm.portal.debug.entry( "NavigationModel.onNodeLoad", [type, data, xhr ] );
								
								var url = new com.ibm.portal.services.ContentHandlerURL( args[ "requestedURI" ] );
								var requestedURI = me._getObjectIDFromUniqueName( data, url.getURI() );
								var isUniqueName = true;
								if ( requestedURI == null ) { requestedURI = url.getURI(); isUniqueName = false; } else { uri = requestedURI }
								var results = me._doXSLTransformation( data, requestedURI, isUniqueName );
								ibm.portal.debug.text( "xslt result: " + dojox.data.dom.innerXML( results ) );
								
								//var requestedNodeDiv = dojo.byId( me._nodeContainer + url.getURI(), results );
								var requestedNodeDiv = me._getElementToAdd( me._nodeContainer + requestedURI, results );
								var requestedNode = new com.ibm.portal.services.NavigationNode( requestedNodeDiv, me._nodeContainer );
								
								ibm.portal.debug.text( "found requested node in results: " + requestedNode.URI );
								
								var nodeToUpdate = me._getNodeToUpdate( requestedNode );
								
								//If the requested node already exists in our node container, we want to replace it with our new retrieval.
								var requestedNodeInContainer = dojo.byId( me._nodeContainer + url.getURI() );
								ibm.portal.debug.text( "The requested node is already in the container? " + requestedNodeInContainer );
								
								if ( requestedNodeInContainer ) {
									//dojox.data.dom.replaceNode( requestedNodeInContainer, requestedNodeDiv );
									requestedNodeInContainer.parentNode.replaceChild(requestedNodeDiv,requestedNodeInContainer);
								} 
								else {
									ibm.portal.debug.text( "Appending the new div to our container." );
									//nodeToUpdate.appendChild( requestedNodeDiv );
									nodeToUpdate.appendChild( requestedNodeDiv );	
								}
								//If a placeholder node exists for the requested node, we must copy the placeholder children
								//over to our new requested node
								var placeholder = dojo.byId( "placeholder_" + me._nodeContainer + requestedNode.URI );
								
								ibm.portal.debug.text( "Found placeholder div: " + placeholder );
								
								if ( placeholder ) {
									//Need to replace all existing nodes with the matching nodes copied over
									//from the placeholder node. This is because if a placeholder exists, we
									//have already retrieved some portion of the navigation tree.
									var array = placeholder.childNodes;
									for ( var i = 0; i < array.length; i++ ) {
										var node = array[i].parentNode.removeChild(array[i]);
										var existingNode = dojo.byId( node.getAttribute( "id" ) );
										//dojo.dom.replaceNode( existingNode, node ); 
										existingNode.parentNode.replaceChild(node, existingNode);
									}
									//dojo.dom.removeNode( placeholder );	
									placeholder.parentNode.removeChild(placeholder);
								}
																
								if ( callbackfn ) {
									callbackfn();
								}
								
								ibm.portal.debug.exit( "NavigationModel.onNodeLoad" );
							},
							{ "requestedURI": uri }
						);
					}
					
					//If this is an asynchronous call, don't wait around for the return value.
					if ( async ) {
						ibm.portal.debug.exit( "NavigationModel.getNode" );
						return;
					}
					
					//Try again, now that we've attempted to retrieve the node.
					retVal = this._getCachedNode( uri );
					
					ibm.portal.debug.exit( "NavigationModel.getNode", [ retVal ]);
					
					return retVal; //com.ibm.portal.services.NavigationNode
				},
				_doXSLTransformation: function ( /*XMLDocument*/xmlDoc, /*String*/requestedURI, /*boolean*/isUniqueName ) {
					ibm.portal.debug.entry( "NavigationModel._doXSLTransformation", [ xmlDoc, requestedURI, isUniqueName ] );
					var trf = com.ibm.portal.xslt.TRANSFORMER_FACTORY.newTransformer( this._xsltURL + "NavigationModel.xsl" );
					if (trf == null) {
						ibm.portal.debug.text("XSL transformer is null");
					}
					
					var tempNode = document.createElement('div');
					var xsltParams = {"nmPrefix":this._nodeContainer,"rootNode":requestedURI};
					// determine if we retrieved by unique name or by object id.
					if( isUniqueName ) {
						xsltParams["byUniqueName"] = "true";
					}
					
					trf.transformToRegion( xmlDoc, xsltParams, tempNode, document );
					
					var results = this._convertTransformedDoc( tempNode.firstChild );
					this._doUniqueNamesMapping( xmlDoc );
					ibm.portal.debug.exit( "NavigationModel._doXSLTransformation", [ results ] );
					return results;
				},
				_convertTransformedDoc: function ( /*HTMLElement*/root ) {
					var rootDiv = document.createElement( "div" );
					ibm.portal.debug.text("created root div");
					this._populateNewDoc( root, rootDiv );
					ibm.portal.debug.text( dojox.data.dom.innerXML( rootDiv ) );					
					return rootDiv;	
				},
				_populateNewDoc: function ( /*Element*/root, /*Node*/parentNode ) {
					for ( var i = 0; i < root.childNodes.length; i++ ) {
						var div = document.createElement( "div" );
						ibm.portal.debug.text( "creating div for " + root.childNodes[i].getAttribute("id") );
						div.setAttribute( "id", root.childNodes[i].getAttribute("id") );
						ibm.portal.debug.text( "set id attribute: " + div.getAttribute("id") );
						div.setAttribute( "hasChildren", root.childNodes[i].getAttribute("hasChildren"));
						ibm.portal.debug.text( "set hasChildren attribute: " + div.getAttribute("hasChildren") );
						div.setAttribute( "contentNodeType", root.childNodes[i].getAttribute("contentNodeType"));
						ibm.portal.debug.text( "set nodeType attribute: " + div.getAttribute("contentNodeType") );
						div.setAttribute( "localizedTitle", root.childNodes[i].getAttribute( "localizedTitle" ) );
						if ( root.childNodes[i].getAttribute( "lmURI" ) ) {
							div.setAttribute( "lmURI", root.childNodes[i].getAttribute("lmURI") );
						}
						
						if ( root.childNodes[i].getAttribute( "cmURI" ) ) {
							div.setAttribute( "cmURI", root.childNodes[i].getAttribute( "cmURI" ) );
						}
						
						if ( root.childNodes[i].getAttribute( "childrenURI" ) ) {
							div.setAttribute( "childrenURI", root.childNodes[i].getAttribute("childrenURI") );
						}
						
						if ( root.childNodes[i].getAttribute( "navLevel" ) ) {
							div.setAttribute( "navLevel", root.childNodes[i].getAttribute("navLevel") );
						}
						
						if ( root.childNodes[i].getAttribute( "childOf" ) ) {
							div.setAttribute( "childOf", root.childNodes[i].getAttribute("childOf") );
						}
						if ( root.childNodes[i].getAttribute( "theme" ) ) {
							div.setAttribute( "theme", root.childNodes[i].getAttribute("theme") );
						}
						if ( root.childNodes[i].getAttribute( "themePolicy" ) ) {
							div.setAttribute( "themePolicy", root.childNodes[i].getAttribute("themePolicy") );
						}
						if ( root.childNodes[i].getAttribute( "applicationGuid" ) ) {
							div.setAttribute( "applicationGuid", root.childNodes[i].getAttribute("applicationGuid") );
						}
						parentNode.appendChild( div );
						this._populateNewDoc( root.childNodes[i], div );
					}	
				},
				_getNodeToUpdate: function ( /*NavigationNode*/requestedNode ) {
					ibm.portal.debug.entry( "NavigationModel._getNodeToUpdate", [requestedNode] );
					var nodeToUpdate = dojo.byId( this._nodeContainer );
					
					var parentNode = dojo.byId( this._nodeContainer + requestedNode.childOf );
								
					//If so, we update the parent node.
					if ( parentNode ) {
						ibm.portal.debug.text( "found parent node: " + parentNode.id );
						nodeToUpdate = parentNode;
					}
					else {
						//If a placeholder exists for the parent node, we copy the children there.
						var placeHolderID = "placeholder_" + this._nodeContainer + requestedNode.childOf;
						var parentPlaceholder = dojo.byId( placeHolderID );
						if ( parentPlaceholder ) {
							ibm.portal.debug.text( "parent placeholder found: " + parentPlaceholder );
							nodeToUpdate = parentPlaceholder;
						}
						else if ( requestedNode.childOf ){
							var div = document.createElement( "DIV" );
							div.setAttribute( "id", placeHolderID);
							div.style.display = "none";
							dojo.byId( this._nodeContainer ).appendChild( div );
							nodeToUpdate = div;
						}
					}
					ibm.portal.debug.exit( "NavigationModel._getNodeToUpdate", [nodeToUpdate.getAttribute("id")] );
					return nodeToUpdate;
				},
				_getElementToAdd: function ( /*String*/id, /*XMLDocument*/doc ) {
					ibm.portal.debug.entry( "NavigationModel._getElementToAdd", [id, doc] );
					var retVal = null;
					
					//Note: Since moving to the dojo xslt impl, the dojo.byId query doesn't seem to work anymore
					//if ( dojo.isIE ) {
						var divs = doc.getElementsByTagName( "div" );
						var found = false, i = 0;
						
						while ( i < divs.length && !found ) {
							ibm.portal.debug.text( "Examining div: " + divs[i] + " with id: " + divs[i].getAttribute("id") );
							found = ( id == divs[i].getAttribute( "id" ) );
							i++;	
						}
						
						if ( found ) {
							retVal = divs[i - 1]; //i was incremented once after we found our div
						}		
					/*}
					else {
						retVal = dojo.byId( id, doc );
					}*/
					
					ibm.portal.debug.exit( "NavigationModel._getElementToAdd", [ retVal ] );
					return retVal;
				}	
			  }  
);

//Static helper variable
com.ibm.portal.services.NAVIGATION_MODEL = new com.ibm.portal.services.NavigationModel();

}
