/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.strategy.PageMovedNotificationStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.strategy.PageMovedNotificationStrategy"] = true;
dojo.provide("com.ibm.strategy.PageMovedNotificationStrategy");

dojo.require("com.ibm.strategy.Strategy");

dojo.declare("com.ibm.strategy.PageMovedNotificationStrategy",
	com.ibm.strategy.Strategy,
	{
		// extensions: Array
		//		Array of strings indicating which functions in this strategy should be used
		//		to wrap functions of the same name in the object this strategy is applied to.
		//		Extensions cannot be named "strategyInit", "around", or "proceed", as these
		//		reserved words for strategy management.
		// 		This extension is set in the enhancedPageContextMenu.jsp file in the theme,
		//		it is set for the com.ibm.mm.builder.utils.navigationUtil object.
		extensions: ["reorderPageNode"],
		
		constructor: function(callback) {
			if(callback) this.callback = callback;
		},
		
		reorderPageNode: function() {
			var me = this,
				instance = this.getStrategyContext().instance,
				navigationModel =  com.ibm.mm.builder.utils.navigationUtil.getNavigationModel(),
				oldCommit = navigationModel.commit;	
			
			navigationModel.commit = function() {
				var dfd = oldCommit.apply(this, arguments);
				dfd.setOperationCallback(function(newNode){
					me.callback(newNode);
				});
				return dfd;				
			}
			
			var ret = this.proceed(arguments);
			navigationModel.commit = oldCommit;
			return ret;
		},
		
		callback: function(newNode) {
			// summary: Function which is called at the end of the Deferred processing which
			// 		fires its operation callback when the share operation completes either
			// 		successfully or unsuccessfully.
		}
	}
);

}
